/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],S=0,k=K.length;S<k;S++)e[S]=Z[K[S]];return e};define(Z[84],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=S}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function k(R){const g=[];for(let y in R)S.call(R,y)&&g.push(R[y]);return g}e.values=k;function A(R,g){for(let y in R)if(S.call(R,y)&&g({key:y,value:R[y]},function(){delete R[y]})===!1)return}e.forEach=A;function L(R,g){const y=Object.create(null);for(const b of R){const c=g(b);let p=y[c];p||(p=y[c]=[]),p.push(b)}return y}e.groupBy=L;function U(R){const g=Object.create(null);return R&&R.forEach((y,b)=>{g[b]=y}),g}e.fromMap=U;function O(R,g){const y=[],b=[];for(let c of R)g.has(c)||y.push(c);for(let c of g)R.has(c)||b.push(c);return{removed:y,added:b}}e.diffSets=O;function m(R,g){const y=[],b=[];for(let[c,p]of R)g.has(c)||y.push(p);for(let[c,p]of g)R.has(c)||b.push(p);return{removed:y,added:b}}e.diffMaps=m;class v{constructor(){this.map=new Map}add(g,y){let b=this.map.get(g);b||(b=new Set,this.map.set(g,b)),b.add(y)}delete(g,y){const b=this.map.get(g);!b||(b.delete(y),b.size===0&&this.map.delete(g))}forEach(g,y){const b=this.map.get(g);!b||b.forEach(y)}}e.SetMap=v}),define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function S(m){return(v,R,g)=>{let y=null,b=null;if(typeof g.value=="function"?(y="value",b=g.value):typeof g.get=="function"&&(y="get",b=g.get),!b)throw new Error("not supported");g[y]=m(b,R)}}e.createDecorator=S;let k=0;function A(){const m=`$memoize${k++}`;let v;const R=function(y,b,c){let p=null,w=null;if(typeof c.value=="function"?(p="value",w=c.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(p="get",w=c.get),!w)throw new Error("not supported");const C=`${m}:${b}`;c[p]=function(...D){return v=this,this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!0,enumerable:!1,writable:!0,value:w.apply(this,D)}),this[C]}};return R.clear=()=>{typeof v!="undefined"&&Object.getOwnPropertyNames(v).forEach(g=>{g.indexOf(m)===0&&delete v[g]})},R}e.createMemoizer=A;function L(m,v,R){return A()(m,v,R)}e.memoize=L;function U(m,v,R){return S((g,y)=>{const b=`$debounce$${y}`,c=`$debounce$result$${y}`;return function(...p){this[c]||(this[c]=R?R():void 0),clearTimeout(this[b]),v&&(this[c]=v(this[c],...p),p=[this[c]]),this[b]=setTimeout(()=>{g.apply(this,p),this[c]=R?R():void 0},m)}})}e.debounce=U;function O(m,v,R){return S((g,y)=>{const b=`$throttle$timer$${y}`,c=`$throttle$result$${y}`,p=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...C){if(this[c]||(this[c]=R?R():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),v&&(this[c]=v(this[c],...C)),!this[w]){const D=this[p]+m;D<=Date.now()?(this[p]=Date.now(),g.apply(this,[this[c]]),this[c]=R?R():void 0):(this[w]=!0,this[b]=setTimeout(()=>{this[w]=!1,this[p]=Date.now(),g.apply(this,[this[c]]),this[c]=R?R():void 0},D-Date.now()))}}})}e.throttle=O}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function k(r){e.errorHandler.setUnexpectedErrorHandler(r)}e.setUnexpectedErrorHandler=k;function A(r){m(r)||e.errorHandler.onUnexpectedError(r)}e.onUnexpectedError=A;function L(r){m(r)||e.errorHandler.onUnexpectedExternalError(r)}e.onUnexpectedExternalError=L;function U(r){if(r instanceof Error){let{name:t,message:i}=r;const n=r.stacktrace||r.stack;return{$isError:!0,name:t,message:i,stack:n}}return r}e.transformErrorForSerialization=U;const O="Canceled";function m(r){return r instanceof Error&&r.name===O&&r.message===O}e.isPromiseCanceledError=m;class v extends Error{constructor(){super(O);this.name=this.message}}e.CancellationError=v;function R(){const r=new Error(O);return r.name=r.message,r}e.canceled=R;function g(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}e.illegalArgument=g;function y(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}e.illegalState=y;function b(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function c(r){const t=new Error(`${r} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function p(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}e.getErrorMessage=p;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class C extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=C;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function f(r){const t=r;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function s(r,t=Object.create(null)){const i=new Error(r);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=s}),define(Z[18],ee([0,1,11]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(q,H=0){return q[q.length-(1+H)]}e.tail=k;function A(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=A;function L(q,H,z=(I,T)=>I===T){if(q===H)return!0;if(!q||!H||q.length!==H.length)return!1;for(let I=0,T=q.length;I<T;I++)if(!z(q[I],H[I]))return!1;return!0}e.equals=L;function U(q,H,z){let I=0,T=q.length-1;for(;I<=T;){const F=(I+T)/2|0,N=z(q[F],H);if(N<0)I=F+1;else if(N>0)T=F-1;else return F}return-(I+1)}e.binarySearch=U;function O(q,H){let z=0,I=q.length;if(I===0)return 0;for(;z<I;){const T=Math.floor((z+I)/2);H(q[T])?I=T:z=T+1}return z}e.findFirstInSorted=O;function m(q,H,z){if(q=q|0,q>=H.length)throw new TypeError("invalid index");let I=H[Math.floor(H.length*Math.random())],T=[],F=[],N=[];for(let x of H){const G=z(x,I);G<0?T.push(x):G>0?F.push(x):N.push(x)}return q<T.length?m(q,T,z):q<T.length+N.length?N[0]:m(q-(T.length+N.length),F,z)}e.quickSelect=m;function v(q,H){const z=[];let I;for(const T of q.slice(0).sort(H))!I||H(I[0],T)!==0?(I=[T],z.push(I)):I.push(T);return z}e.groupBy=v;function R(q,H,z){const I=[];function T(x,G,J){if(!(G===0&&J.length===0)){const Q=I[I.length-1];Q&&Q.start+Q.deleteCount===x?(Q.deleteCount+=G,Q.toInsert.push(...J)):I.push({start:x,deleteCount:G,toInsert:J})}}let F=0,N=0;for(;;){if(F===q.length){T(F,0,H.slice(N));break}if(N===H.length){T(F,q.length-F,[]);break}const x=q[F],G=H[N],J=z(x,G);J===0?(F+=1,N+=1):J<0?(T(F,1,[]),F+=1):J>0&&(T(F,0,[G]),N+=1)}return I}e.sortedDiff=R;function g(q,H,z){const I=R(q,H,z),T=[],F=[];for(const N of I)T.push(...q.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:T,added:F}}e.delta=g;function y(q,H,z){if(z===0)return[];const I=q.slice(0,z).sort(H);return c(q,H,I,z,q.length),I}e.top=y;function b(q,H,z,I,T){return z===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const x=q.length,G=q.slice(0,z).sort(H);for(let J=z,Q=Math.min(z+I,x);J<x;J=Q,Q=Math.min(Q+I,x)){if(J>z&&await new Promise(ne=>setTimeout(ne)),T&&T.isCancellationRequested)throw(0,S.canceled)();c(q,H,G,J,Q)}return G})().then(F,N)})}e.topAsync=b;function c(q,H,z,I,T){for(const F=z.length;I<T;I++){const N=q[I];if(H(N,z[F-1])<0){z.pop();const x=O(z,G=>H(N,G)<0);z.splice(x,0,N)}}}function p(q){return q.filter(H=>!!H)}e.coalesce=p;function w(q){let H=0;for(let z=0;z<q.length;z++)q[z]&&(q[H]=q[z],H+=1);q.length=H}e.coalesceInPlace=w;function C(q,H,z){q.splice(z,0,q.splice(H,1)[0])}e.move=C;function D(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=D;function f(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=f;function s(q,H){if(!H)return q.filter((I,T)=>q.indexOf(I)===T);const z=Object.create(null);return q.filter(I=>{const T=H(I);return z[T]?!1:(z[T]=!0,!0)})}e.distinct=s;function r(q){const H=new Set;return q.filter(z=>H.has(z)?!1:(H.add(z),!0))}e.distinctES6=r;function t(q){const H=Object.create(null);return z=>{const I=q(z);return H[I]?!1:(H[I]=!0,!0)}}e.uniqueFilter=t;function i(q,H){for(let z=q.length-1;z>=0;z--){const I=q[z];if(H(I))return z}return-1}e.lastIndex=i;function n(q,H){return q.length>0?q[0]:H}e.firstOrDefault=n;function o(q,H,z=(I,T)=>I===T){let I=0;for(let T=0,F=Math.min(q.length,H.length);T<F&&z(q[T],H[T]);T++)I++;return I}e.commonPrefixLength=o;function a(q){return[].concat(...q)}e.flatten=a;function l(q,H){let z=typeof H=="number"?q:0;typeof H=="number"?z=q:(z=0,H=q);const I=[];if(z<=H)for(let T=z;T<H;T++)I.push(T);else for(let T=z;T>H;T--)I.push(T);return I}e.range=l;function u(q,H,z){return q.reduce((I,T)=>(I[H(T)]=z?z(T):T,I),Object.create(null))}e.index=u;function d(q,H){return q.push(H),()=>E(q,H)}e.insert=d;function E(q,H){const z=q.indexOf(H);if(z>-1)return q.splice(z,1),H}e.remove=E;function h(q,H,z){const I=q.slice(0,H),T=q.slice(H);return I.concat(z,T)}e.arrayInsert=h;function P(q,H){let z;if(typeof H=="number"){let I=H;z=()=>{const T=Math.sin(I++)*179426549;return T-Math.floor(T)}}else z=Math.random;for(let I=q.length-1;I>0;I-=1){const T=Math.floor(z()*(I+1)),F=q[I];q[I]=q[T],q[T]=F}}e.shuffle=P;function _(q,H){const z=q.indexOf(H);z>-1&&(q.splice(z,1),q.unshift(H))}e.pushToStart=_;function j(q,H){const z=q.indexOf(H);z>-1&&(q.splice(z,1),q.push(H))}e.pushToEnd=j;function B(q,H){return Array.isArray(q)?q.map(H):H(q)}e.mapArrayOrNot=B;function M(q){return Array.isArray(q)?q:[q]}e.asArray=M;function $(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=$;function V(q,H){for(const z of q){const I=H(z);if(I!==void 0)return I}}e.mapFind=V}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(k){const A=this;let L=!1,U;return function(){return L||(L=!0,U=k.apply(A,arguments)),U}}e.once=S}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(k){function A(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}k.is=A;const L=Object.freeze([]);function U(){return L}k.empty=U;function*O(r){yield r}k.single=O;function m(r){return r||L}k.from=m;function v(r){return!r||r[Symbol.iterator]().next().done===!0}k.isEmpty=v;function R(r){return r[Symbol.iterator]().next().value}k.first=R;function g(r,t){for(const i of r)if(t(i))return!0;return!1}k.some=g;function y(r,t){for(const i of r)if(t(i))return i}k.find=y;function*b(r,t){for(const i of r)t(i)&&(yield i)}k.filter=b;function*c(r,t){for(const i of r)yield t(i)}k.map=c;function*p(...r){for(const t of r)for(const i of t)yield i}k.concat=p;function*w(r){for(const t of r)for(const i of t)yield i}k.concatNested=w;function C(r,t,i){let n=i;for(const o of r)n=t(n,o);return n}k.reduce=C;function*D(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}k.slice=D;function f(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const n=r[Symbol.iterator]();for(let o=0;o<t;o++){const a=n.next();if(a.done)return[i,k.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return n}}]}k.consume=f;function s(r,t,i=(n,o)=>n===o){const n=r[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=n.next(),l=o.next();if(a.done!==l.done)return!1;if(a.done)return!0;if(!i(a.value,l.value))return!1}}k.equals=s})(S=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let n=0,o=t.length,a="",l=0,u=16,d=0;function E($){let V=0,q=0;for(;V<$;){const H=t.charCodeAt(n);if(H>=48&&H<=57)q=q*16+H-48;else if(H>=65&&H<=70)q=q*16+H-65+10;else if(H>=97&&H<=102)q=q*16+H-97+10;else break;n++,V++}return V<$&&(q=-1),q}function h($){n=$,a="",l=0,u=16,d=0}function P(){const $=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&v(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&v(t.charCodeAt(n)))for(n++;n<t.length&&v(t.charCodeAt(n));)n++;else return d=3,t.substring($,n);let V=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&v(t.charCodeAt(n))){for(n++;n<t.length&&v(t.charCodeAt(n));)n++;V=n}else d=3;return t.substring($,V)}function _(){let $="",V=n;for(;;){if(n>=o){$+=t.substring(V,n),d=2;break}const q=t.charCodeAt(n);if(q===34){$+=t.substring(V,n),n++;break}if(q===92){if($+=t.substring(V,n),n++,n>=o){d=2;break}switch(t.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const z=E(4);z>=0?$+=String.fromCharCode(z):d=4;break;default:d=5}V=n;continue}if(q>=0&&q<=31)if(m(q)){$+=t.substring(V,n),d=2;break}else d=6;n++}return $}function j(){if(a="",d=0,l=n,n>=o)return l=o,u=17;let $=t.charCodeAt(n);if(O($)){do n++,a+=String.fromCharCode($),$=t.charCodeAt(n);while(O($));return u=15}if(m($))return n++,a+=String.fromCharCode($),$===13&&t.charCodeAt(n)===10&&(n++,a+=`
`),u=14;switch($){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,a=_(),u=10;case 47:const V=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<o&&!m(t.charCodeAt(n));)n++;return a=t.substring(V,n),u=12}if(t.charCodeAt(n+1)===42){n+=2;const q=o-1;let H=!1;for(;n<q;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,d=1),a=t.substring(V,n),u=13}return a+=String.fromCharCode($),n++,u=16;case 45:if(a+=String.fromCharCode($),n++,n===o||!v(t.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=P(),u=11;default:for(;n<o&&B($);)n++,$=t.charCodeAt(n);if(l!==n){switch(a=t.substring(l,n),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode($),n++,u=16}}function B($){if(O($)||m($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=j();while($>=12&&$<=15);return $}return{setPosition:h,getPosition:()=>n,scan:i?M:j,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=U;function O(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function g(t,i){const n=[],o=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(E,h,P,_){l.value=E,l.offset=h,l.length=P,l.type=_,l.colonOffset=void 0,a=l}try{f(t,{onObjectBegin:(E,h)=>{if(i<=E)throw o;a=void 0,u=i>E,n.push("")},onObjectProperty:(E,h,P)=>{if(i<h||(d(E,h,P,"property"),n[n.length-1]=E,i<=h+P))throw o},onObjectEnd:(E,h)=>{if(i<=E)throw o;a=void 0,n.pop()},onArrayBegin:(E,h)=>{if(i<=E)throw o;a=void 0,n.push(0)},onArrayEnd:(E,h)=>{if(i<=E)throw o;a=void 0,n.pop()},onLiteralValue:(E,h,P)=>{if(i<h||(d(E,h,P,r(E)),i<=h+P))throw o},onSeparator:(E,h,P)=>{if(i<=h)throw o;if(E===":"&&a&&a.type==="property")a.colonOffset=h,u=!1,a=void 0;else if(E===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(u=!0,n[n.length-1]=""),a=void 0}}})}catch(E){if(E!==o)throw E}return{path:n,previousNode:a,isAtPropertyKey:u,matches:E=>{let h=0;for(let P=0;h<E.length&&P<n.length;P++)if(E[h]===n[P]||E[h]==="*")h++;else if(E[h]!=="**")return!1;return h===E.length}}}e.getLocation=g;function y(t,i=[],n=L.DEFAULT){let o=null,a=[];const l=[];function u(E){Array.isArray(a)?a.push(E):o!==null&&(a[o]=E)}return f(t,{onObjectBegin:()=>{const E={};u(E),l.push(a),a=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const E=[];u(E),l.push(a),a=E,o=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:u,onError:(E,h,P)=>{i.push({error:E,offset:h,length:P})}},n),a[0]}e.parse=y;function b(t,i=[],n=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function l(E){return o.children.push(E),E}f(t,{onObjectBegin:E=>{o=l({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,h,P)=>{o=l({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:h,length:P,parent:o})},onObjectEnd:(E,h)=>{o.length=E+h-o.offset,o=o.parent,a(E+h)},onArrayBegin:(E,h)=>{o=l({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,h)=>{o.length=E+h-o.offset,o=o.parent,a(E+h)},onLiteralValue:(E,h,P)=>{l({type:r(E),offset:h,length:P,parent:o,value:E}),a(h+P)},onSeparator:(E,h,P)=>{o.type==="property"&&(E===":"?o.colonOffset=h:E===","&&a(h))},onError:(E,h,P)=>{i.push({error:E,offset:h,length:P})}},n);const d=o.children[0];return d&&delete d.parent,d}e.parseTree=b;function c(t,i){if(!!t){let n=t;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===o){n=l.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}}e.findNodeAtLocation=c;function p(t){if(!t.parent||!t.parent.children)return[];const i=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=p;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const i=Object.create(null);for(let n of t.children){const o=n.children[1];o&&(i[n.children[0].value]=w(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function C(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=C;function D(t,i,n=!1){if(C(t,i,n)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const l=D(o[a],i,n);if(l)return l}return t}}e.findNodeAtOffset=D;function f(t,i,n=L.DEFAULT){const o=U(t,!1);function a(G){return G?()=>G(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(G){return G?J=>G(J,o.getTokenOffset(),o.getTokenLength()):()=>!0}const u=a(i.onObjectBegin),d=l(i.onObjectProperty),E=a(i.onObjectEnd),h=a(i.onArrayBegin),P=a(i.onArrayEnd),_=l(i.onLiteralValue),j=l(i.onSeparator),B=a(i.onComment),M=l(i.onError),$=n&&n.disallowComments,V=n&&n.allowTrailingComma;function q(){for(;;){const G=o.scan();switch(o.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(G){case 12:case 13:$?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return G}}}function H(G,J=[],Q=[]){if(M(G),J.length+Q.length>0){let ne=o.getToken();for(;ne!==17;){if(J.indexOf(ne)!==-1){q();break}else if(Q.indexOf(ne)!==-1)break;ne=q()}}}function z(G){const J=o.getTokenValue();return G?_(J):d(J),q(),!0}function I(){switch(o.getToken()){case 11:let G=0;try{G=JSON.parse(o.getTokenValue()),typeof G!="number"&&(H(2),G=0)}catch(J){H(2)}_(G);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return q(),!0}function T(){return o.getToken()!==10?(H(3,[],[2,5]),!1):(z(!1),o.getToken()===6?(j(":"),q(),x()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function F(){u(),q();let G=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(G||H(4,[],[]),j(","),q(),o.getToken()===2&&V)break}else G&&H(6,[],[]);T()||H(4,[],[2,5]),G=!0}return E(),o.getToken()!==2?H(7,[2],[]):q(),!0}function N(){h(),q();let G=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(G||H(4,[],[]),j(","),q(),o.getToken()===4&&V)break}else G&&H(6,[],[]);x()||H(4,[],[4,5]),G=!0}return P(),o.getToken()!==4?H(8,[4],[]):q(),!0}function x(){switch(o.getToken()){case 3:return N();case 1:return F();case 10:return z(!0);default:return I()}}return q(),o.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):x()?(o.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=f;function s(t,i){let n=U(t),o=[],a,l=0,u;do switch(u=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:l!==u&&o.push(t.substring(l,u)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),l=n.getPosition();break}while(a!==17);return o.join("")}e.stripComments=s;function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=r}),define(Z[46],ee([0,1,32]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(m,v,R){let g,y,b,c,p;if(v){for(c=v.offset,p=c+v.length,b=c;b>0&&!O(m,b-1);)b--;let l=p;for(;l<m.length&&!O(m,l);)l++;y=m.substring(b,l),g=L(y,R)}else y=m,g=0,b=0,c=0,p=m.length;const w=U(R,m);let C=!1,D=0,f;R.insertSpaces?f=A(" ",R.tabSize||4):f="	";const s=(0,S.createScanner)(y,!1);let r=!1;function t(){return w+A(f,g+D)}function i(){let l=s.scan();for(C=!1;l===15||l===14;)C=C||l===14,l=s.scan();return r=l===16||s.getTokenError()!==0,l}const n=[];function o(l,u,d){!r&&u<p&&d>c&&m.substring(u,d)!==l&&n.push({offset:u,length:d-u,content:l})}let a=i();if(a!==17){const l=s.getTokenOffset()+b,u=A(f,g);o(u,b,l)}for(;a!==17;){let l=s.getTokenOffset()+s.getTokenLength()+b,u=i(),d="";for(;!C&&(u===12||u===13);){const h=s.getTokenOffset()+b;o(" ",l,h),l=s.getTokenOffset()+s.getTokenLength()+b,d=u===12?t():"",u=i()}if(u===2)a!==1&&(D--,d=t());else if(u===4)a!==3&&(D--,d=t());else{switch(a){case 3:case 1:D++,d=t();break;case 5:case 12:d=t();break;case 13:C?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}C&&(u===12||u===13)&&(d=t())}const E=s.getTokenOffset()+b;o(d,l,E),a=u}return n}e.format=k;function A(m,v){let R="";for(let g=0;g<v;g++)R+=m;return R}function L(m,v){let R=0,g=0;const y=v.tabSize||4;for(;R<m.length;){const b=m.charAt(R);if(b===" ")g++;else if(b==="	")g+=y;else break;R++}return Math.floor(g/y)}function U(m,v){for(let R=0;R<v.length;R++){const g=v.charAt(R);if(g==="\r")return R+1<v.length&&v.charAt(R+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=U;function O(m,v){return`\r
`.indexOf(m.charAt(v))!==-1}e.isEOL=O}),define(Z[41],ee([0,1,32,46]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(v,R,g){return L(v,R,void 0,g)}e.removeProperty=A;function L(v,R,g,y,b){const c=R.slice(),p=[],w=(0,S.parseTree)(v,p);let C,D;for(;c.length>0&&(D=c.pop(),C=(0,S.findNodeAtLocation)(w,c),C===void 0&&g!==void 0);)typeof D=="string"?g={[D]:g}:g=[g];if(C)if(C.type==="object"&&typeof D=="string"&&Array.isArray(C.children)){const f=(0,S.findNodeAtLocation)(C,[D]);if(f!==void 0)if(g===void 0){if(!f.parent)throw new Error("Malformed AST");const s=C.children.indexOf(f.parent);let r,t=f.parent.offset+f.parent.length;if(s>0){const i=C.children[s-1];r=i.offset+i.length}else r=C.offset+1,C.children.length>1&&(t=C.children[1].offset);return U(v,{offset:r,length:t-r,content:""},y)}else return U(v,{offset:f.offset,length:f.length,content:JSON.stringify(g)},y);else{if(g===void 0)return[];const s=`${JSON.stringify(D)}: ${JSON.stringify(g)}`,r=b?b(C.children.map(i=>i.children[0].value)):C.children.length;let t;if(r>0){const i=C.children[r-1];t={offset:i.offset+i.length,length:0,content:","+s}}else C.children.length===0?t={offset:C.offset+1,length:0,content:s}:t={offset:C.offset+1,length:0,content:s+","};return U(v,t,y)}}else if(C.type==="array"&&typeof D=="number"&&Array.isArray(C.children))if(g!==void 0){const f=`${JSON.stringify(g)}`;let s;if(C.children.length===0||D===0)s={offset:C.offset+1,length:0,content:C.children.length===0?f:f+","};else{const r=D===-1||D>C.children.length?C.children.length:D,t=C.children[r-1];s={offset:t.offset+t.length,length:0,content:","+f}}return U(v,s,y)}else{const f=D,s=C.children[f];let r;if(C.children.length===1)r={offset:C.offset+1,length:C.length-2,content:""};else if(C.children.length-1===f){const t=C.children[f-1],i=t.offset+t.length,n=C.offset+C.length;r={offset:i,length:n-2-i,content:""}}else r={offset:s.offset,length:C.children[f+1].offset-s.offset,content:""};return U(v,r,y)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${C.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return U(v,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(g)},y)}}e.setProperty=L;function U(v,R,g){let y=O(v,R),b=R.offset,c=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;b>0&&!(0,k.isEOL)(y,b-1);)b--;for(;c<y.length&&!(0,k.isEOL)(y,c);)c++}const p=(0,k.format)(y,{offset:b,length:c-b},g);for(let C=p.length-1;C>=0;C--){const D=p[C];y=O(y,D),b=Math.min(b,D.offset),c=Math.max(c,D.offset+D.length),c+=D.content.length-D.length}const w=v.length-(y.length-c)-b;return[{offset:b,length:w,content:y.substring(b,c)}]}e.withFormatting=U;function O(v,R){return v.substring(0,R.offset)+R.content+v.substring(R.offset+R.length)}e.applyEdit=O;function m(v,R){let g=R.slice(0).sort((b,c)=>{const p=b.offset-c.offset;return p===0?b.length-c.length:p}),y=v.length;for(let b=g.length-1;b>=0;b--){let c=g[b];if(c.offset+c.length<=y)v=O(v,c);else throw new Error("Overlapping edit");y=c.offset}return v}e.applyEdits=m}),define(Z[2],ee([0,1,63,53]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let L=null;function U(f){L=f}if(e.setDisposableTracker=U,A){const f="__is_disposable_tracked__";L=new class{trackDisposable(s){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[f]||console.log(r)},3e3)}markTracked(s){if(s&&s!==p.None)try{s[f]=!0}catch(r){}}}}function O(f){!L||L.markTracked(f)}function m(f){return L&&L.trackDisposable(f),f}e.trackDisposable=m;class v extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=v;function R(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=R;function g(f){if(k.Iterable.is(f)){let s=[];for(const r of f)if(r){O(r);try{r.dispose()}catch(t){s.push(t)}}if(s.length===1)throw s[0];if(s.length>1)throw new v(s);return Array.isArray(f)?[]:f}else if(f)return O(f),f.dispose(),f}e.dispose=g;function y(...f){return f.forEach(O),b(()=>g(f))}e.combinedDisposable=y;function b(f){const s=m({dispose:()=>{O(s),f()}});return s}e.toDisposable=b;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(O(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return O(s),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new c,m(this)}dispose(){O(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var r;this._isDisposed||s===this._value||((r=this._value)===null||r===void 0||r.dispose(),s&&O(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,O(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=w;class C{constructor(){this.references=new Map}acquire(s,...r){let t=this.references.get(s);t||(t={counter:0,object:this.createReferencedObject(s,...r)},this.references.set(s,t));const{object:i}=t,n=(0,S.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(s,t.object),this.references.delete(s))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=C;class D{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=D}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class k{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,U){const O=new S(L);if(this._first===S.Undefined)this._first=O,this._last=O;else if(U){const v=this._last;this._last=O,O.prev=v,v.next=O}else{const v=this._first;this._first=O,O.next=v,v.prev=O}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(O))}}shift(){if(this._first!==S.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==S.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const U=L.prev;U.next=L.next,L.next.prev=U}else L.prev===S.Undefined&&L.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):L.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):L.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.LinkedList=k});"use strict";(function(){function K(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function U(m){L.push(m,Date.now())}function O(){const m=[];for(let v=0;v<L.length;v+=2)m.push({name:L[v],startTime:L[v+1]});return m}return{mark:U,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const U of performance.getEntriesByType("mark"))L.push({name:U.name,startTime:Math.round(A+U.startTime)});return L}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function S(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=S(k))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,L=!1,U=!1,O=!1,m=!1,v=!1,R=!1,g,y=k,b,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const w=typeof((S=p==null?void 0:p.versions)===null||S===void 0?void 0:S.electron)=="string"&&p.type==="renderer";if(e.isElectronSandboxed=w&&(p==null?void 0:p.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=p==null?void 0:p.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)c=navigator.userAgent,A=c.indexOf("Windows")>=0,L=c.indexOf("Macintosh")>=0,R=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=c.indexOf("Linux")>=0,v=!0,g=navigator.language,y=g;else if(typeof p=="object"){A=p.platform==="win32",L=p.platform==="darwin",U=p.platform==="linux",O=U&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,g=k,y=k;const o=p.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),l=a.availableLanguages["*"];g=a.locale,y=l||k,b=a._translationsConfigFile}catch(a){}m=!0}else console.error("Unable to resolve platform.");var C;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function D(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let f=0;L?f=1:A?f=3:U&&(f=2),e.isWindows=A,e.isMacintosh=L,e.isLinux=U,e.isLinuxSnap=O,e.isNative=m,e.isWeb=v,e.isIOS=R,e.platform=f,e.userAgent=c,e.language=y;var s;(function(o){function a(){return e.language}o.value=a;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=l;function u(){return e.language==="en"}o.isDefault=u})(s=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let E=0,h=l.length;E<h;E++){const P=l[E];if(P.id===d.data.vscodeSetImmediateId){l.splice(E,1),P.callback();return}}});let u=0;return d=>{const E=++u;l.push({id:E,callback:d}),e.globals.postMessage({vscodeSetImmediateId:E},"*")}}if(typeof(p==null?void 0:p.nextTick)=="function")return p.nextTick.bind(p);const a=Promise.resolve();return l=>a.then(l)}();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||R?2:A?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(Z[36],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof S.globals.vscode!="undefined"){const A=S.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(L){return(0,S.setImmediate)(L)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(A){return(0,S.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,36]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,L=90,U=122,O=46,m=47,v=92,R=58,g=63;class y extends Error{constructor(s,r,t){let i;typeof r=="string"&&r.indexOf("not ")===0?(i="must not be",r=r.replace(/^not /,"")):i="must be";const n=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${n} ${i} of type ${r}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function b(f,s){if(typeof f!="string")throw new y(s,"string",f)}function c(f){return f===m||f===v}function p(f){return f===m}function w(f){return f>=k&&f<=L||f>=A&&f<=U}function C(f,s,r,t){let i="",n=0,o=-1,a=0,l=0;for(let u=0;u<=f.length;++u){if(u<f.length)l=f.charCodeAt(u);else{if(t(l))break;l=m}if(t(l)){if(!(o===u-1||a===1))if(a===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==O||i.charCodeAt(i.length-2)!==O){if(i.length>2){const d=i.lastIndexOf(r);d===-1?(i="",n=0):(i=i.slice(0,d),n=i.length-1-i.lastIndexOf(r)),o=u,a=0;continue}else if(i.length!==0){i="",n=0,o=u,a=0;continue}}s&&(i+=i.length>0?`${r}..`:"..",n=2)}else i.length>0?i+=`${r}${f.slice(o+1,u)}`:i=f.slice(o+1,u),n=u-o-1;o=u,a=0}else l===O&&a!==-1?++a:a=-1}return i}function D(f,s){if(s===null||typeof s!="object")throw new y("pathObject","Object",s);const r=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${t}`:`${r}${f}${t}`:t}e.win32={resolve(...f){let s="",r="",t=!1;for(let i=f.length-1;i>=-1;i--){let n;if(i>=0){if(n=f[i],b(n,"path"),n.length===0)continue}else s.length===0?n=S.cwd():(n=S.env[`=${s}`]||S.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==s.toLowerCase()&&n.charCodeAt(2)===v)&&(n=`${s}\\`));const o=n.length;let a=0,l="",u=!1;const d=n.charCodeAt(0);if(o===1)c(d)&&(a=1,u=!0);else if(c(d))if(u=!0,c(n.charCodeAt(1))){let E=2,h=E;for(;E<o&&!c(n.charCodeAt(E));)E++;if(E<o&&E!==h){const P=n.slice(h,E);for(h=E;E<o&&c(n.charCodeAt(E));)E++;if(E<o&&E!==h){for(h=E;E<o&&!c(n.charCodeAt(E));)E++;(E===o||E!==h)&&(l=`\\\\${P}\\${n.slice(h,E)}`,a=E)}}}else a=1;else w(d)&&n.charCodeAt(1)===R&&(l=n.slice(0,2),a=2,o>2&&c(n.charCodeAt(2))&&(u=!0,a=3));if(l.length>0)if(s.length>0){if(l.toLowerCase()!==s.toLowerCase())continue}else s=l;if(t){if(s.length>0)break}else if(r=`${n.slice(a)}\\${r}`,t=u,u&&s.length>0)break}return r=C(r,!t,"\\",c),t?`${s}\\${r}`:`${s}${r}`||"."},normalize(f){b(f,"path");const s=f.length;if(s===0)return".";let r=0,t,i=!1;const n=f.charCodeAt(0);if(s===1)return p(n)?"\\":f;if(c(n))if(i=!0,c(f.charCodeAt(1))){let a=2,l=a;for(;a<s&&!c(f.charCodeAt(a));)a++;if(a<s&&a!==l){const u=f.slice(l,a);for(l=a;a<s&&c(f.charCodeAt(a));)a++;if(a<s&&a!==l){for(l=a;a<s&&!c(f.charCodeAt(a));)a++;if(a===s)return`\\\\${u}\\${f.slice(l)}\\`;a!==l&&(t=`\\\\${u}\\${f.slice(l,a)}`,r=a)}}}else r=1;else w(n)&&f.charCodeAt(1)===R&&(t=f.slice(0,2),r=2,s>2&&c(f.charCodeAt(2))&&(i=!0,r=3));let o=r<s?C(f.slice(r),!i,"\\",c):"";return o.length===0&&!i&&(o="."),o.length>0&&c(f.charCodeAt(s-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(f){b(f,"path");const s=f.length;if(s===0)return!1;const r=f.charCodeAt(0);return c(r)||s>2&&w(r)&&f.charCodeAt(1)===R&&c(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let s,r;for(let n=0;n<f.length;++n){const o=f[n];b(o,"path"),o.length>0&&(s===void 0?s=r=o:s+=`\\${o}`)}if(s===void 0)return".";let t=!0,i=0;if(typeof r=="string"&&c(r.charCodeAt(0))){++i;const n=r.length;n>1&&c(r.charCodeAt(1))&&(++i,n>2&&(c(r.charCodeAt(2))?++i:t=!1))}if(t){for(;i<s.length&&c(s.charCodeAt(i));)i++;i>=2&&(s=`\\${s.slice(i)}`)}return e.win32.normalize(s)},relative(f,s){if(b(f,"from"),b(s,"to"),f===s)return"";const r=e.win32.resolve(f),t=e.win32.resolve(s);if(r===t||(f=r.toLowerCase(),s=t.toLowerCase(),f===s))return"";let i=0;for(;i<f.length&&f.charCodeAt(i)===v;)i++;let n=f.length;for(;n-1>i&&f.charCodeAt(n-1)===v;)n--;const o=n-i;let a=0;for(;a<s.length&&s.charCodeAt(a)===v;)a++;let l=s.length;for(;l-1>a&&s.charCodeAt(l-1)===v;)l--;const u=l-a,d=o<u?o:u;let E=-1,h=0;for(;h<d;h++){const _=f.charCodeAt(i+h);if(_!==s.charCodeAt(a+h))break;_===v&&(E=h)}if(h!==d){if(E===-1)return t}else{if(u>d){if(s.charCodeAt(a+h)===v)return t.slice(a+h+1);if(h===2)return t.slice(a+h)}o>d&&(f.charCodeAt(i+h)===v?E=h:h===2&&(E=3)),E===-1&&(E=0)}let P="";for(h=i+E+1;h<=n;++h)(h===n||f.charCodeAt(h)===v)&&(P+=P.length===0?"..":"\\..");return a+=E,P.length>0?`${P}${t.slice(a,l)}`:(t.charCodeAt(a)===v&&++a,t.slice(a,l))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const s=e.win32.resolve(f);if(s.length<=2)return f;if(s.charCodeAt(0)===v){if(s.charCodeAt(1)===v){const r=s.charCodeAt(2);if(r!==g&&r!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===v)return`\\\\?\\${s}`;return f},dirname(f){b(f,"path");const s=f.length;if(s===0)return".";let r=-1,t=0;const i=f.charCodeAt(0);if(s===1)return c(i)?f:".";if(c(i)){if(r=t=1,c(f.charCodeAt(1))){let a=2,l=a;for(;a<s&&!c(f.charCodeAt(a));)a++;if(a<s&&a!==l){for(l=a;a<s&&c(f.charCodeAt(a));)a++;if(a<s&&a!==l){for(l=a;a<s&&!c(f.charCodeAt(a));)a++;if(a===s)return f;a!==l&&(r=t=a+1)}}}}else w(i)&&f.charCodeAt(1)===R&&(r=s>2&&c(f.charCodeAt(2))?3:2,t=r);let n=-1,o=!0;for(let a=s-1;a>=t;--a)if(c(f.charCodeAt(a))){if(!o){n=a;break}}else o=!1;if(n===-1){if(r===-1)return".";n=r}return f.slice(0,n)},basename(f,s){s!==void 0&&b(s,"ext"),b(f,"path");let r=0,t=-1,i=!0,n;if(f.length>=2&&w(f.charCodeAt(0))&&f.charCodeAt(1)===R&&(r=2),s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,a=-1;for(n=f.length-1;n>=r;--n){const l=f.charCodeAt(n);if(c(l)){if(!i){r=n+1;break}}else a===-1&&(i=!1,a=n+1),o>=0&&(l===s.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=a))}return r===t?t=a:t===-1&&(t=f.length),f.slice(r,t)}for(n=f.length-1;n>=r;--n)if(c(f.charCodeAt(n))){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":f.slice(r,t)},extname(f){b(f,"path");let s=0,r=-1,t=0,i=-1,n=!0,o=0;f.length>=2&&f.charCodeAt(1)===R&&w(f.charCodeAt(0))&&(s=t=2);for(let a=f.length-1;a>=s;--a){const l=f.charCodeAt(a);if(c(l)){if(!n){t=a+1;break}continue}i===-1&&(n=!1,i=a+1),l===O?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":f.slice(r,i)},format:D.bind(null,"\\"),parse(f){b(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const r=f.length;let t=0,i=f.charCodeAt(0);if(r===1)return c(i)?(s.root=s.dir=f,s):(s.base=s.name=f,s);if(c(i)){if(t=1,c(f.charCodeAt(1))){let E=2,h=E;for(;E<r&&!c(f.charCodeAt(E));)E++;if(E<r&&E!==h){for(h=E;E<r&&c(f.charCodeAt(E));)E++;if(E<r&&E!==h){for(h=E;E<r&&!c(f.charCodeAt(E));)E++;E===r?t=E:E!==h&&(t=E+1)}}}}else if(w(i)&&f.charCodeAt(1)===R){if(r<=2)return s.root=s.dir=f,s;if(t=2,c(f.charCodeAt(2))){if(r===3)return s.root=s.dir=f,s;t=3}}t>0&&(s.root=f.slice(0,t));let n=-1,o=t,a=-1,l=!0,u=f.length-1,d=0;for(;u>=t;--u){if(i=f.charCodeAt(u),c(i)){if(!l){o=u+1;break}continue}a===-1&&(l=!1,a=u+1),i===O?n===-1?n=u:d!==1&&(d=1):n!==-1&&(d=-1)}return a!==-1&&(n===-1||d===0||d===1&&n===a-1&&n===o+1?s.base=s.name=f.slice(o,a):(s.name=f.slice(o,n),s.base=f.slice(o,a),s.ext=f.slice(n,a))),o>0&&o!==t?s.dir=f.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let s="",r=!1;for(let t=f.length-1;t>=-1&&!r;t--){const i=t>=0?f[t]:S.cwd();b(i,"path"),i.length!==0&&(s=`${i}/${s}`,r=i.charCodeAt(0)===m)}return s=C(s,!r,"/",p),r?`/${s}`:s.length>0?s:"."},normalize(f){if(b(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===m,r=f.charCodeAt(f.length-1)===m;return f=C(f,!s,"/",p),f.length===0?s?"/":r?"./":".":(r&&(f+="/"),s?`/${f}`:f)},isAbsolute(f){return b(f,"path"),f.length>0&&f.charCodeAt(0)===m},join(...f){if(f.length===0)return".";let s;for(let r=0;r<f.length;++r){const t=f[r];b(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(f,s){if(b(f,"from"),b(s,"to"),f===s||(f=e.posix.resolve(f),s=e.posix.resolve(s),f===s))return"";const r=1,t=f.length,i=t-r,n=1,o=s.length-n,a=i<o?i:o;let l=-1,u=0;for(;u<a;u++){const E=f.charCodeAt(r+u);if(E!==s.charCodeAt(n+u))break;E===m&&(l=u)}if(u===a)if(o>a){if(s.charCodeAt(n+u)===m)return s.slice(n+u+1);if(u===0)return s.slice(n+u)}else i>a&&(f.charCodeAt(r+u)===m?l=u:u===0&&(l=0));let d="";for(u=r+l+1;u<=t;++u)(u===t||f.charCodeAt(u)===m)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(n+l)}`},toNamespacedPath(f){return f},dirname(f){if(b(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===m;let r=-1,t=!0;for(let i=f.length-1;i>=1;--i)if(f.charCodeAt(i)===m){if(!t){r=i;break}}else t=!1;return r===-1?s?"/":".":s&&r===1?"//":f.slice(0,r)},basename(f,s){s!==void 0&&b(s,"ext"),b(f,"path");let r=0,t=-1,i=!0,n;if(s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,a=-1;for(n=f.length-1;n>=0;--n){const l=f.charCodeAt(n);if(l===m){if(!i){r=n+1;break}}else a===-1&&(i=!1,a=n+1),o>=0&&(l===s.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=a))}return r===t?t=a:t===-1&&(t=f.length),f.slice(r,t)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===m){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":f.slice(r,t)},extname(f){b(f,"path");let s=-1,r=0,t=-1,i=!0,n=0;for(let o=f.length-1;o>=0;--o){const a=f.charCodeAt(o);if(a===m){if(!i){r=o+1;break}continue}t===-1&&(i=!1,t=o+1),a===O?s===-1?s=o:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||t===-1||n===0||n===1&&s===t-1&&s===r+1?"":f.slice(s,t)},format:D.bind(null,"/"),parse(f){b(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const r=f.charCodeAt(0)===m;let t;r?(s.root="/",t=1):t=0;let i=-1,n=0,o=-1,a=!0,l=f.length-1,u=0;for(;l>=t;--l){const d=f.charCodeAt(l);if(d===m){if(!a){n=l+1;break}continue}o===-1&&(a=!1,o=l+1),d===O?i===-1?i=l:u!==1&&(u=1):i!==-1&&(u=-1)}if(o!==-1){const d=n===0&&r?1:n;i===-1||u===0||u===1&&i===o-1&&i===n+1?s.base=s.name=f.slice(d,o):(s.name=f.slice(d,i),s.base=f.slice(d,o),s.ext=f.slice(i,o))}return n>0?s.dir=f.slice(0,n-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var k in S)(typeof exports=="object"?exports:K)[k]=S[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function S(k){if(e[k])return e[k].exports;var A=e[k]={i:k,l:!1,exports:{}};return K[k].call(A.exports,A,A.exports,S),A.l=!0,A.exports}return S.m=K,S.c=e,S.d=function(k,A,L){S.o(k,A)||Object.defineProperty(k,A,{enumerable:!0,get:L})},S.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},S.t=function(k,A){if(1&A&&(k=S(k)),8&A||4&A&&typeof k=="object"&&k&&k.__esModule)return k;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:k}),2&A&&typeof k!="string")for(var U in k)S.d(L,U,function(O){return k[O]}.bind(null,U));return L},S.n=function(k){var A=k&&k.__esModule?function(){return k.default}:function(){return k};return S.d(A,"a",A),A},S.o=function(k,A){return Object.prototype.hasOwnProperty.call(k,A)},S.p="",S(S.s=0)}([function(K,e,S){(function(k){var A;e=K.exports=Q,A=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],m=e.src=[],v=0,R=v++;m[R]="0|[1-9]\\d*";var g=v++;m[g]="[0-9]+";var y=v++;m[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=v++;m[b]="("+m[R]+")\\.("+m[R]+")\\.("+m[R]+")";var c=v++;m[c]="("+m[g]+")\\.("+m[g]+")\\.("+m[g]+")";var p=v++;m[p]="(?:"+m[R]+"|"+m[y]+")";var w=v++;m[w]="(?:"+m[g]+"|"+m[y]+")";var C=v++;m[C]="(?:-("+m[p]+"(?:\\."+m[p]+")*))";var D=v++;m[D]="(?:-?("+m[w]+"(?:\\."+m[w]+")*))";var f=v++;m[f]="[0-9A-Za-z-]+";var s=v++;m[s]="(?:\\+("+m[f]+"(?:\\."+m[f]+")*))";var r=v++,t="v?"+m[b]+m[C]+"?"+m[s]+"?";m[r]="^"+t+"$";var i="[v=\\s]*"+m[c]+m[D]+"?"+m[s]+"?",n=v++;m[n]="^"+i+"$";var o=v++;m[o]="((?:<|>)?=?)";var a=v++;m[a]=m[g]+"|x|X|\\*";var l=v++;m[l]=m[R]+"|x|X|\\*";var u=v++;m[u]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[C]+")?"+m[s]+"?)?)?";var d=v++;m[d]="[v=\\s]*("+m[a]+")(?:\\.("+m[a]+")(?:\\.("+m[a]+")(?:"+m[D]+")?"+m[s]+"?)?)?";var E=v++;m[E]="^"+m[o]+"\\s*"+m[u]+"$";var h=v++;m[h]="^"+m[o]+"\\s*"+m[d]+"$";var P=v++;m[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;m[_]="(?:~>?)";var j=v++;m[j]="(\\s*)"+m[_]+"\\s+",O[j]=new RegExp(m[j],"g");var B=v++;m[B]="^"+m[_]+m[u]+"$";var M=v++;m[M]="^"+m[_]+m[d]+"$";var $=v++;m[$]="(?:\\^)";var V=v++;m[V]="(\\s*)"+m[$]+"\\s+",O[V]=new RegExp(m[V],"g");var q=v++;m[q]="^"+m[$]+m[u]+"$";var H=v++;m[H]="^"+m[$]+m[d]+"$";var z=v++;m[z]="^"+m[o]+"\\s*("+i+")$|^$";var I=v++;m[I]="^"+m[o]+"\\s*("+t+")$|^$";var T=v++;m[T]="(\\s*)"+m[o]+"\\s*("+i+"|"+m[u]+")",O[T]=new RegExp(m[T],"g");var F=v++;m[F]="^\\s*("+m[u]+")\\s+-\\s+("+m[u]+")\\s*$";var N=v++;m[N]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var x=v++;m[x]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)A(G,m[G]),O[G]||(O[G]=new RegExp(m[G]));function J(X,re){if(X instanceof Q)return X;if(typeof X!="string"||X.length>L||!(re?O[n]:O[r]).test(X))return null;try{return new Q(X,re)}catch(se){return null}}function Q(X,re){if(X instanceof Q){if(X.loose===re)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(X,re);A("SemVer",X,re),this.loose=re;var se=X.trim().match(re?O[n]:O[r]);if(!se)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var W=+me;if(W>=0&&W<U)return W}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,re){var se=J(X,re);return se?se.version:null},e.clean=function(X,re){var se=J(X.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return A("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),ie(this.major,X.major)||ie(this.minor,X.minor)||ie(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=X.prerelease[re];if(A("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ie(se,me)}while(++re)},Q.prototype.inc=function(X,re){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(X,se).inc(re,me).version}catch(W){return null}},e.diff=function(X,re){if(Ee(X,re))return null;var se=J(X),me=J(re);if(se.prerelease.length||me.prerelease.length){for(var W in se)if((W==="major"||W==="minor"||W==="patch")&&se[W]!==me[W])return"pre"+W;return"prerelease"}for(var W in se)if((W==="major"||W==="minor"||W==="patch")&&se[W]!==me[W])return W},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(X,re){var se=ne.test(X),me=ne.test(re);return se&&me&&(X=+X,re=+re),se&&!me?-1:me&&!se?1:X<re?-1:X>re?1:0}function ce(X,re,se){return new Q(X,se).compare(new Q(re,se))}function ue(X,re,se){return ce(X,re,se)>0}function ge(X,re,se){return ce(X,re,se)<0}function Ee(X,re,se){return ce(X,re,se)===0}function Ie(X,re,se){return ce(X,re,se)!==0}function Oe(X,re,se){return ce(X,re,se)>=0}function Ae(X,re,se){return ce(X,re,se)<=0}function Ue(X,re,se,me){var W;switch(re){case"===":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),W=X===se;break;case"!==":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),W=X!==se;break;case"":case"=":case"==":W=Ee(X,se,me);break;case"!=":W=Ie(X,se,me);break;case">":W=ue(X,se,me);break;case">=":W=Oe(X,se,me);break;case"<":W=ge(X,se,me);break;case"<=":W=Ae(X,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return W}function ke(X,re){if(X instanceof ke){if(X.loose===re)return X;X=X.value}if(!(this instanceof ke))return new ke(X,re);A("comparator",X,re),this.loose=re,this.parse(X),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(X,re){return ie(re,X)},e.major=function(X,re){return new Q(X,re).major},e.minor=function(X,re){return new Q(X,re).minor},e.patch=function(X,re){return new Q(X,re).patch},e.compare=ce,e.compareLoose=function(X,re){return ce(X,re,!0)},e.rcompare=function(X,re,se){return ce(re,X,se)},e.sort=function(X,re){return X.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(X,re){return X.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=ue,e.lt=ge,e.eq=Ee,e.neq=Ie,e.gte=Oe,e.lte=Ae,e.cmp=Ue,e.Comparator=ke;var Ne={};function De(X,re){if(X instanceof De)return X.loose===re?X:new De(X.raw,re);if(X instanceof ke)return new De(X.value,re);if(!(this instanceof De))return new De(X,re);if(this.loose=re,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Te(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ge(X,re,se,me,W,te,oe,ae,le,fe,ve,Se,we){return((re=Te(se)?"":Te(me)?">="+se+".0.0":Te(W)?">="+se+"."+me+".0":">="+re)+" "+(ae=Te(le)?"":Te(fe)?"<"+(+le+1)+".0.0":Te(ve)?"<"+le+"."+(+fe+1)+".0":Se?"<="+le+"."+fe+"."+ve+"-"+Se:"<="+ae)).trim()}function Ke(X,re){for(var se=0;se<X.length;se++)if(!X[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<X.length;se++)if(A(X[se].semver),X[se].semver!==Ne&&X[se].semver.prerelease.length>0){var me=X[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(X,re,se){try{re=new De(re,se)}catch(me){return!1}return re.test(X)}function ze(X,re,se,me){var W,te,oe,ae,le;switch(X=new Q(X,me),re=new De(re,me),se){case">":W=ue,te=Ae,oe=ge,ae=">",le=">=";break;case"<":W=ge,te=Oe,oe=ue,ae="<",le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(X,re,me))return!1;for(var fe=0;fe<re.set.length;++fe){var ve=re.set[fe],Se=null,we=null;if(ve.forEach(function(be){be.semver===Ne&&(be=new ke(">=0.0.0")),Se=Se||be,we=we||be,W(be.semver,Se.semver,me)?Se=be:oe(be.semver,we.semver,me)&&(we=be)}),Se.operator===ae||Se.operator===le||(!we.operator||we.operator===ae)&&te(X,we.semver)||we.operator===le&&oe(X,we.semver))return!1}return!0}ke.prototype.parse=function(X){var re=this.loose?O[z]:O[I],se=X.match(re);if(!se)throw new TypeError("Invalid comparator: "+X);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=Ne},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return A("Comparator.test",X,this.loose),this.semver===Ne||(typeof X=="string"&&(X=new Q(X,this.loose)),Ue(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,re){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new De(X.value,re),$e(this.value,se,re);if(X.operator==="")return se=new De(this.value,re),$e(X.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),W=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),te=this.semver.version===X.semver.version,oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ae=Ue(this.semver,"<",X.semver,re)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),le=Ue(this.semver,">",X.semver,re)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return me||W||te&&oe||ae||le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(X){var re=this.loose;X=X.trim(),A("range",X,re);var se=re?O[N]:O[F];X=X.replace(se,Ge),A("hyphen replace",X),X=X.replace(O[T],"$1$2$3"),A("comparator trim",X,O[T]),X=(X=(X=X.replace(O[j],"$1~")).replace(O[V],"$1^")).split(/\s+/).join(" ");var me=re?O[z]:O[I],W=X.split(" ").map(function(te){return function(oe,ae){return A("comp",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){A("caret",Se,we);var be=we?O[H]:O[q];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("caret",Se,Pe,ye,pe,Ce,Re),Te(ye)?de="":Te(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te(Ce)?de=ye==="0"?">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+".0 <"+(+ye+1)+".0.0":Re?(A("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+Re+" <"+(+ye+1)+".0.0"):(A("no pr"),de=ye==="0"?pe==="0"?">="+ye+"."+pe+"."+Ce+" <"+ye+"."+pe+"."+(+Ce+1):">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0":">="+ye+"."+pe+"."+Ce+" <"+(+ye+1)+".0.0"),A("caret return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("caret",oe),oe=function(le,fe){return le.trim().split(/\s+/).map(function(ve){return function(Se,we){var be=we?O[M]:O[B];return Se.replace(be,function(Pe,ye,pe,Ce,Re){var de;return A("tilde",Se,Pe,ye,pe,Ce,Re),Te(ye)?de="":Te(pe)?de=">="+ye+".0.0 <"+(+ye+1)+".0.0":Te(Ce)?de=">="+ye+"."+pe+".0 <"+ye+"."+(+pe+1)+".0":Re?(A("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),de=">="+ye+"."+pe+"."+Ce+Re+" <"+ye+"."+(+pe+1)+".0"):de=">="+ye+"."+pe+"."+Ce+" <"+ye+"."+(+pe+1)+".0",A("tilde return",de),de})}(ve,fe)}).join(" ")}(oe,ae),A("tildes",oe),oe=function(le,fe){return A("replaceXRanges",le,fe),le.split(/\s+/).map(function(ve){return function(Se,we){Se=Se.trim();var be=we?O[h]:O[E];return Se.replace(be,function(Pe,ye,pe,Ce,Re,de){A("xRange",Se,Pe,ye,pe,Ce,Re,de);var Le=Te(pe),_e=Le||Te(Ce),Fe=_e||Te(Re);return ye==="="&&Fe&&(ye=""),Le?Pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Fe?(_e&&(Ce=0),Fe&&(Re=0),ye===">"?(ye=">=",_e?(pe=+pe+1,Ce=0,Re=0):Fe&&(Ce=+Ce+1,Re=0)):ye==="<="&&(ye="<",_e?pe=+pe+1:Ce=+Ce+1),Pe=ye+pe+"."+Ce+"."+Re):_e?Pe=">="+pe+".0.0 <"+(+pe+1)+".0.0":Fe&&(Pe=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0"),A("xRange return",Pe),Pe})}(ve,fe)}).join(" ")}(oe,ae),A("xrange",oe),oe=function(le,fe){return A("replaceStars",le,fe),le.trim().replace(O[x],"")}(oe,ae),A("stars",oe),oe}(te,re)}).join(" ").split(/\s+/);return this.loose&&(W=W.filter(function(te){return!!te.match(me)})),W=W.map(function(te){return new ke(te,re)})},De.prototype.intersects=function(X,re){if(!(X instanceof De))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return X.set.some(function(W){return W.every(function(te){return me.intersects(te,re)})})})})},e.toComparators=function(X,re){return new De(X,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var re=0;re<this.set.length;re++)if(Ke(this.set[re],X))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(X,re,se){var me=null,W=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&W.compare(oe)!==-1||(W=new Q(me=oe,se)))}),me},e.minSatisfying=function(X,re,se){var me=null,W=null;try{var te=new De(re,se)}catch(oe){return null}return X.forEach(function(oe){te.test(oe)&&(me&&W.compare(oe)!==1||(W=new Q(me=oe,se)))}),me},e.validRange=function(X,re){try{return new De(X,re).range||"*"}catch(se){return null}},e.ltr=function(X,re,se){return ze(X,re,"<",se)},e.gtr=function(X,re,se){return ze(X,re,">",se)},e.outside=ze,e.prerelease=function(X,re){var se=J(X,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(X,re,se){return X=new De(X,se),re=new De(re,se),X.intersects(re)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var re=X.match(O[P]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,S(1))},function(K,e){var S,k,A=K.exports={};function L(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function O(w){if(S===setTimeout)return setTimeout(w,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch(C){try{return S.call(null,w,0)}catch(D){return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch(w){S=L}try{k=typeof clearTimeout=="function"?clearTimeout:U}catch(w){k=U}})();var m,v=[],R=!1,g=-1;function y(){R&&m&&(R=!1,m.length?v=m.concat(v):g=-1,v.length&&b())}function b(){if(!R){var w=O(y);R=!0;for(var C=v.length;C;){for(m=v,v=[];++g<C;)m&&m[g].run();g=-1,C=v.length}m=null,R=!1,function(D){if(k===clearTimeout)return clearTimeout(D);if((k===U||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(D);try{k(D)}catch(f){try{return k.call(null,D)}catch(s){return k.call(this,D)}}}(w)}}function c(w,C){this.fun=w,this.array=C}function p(){}A.nextTick=function(w){var C=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)C[D-1]=arguments[D];v.push(new c(w,C)),v.length!==1||R||O(b)},c.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=p,A.addListener=p,A.once=p,A.off=p,A.removeListener=p,A.removeAllListeners=p,A.emit=p,A.prependListener=p,A.prependOnceListener=p,A.listeners=function(w){return[]},A.binding=function(w){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(w){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[86],ee([0,1,7]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=S.globals.performance&&typeof S.globals.performance.now=="function";class A{constructor(U){this._highResolution=k&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new A(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,11,63,2,64,86]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var O;(function(C){C.None=()=>A.Disposable.None;function D(M){return($,V=null,q)=>{let H=!1,z;return z=M(I=>{if(!H)return z?z.dispose():H=!0,$.call(V,I)},null,q),H&&z.dispose(),z}}C.once=D;function f(M,$){return o((V,q=null,H)=>M(z=>V.call(q,$(z)),null,H))}C.map=f;function s(M,$){return o((V,q=null,H)=>M(z=>{$(z),V.call(q,z)},null,H))}C.forEach=s;function r(M,$){return o((V,q=null,H)=>M(z=>$(z)&&V.call(q,z),null,H))}C.filter=r;function t(M){return M}C.signal=t;function i(...M){return($,V=null,q)=>(0,A.combinedDisposable)(...M.map(H=>H(z=>$.call(V,z),null,q)))}C.any=i;function n(M,$,V){let q=V;return f(M,H=>(q=$(q,H),q))}C.reduce=n;function o(M){let $;const V=new y({onFirstListenerAdd(){$=M(V.fire,V)},onLastListenerRemove(){$.dispose()}});return V.event}C.snapshot=o;function a(M,$,V=100,q=!1,H){let z,I,T,F=0;const N=new y({leakWarningThreshold:H,onFirstListenerAdd(){z=M(x=>{F++,I=$(I,x),q&&!T&&(N.fire(I),I=void 0),clearTimeout(T),T=setTimeout(()=>{const G=I;I=void 0,T=void 0,(!q||F>1)&&N.fire(G),F=0},V)})},onLastListenerRemove(){z.dispose()}});return N.event}C.debounce=a;function l(M){const $=new Date().getTime();return f(D(M),V=>new Date().getTime()-$)}C.stopwatch=l;function u(M){let $=!0,V;return r(M,q=>{const H=$||q!==V;return $=!1,V=q,H})}C.latch=u;function d(M,$=!1,V=[]){let q=V.slice(),H=M(T=>{q?q.push(T):I.fire(T)});const z=()=>{q&&q.forEach(T=>I.fire(T)),q=null},I=new y({onFirstListenerAdd(){H||(H=M(T=>I.fire(T)))},onFirstListenerDidAdd(){q&&($?setTimeout(z):z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return I.event}C.buffer=d;class E{constructor($){this.event=$}map($){return new E(f(this.event,$))}forEach($){return new E(s(this.event,$))}filter($){return new E(r(this.event,$))}reduce($,V){return new E(n(this.event,$,V))}latch(){return new E(u(this.event))}debounce($,V=100,q=!1,H){return new E(a(this.event,$,V,q,H))}on($,V,q){return this.event($,V,q)}once($,V,q){return D(this.event)($,V,q)}}function h(M){return new E(M)}C.chain=h;function P(M,$,V=q=>q){const q=(...T)=>I.fire(V(...T)),H=()=>M.on($,q),z=()=>M.removeListener($,q),I=new y({onFirstListenerAdd:H,onLastListenerRemove:z});return I.event}C.fromNodeEventEmitter=P;function _(M,$,V=q=>q){const q=(...T)=>I.fire(V(...T)),H=()=>M.addEventListener($,q),z=()=>M.removeEventListener($,q),I=new y({onFirstListenerAdd:H,onLastListenerRemove:z});return I.event}C.fromDOMEventEmitter=_;function j(M){const $=new y;let V=!1;return M.then(void 0,()=>null).then(()=>{V?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),V=!0,$.event}C.fromPromise=j;function B(M){return new Promise($=>D(M)($))}C.toPromise=B})(O=e.Event||(e.Event={}));class m{constructor(D){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${D}_${m._idPool++}`}start(D){this._stopWatch=new U.StopWatch(!0),this._listenerCount=D}stop(){if(this._stopWatch){const D=this._stopWatch.elapsed();this._elapsedOverall+=D,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${D.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let v=-1;function R(C){const D=v;return v=C,{dispose(){v=D}}}e.setGlobalLeakWarningThreshold=R;class g{constructor(D,f=Math.random().toString(18).slice(2,5)){this.customThreshold=D,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(D){let f=v;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||D<f)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,i=0;for(const[n,o]of this._stacks)(!t||i<o)&&(t=n,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}}class y{constructor(D){var f;this._disposed=!1,this._options=D,this._leakageMon=v>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(D,f,s)=>{var r;this._listeners||(this._listeners=new L.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(f?[D,f]:D);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,D,f);const n=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size);let o;return o={dispose:()=>{n&&n(),o.dispose=y._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof A.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(D){var f,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,D]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,t]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,t):r[0].call(r[1],t)}catch(i){(0,S.onUnexpectedError)(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var D,f,s;(D=this._listeners)===null||D===void 0||D.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(s=this._leakageMon)===null||s===void 0||s.dispose(),this._disposed=!0}}e.Emitter=y,y._noop=function(){};class b extends y{constructor(D){super(D);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=D==null?void 0:D.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const D=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(D))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(D){this._listeners&&(this._isPaused!==0?this._eventQueue.push(D):super.fire(D))}}e.PauseableEmitter=b;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(D){const f={event:D,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const s=()=>{this.hasListeners&&this.unhook(f);const r=this.events.indexOf(f);this.events.splice(r,1)};return(0,A.toDisposable)((0,k.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(D=>this.hook(D))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(D=>this.unhook(D))}hook(D){D.listener=D.event(f=>this.emitter.fire(f))}unhook(D){D.listener&&D.listener.dispose(),D.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class p{constructor(){this.buffers=[]}wrapEvent(D){return(f,s,r)=>D(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>f.call(s,t)):f.call(s,t)},void 0,r)}bufferEvents(D){const f=[];this.buffers.push(f);const s=D();return this.buffers.pop(),f.forEach(r=>r()),s}}e.EventBufferer=p;class w{constructor(){this.listening=!1,this.inputEvent=O.None,this.inputEventListener=A.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(D){this.inputEvent=D,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=D(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(Z[30],ee([0,1,3]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(O,m){const v=setTimeout(O.bind(m),0);return{dispose(){clearTimeout(v)}}});var A;(function(O){function m(v){return v===O.None||v===O.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}O.isCancellationToken=m,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=A.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=U}),define(Z[47],ee([0,1,11,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=A;function L(f){const s=f;return s?A(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=L;function U(f,s){return new O(f,s)}e.newWriteableStream=U;class O{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,S.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(r);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(f,s){const r=[];let t;for(;(t=f.read())!==null;)r.push(t);return s(r)}e.consumeReadable=m;function v(f,s,r){const t=[];let i;for(;(i=f.read())!==null&&t.length<r;)t.push(i);return i===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}e.peekReadable=v;function R(f,s){return new Promise((r,t)=>{const i=[];g(f,{onData:n=>{s&&i.push(n)},onError:n=>{s?t(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}e.consumeStream=R;function g(f,s){f.on("error",r=>s.onError(r)),f.on("end",()=>s.onEnd()),f.on("data",r=>s.onData(r))}e.listenStream=g;function y(f,s){return new Promise((r,t)=>{const i=new k.DisposableStore,n=[],o=u=>{if(n.push(u),n.length>s)return i.dispose(),f.pause(),r({stream:f,buffer:n,ended:!1})},a=u=>t(u),l=()=>r({stream:f,buffer:n,ended:!0});i.add((0,k.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,k.toDisposable)(()=>f.removeListener("end",l))),f.on("end",l),i.add((0,k.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=y;function b(f,s){const r=U(s);return r.end(f),r}e.toStream=b;function c(){const f=U(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=c;function p(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=p;function w(f,s,r){const t=U(r);return g(f,{onData:i=>t.write(s.data(i)),onError:i=>t.error(s.error?s.error(i):i),onEnd:()=>t.end()}),t}e.transform=w;function C(f,s,r){let t=!1;return{read:()=>{const i=s.read();return t?i:(t=!0,i!==null?r([f,i]):f)}}}e.prefixedReadable=C;function D(f,s,r){let t=!1;const i=U(r);return g(s,{onData:n=>t?i.write(n):(t=!0,i.write(r([f,n]))),onError:n=>i.error(n),onEnd:()=>{t||(t=!0,i.write(f)),i.end()}}),i}e.prefixedStream=D}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function S(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=S;const k=/{(\d+)}/g;function A(W,...te){return te.length===0?W:W.replace(k,function(oe,ae){const le=parseInt(ae,10);return isNaN(le)||le<0||le>=te.length?oe:te[le]})}e.format=A;function L(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=L;function U(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function O(W,te){let oe=0;const ae=te.charCodeAt(0);for(let le=W.length-1;le>=0;le--)W.charCodeAt(le)===ae&&oe++;return oe}e.count=O;function m(W,te,oe="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${oe}`}e.truncate=m;function v(W,te=" "){const oe=R(W,te);return g(oe,te)}e.trim=v;function R(W,te){if(!W||!te)return W;const oe=te.length;if(oe===0||W.length===0)return W;let ae=0;for(;W.indexOf(te,ae)===ae;)ae=ae+oe;return W.substring(ae)}e.ltrim=R;function g(W,te){if(!W||!te)return W;const oe=te.length,ae=W.length;if(oe===0||ae===0)return W;let le=ae,fe=-1;for(;fe=W.lastIndexOf(te,le-1),!(fe===-1||fe+oe!==le);){if(fe===0)return"";le=fe}return W.substring(0,le)}e.rtrim=g;function y(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function b(W){return W.replace(/\*/g,"")}e.stripWildcards=b;function c(W,te,oe={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=U(W)),oe.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(W,ae)}e.createRegExp=c;function p(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function w(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function C(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=C;function D(W){return W.split(/\r\n|\r|\n/)}e.splitLines=D;function f(W){for(let te=0,oe=W.length;te<oe;te++){const ae=W.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=f;function s(W,te=0,oe=W.length){for(let ae=te;ae<oe;ae++){const le=W.charCodeAt(ae);if(le!==32&&le!==9)return W.substring(te,ae)}return W.substring(te,oe)}e.getLeadingWhitespace=s;function r(W,te=W.length-1){for(let oe=te;oe>=0;oe--){const ae=W.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function t(W,te){return W<te?-1:W>te?1:0}e.compare=t;function i(W,te,oe=0,ae=W.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=W.charCodeAt(oe),be=te.charCodeAt(le);if(we<be)return-1;if(we>be)return 1}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstring=i;function n(W,te){return o(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=n;function o(W,te,oe=0,ae=W.length,le=0,fe=te.length){for(;oe<ae&&le<fe;oe++,le++){let we=W.charCodeAt(oe),be=te.charCodeAt(le);if(we!==be){const Pe=we-be;if(!(Pe===32&&l(be))&&!(Pe===-32&&l(we)))return a(we)&&a(be)?Pe:i(W.toLowerCase(),te.toLowerCase(),oe,ae,le,fe)}}const ve=ae-oe,Se=fe-le;return ve<Se?-1:ve>Se?1:0}e.compareSubstringIgnoreCase=o;function a(W){return W>=97&&W<=122}e.isLowerAsciiLetter=a;function l(W){return W>=65&&W<=90}e.isUpperAsciiLetter=l;function u(W){return a(W)||l(W)}function d(W,te){return W.length===te.length&&E(W,te)}e.equalsIgnoreCase=d;function E(W,te,oe=W.length){for(let ae=0;ae<oe;ae++){const le=W.charCodeAt(ae),fe=te.charCodeAt(ae);if(le!==fe){if(u(le)&&u(fe)){const ve=Math.abs(le-fe);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(le).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function h(W,te){const oe=te.length;return te.length>W.length?!1:E(W,te,oe)}e.startsWithIgnoreCase=h;function P(W,te){let oe,ae=Math.min(W.length,te.length);for(oe=0;oe<ae;oe++)if(W.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(W,te){let oe,ae=Math.min(W.length,te.length);const le=W.length-1,fe=te.length-1;for(oe=0;oe<ae;oe++)if(W.charCodeAt(le-oe)!==te.charCodeAt(fe-oe))return oe;return ae}e.commonSuffixLength=_;function j(W){return 55296<=W&&W<=56319}e.isHighSurrogate=j;function B(W){return 56320<=W&&W<=57343}e.isLowSurrogate=B;function M(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=M;function $(W,te,oe){const ae=W.charCodeAt(oe);if(j(ae)&&oe+1<te){const le=W.charCodeAt(oe+1);if(B(le))return M(ae,le)}return ae}e.getNextCodePoint=$;function V(W,te){const oe=W.charCodeAt(te-1);if(B(oe)&&te>1){const ae=W.charCodeAt(te-2);if(j(ae))return M(ae,oe)}return oe}function q(W,te){const oe=se.getInstance(),ae=te,le=W.length,fe=$(W,le,te);te+=fe>=65536?2:1;let ve=oe.getGraphemeBreakType(fe);for(;te<le;){const Se=$(W,le,te),we=oe.getGraphemeBreakType(Se);if(X(ve,we))break;te+=Se>=65536?2:1,ve=we}return te-ae}e.nextCharLength=q;function H(W,te){const oe=se.getInstance(),ae=te,le=V(W,te);te-=le>=65536?2:1;let fe=oe.getGraphemeBreakType(le);for(;te>0;){const ve=V(W,te),Se=oe.getGraphemeBreakType(ve);if(X(Se,fe))break;te-=ve>=65536?2:1,fe=Se}return ae-te}e.prevCharLength=H;function z(W,te){const oe=se.getInstance(),ae=W.length,le=te,fe=$(W,ae,te),ve=oe.getGraphemeBreakType(fe);te+=fe>=65536?2:1;let Se=ve;for(;te<ae;){const be=$(W,ae,te),Pe=oe.getGraphemeBreakType(be);if(X(Se,Pe))break;te+=be>=65536?2:1,Se=Pe}const we=te;for(te=le,Se=ve;te>0;){const be=V(W,te),Pe=oe.getGraphemeBreakType(be);if(X(Pe,Se))break;te-=be>=65536?2:1,Se=Pe}return[te,we]}function I(W,te){return te>0&&B(W.charCodeAt(te))?z(W,te-1):z(W,te)}e.getCharContainingOffset=I;function T(W){const te=W.length;let oe=0,ae=0;for(;ae<te;){const ve=$(W,te,ae);ae+=ve>=65536?2:1,ve<128?oe+=1:ve<2048?oe+=2:ve<65536?oe+=3:oe+=4}const le=new Uint8Array(oe);ae=0;let fe=0;for(;ae<te;){const ve=$(W,te,ae);ae+=ve>=65536?2:1,ve<128?le[fe++]=ve:ve<2048?(le[fe++]=192|(ve&1984)>>>6,le[fe++]=128|(ve&63)>>>0):ve<65536?(le[fe++]=224|(ve&61440)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0):(le[fe++]=240|(ve&1835008)>>>18,le[fe++]=128|(ve&258048)>>>12,le[fe++]=128|(ve&4032)>>>6,le[fe++]=128|(ve&63)>>>0)}return le}e.encodeUTF8=T;function F(W){const te=W.byteLength,oe=[];let ae=0;for(;ae<te;){const le=W[ae];let fe;if(le>=240&&ae+3<te?fe=(W[ae++]&7)<<18>>>0|(W[ae++]&63)<<12>>>0|(W[ae++]&63)<<6>>>0|(W[ae++]&63)<<0>>>0:le>=224&&ae+2<te?fe=(W[ae++]&15)<<12>>>0|(W[ae++]&63)<<6>>>0|(W[ae++]&63)<<0>>>0:le>=192&&ae+1<te?fe=(W[ae++]&31)<<6>>>0|(W[ae++]&63)<<0>>>0:fe=W[ae++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)oe.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ve=fe-65536,Se=55296+((ve&1047552)>>>10),we=56320+((ve&1023)>>>0);oe.push(String.fromCharCode(Se)),oe.push(String.fromCharCode(we))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(W){return N.test(W)}e.containsRTL=x;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(W){return G.test(W)}e.containsEmoji=J;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(W){return Q.test(W)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=ie;function ce(W){for(let te=0,oe=W.length;te<oe;te++)if(ue(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ue;function ge(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ge;function Ee(W,te){if(W.length<te)return W;const oe=/\b/g;let ae=0;for(;oe.test(W)&&!(W.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return W.substring(ae).replace(/^\s/,"")}e.lcut=Ee;const Ie=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function Ue(W){return W&&(W=W.replace(Ie,""),W=W.replace(Oe,""),W=W.replace(Ae,"")),W}e.removeAnsiEscapeCodes=Ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ne(W){return ke(W)?W.substr(1):W}e.stripUTF8BOM=Ne;function De(W,te){if(!W||!te||W.length<te.length)return!1;const oe=te.length,ae=W.toLowerCase();let le=0,fe=-1;for(;le<oe;){const ve=ae.indexOf(te[le],fe+1);if(ve<0)return!1;fe=ve,le++}return!0}e.fuzzyContains=De;function Te(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Te;function Ge(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=Ge;function Ke(W,te=1){if(te===0)return"";let oe=-1;do oe=W.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?W:(W[oe-1]==="\r"&&oe--,W.substr(0,oe))}e.getNLines=Ke;function $e(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=$e;function ze(W){return se.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ze;function X(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=X;var re;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let le=1;for(;le<=ae;)if(te<oe[3*le])le=2*le;else if(te>oe[3*le+1])le=2*le+1;else return oe[3*le+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Z[23],ee([0,1,21,47]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",L=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let O,m;class v{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return A?new v(Buffer.allocUnsafe(u)):new v(new Uint8Array(u))}static wrap(u){return A&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new v(u)}static fromString(u,d){return!((d==null?void 0:d.dontUseNodeBuffer)||!1)&&A?new v(Buffer.from(u)):L?(O||(O=new TextEncoder),new v(O.encode(u))):new v(S.encodeUTF8(u))}static concat(u,d){if(typeof d=="undefined"){d=0;for(let P=0,_=u.length;P<_;P++)d+=u[P].byteLength}const E=v.alloc(d);let h=0;for(let P=0,_=u.length;P<_;P++){const j=u[P];E.set(j,h),h+=j.byteLength}return E}toString(){return A?this.buffer.toString():U?(m||(m=new TextDecoder),m.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(u,d){return new v(this.buffer.subarray(u,d))}set(u,d){u instanceof v?this.buffer.set(u.buffer,d):this.buffer.set(u,d)}readUInt32BE(u){return y(this.buffer,u)}writeUInt32BE(u,d){b(this.buffer,u,d)}readUInt32LE(u){return c(this.buffer,u)}writeUInt32LE(u,d){p(this.buffer,u,d)}readUInt8(u){return w(this.buffer,u)}writeUInt8(u,d){C(this.buffer,u,d)}}e.VSBuffer=v;function R(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0}e.readUInt16LE=R;function g(l,u,d){l[d+0]=u&255,u=u>>>8,l[d+1]=u&255}e.writeUInt16LE=g;function y(l,u){return l[u]*2**24+l[u+1]*2**16+l[u+2]*2**8+l[u+3]}e.readUInt32BE=y;function b(l,u,d){l[d+3]=u,u=u>>>8,l[d+2]=u,u=u>>>8,l[d+1]=u,u=u>>>8,l[d]=u}e.writeUInt32BE=b;function c(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0|l[u+2]<<16>>>0|l[u+3]<<24>>>0}e.readUInt32LE=c;function p(l,u,d){l[d+0]=u&255,u=u>>>8,l[d+1]=u&255,u=u>>>8,l[d+2]=u&255,u=u>>>8,l[d+3]=u&255}e.writeUInt32LE=p;function w(l,u){return l[u]}e.readUInt8=w;function C(l,u,d){l[d]=u}e.writeUInt8=C;function D(l){return k.consumeReadable(l,u=>v.concat(u))}e.readableToBuffer=D;function f(l){return k.toReadable(l)}e.bufferToReadable=f;function s(l){return k.consumeStream(l,u=>v.concat(u))}e.streamToBuffer=s;async function r(l){return l.ended?v.concat(l.buffer):v.concat([...l.buffer,await s(l.stream)])}e.bufferedStreamToBuffer=r;function t(l){return k.toStream(l,u=>v.concat(u))}e.bufferToStream=t;function i(l){return k.transform(l,{data:u=>typeof u=="string"?v.fromString(u):v.wrap(u)},u=>v.concat(u))}e.streamToBufferReadableStream=i;function n(l){return k.newWriteableStream(u=>v.concat(u),l)}e.newWriteableBufferStream=n;function o(l,u){return k.prefixedReadable(l,u,d=>v.concat(d))}e.prefixedBufferReadable=o;function a(l,u){return k.prefixedStream(l,u,d=>v.concat(d))}e.prefixedBufferStream=a}),define(Z[15],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(u){return Array.isArray(u)}e.isArray=S;function k(u){return typeof u=="string"}e.isString=k;function A(u){return Array.isArray(u)&&u.every(d=>k(d))}e.isStringArray=A;function L(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=L;function U(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=U;function O(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=O;function m(u){return u===!0||u===!1}e.isBoolean=m;function v(u){return typeof u=="undefined"}e.isUndefined=v;function R(u){return!g(u)}e.isDefined=R;function g(u){return v(u)||u===null}e.isUndefinedOrNull=g;function y(u,d){if(!u)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=y;function b(u){if(g(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=b;function c(...u){const d=[];for(let E=0;E<u.length;E++){const h=u[E];if(g(h))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);d.push(h)}return d}e.assertAllDefined=c;const p=Object.prototype.hasOwnProperty;function w(u){if(!L(u))return!1;for(let d in u)if(p.call(u,d))return!1;return!0}e.isEmptyObject=w;function C(u){return typeof u=="function"}e.isFunction=C;function D(...u){return u.length>0&&u.every(C)}e.areFunctions=D;function f(u,d){const E=Math.min(u.length,d.length);for(let h=0;h<E;h++)s(u[h],d[h])}e.validateConstraints=f;function s(u,d){if(k(d)){if(typeof u!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(C(d)){try{if(u instanceof d)return}catch(E){}if(!g(u)&&u.constructor===d||d.length===1&&d.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function r(u){let d=[],E=Object.getPrototypeOf(u);for(;Object.prototype!==E;)d=d.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return d}e.getAllPropertyNames=r;function t(u){const d=[];for(const E of r(u))typeof u[E]=="function"&&d.push(E);return d}e.getAllMethodNames=t;function i(u,d){const E=P=>function(){const _=Array.prototype.slice.call(arguments,0);return d(P,_)};let h={};for(const P of u)h[P]=E(P);return h}e.createProxyObject=i;function n(u){return u===null?void 0:u}e.withNullAsUndefined=n;function o(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=o;function a(u){return class{constructor(){return new Proxy({},{get(d,E){if(d[E])return d[E];throw new Error(`Not Implemented: ${u}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function l(u){throw new Error("Unreachable")}e.assertNever=l}),define(Z[42],ee([0,1,7,21,8,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function U(i){return i===47||i===92}e.isPathSeparator=U;function O(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=O;function m(i,n=A.posix.sep){if(!i)return"";const o=i.length,a=i.charCodeAt(0);if(U(a)){if(U(i.charCodeAt(1))&&!U(i.charCodeAt(2))){let u=3;const d=u;for(;u<o&&!U(i.charCodeAt(u));u++);if(d!==u&&!U(i.charCodeAt(u+1))){for(u+=1;u<o;u++)if(U(i.charCodeAt(u)))return i.slice(0,u+1).replace(/[\\/]/g,n)}}return n}else if(w(a)&&i.charCodeAt(1)===58)return U(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<o;l++)if(U(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=m;function v(i){if(!S.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let o=2;const a=o;for(;o<i.length&&(n=i.charCodeAt(o),n!==92);o++);return!(a===o||(n=i.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=v;const R=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(i,n=S.isWindows){const o=n?R:g;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||n&&y.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=b;function c(i,n,o){const a=i===n;return!o||a?a:!i||!n?!1:(0,k.equalsIgnoreCase)(i,n)}e.isEqual=c;function p(i,n,o,a=A.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let u=n.length;return n.charAt(n.length-1)===a&&u--,i.charAt(u)===a}return n.charAt(n.length-1)!==a&&(n+=a),i.indexOf(n)===0}e.isEqualOrParent=p;function w(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=w;function C(i,n){return S.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(n,i)),i=(0,A.normalize)(i),S.isWindows?(i=(0,k.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,k.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=C;function D(i){const n=(0,A.normalize)(i);return S.isWindows?i.length>3?!1:f(n)&&(i.length===2||n.charCodeAt(2)===92):n===A.posix.sep}e.isRootOrDriveLetter=D;function f(i){return S.isWindows?w(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function s(i){return f(i)?i[0]:void 0}e.getDriveLetter=s;function r(i,n,o){return n.length>i.length?-1:i===n?0:(o&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=r;function t(i){const n=i.split(":");let o,a,l;if(n.forEach(u=>{const d=Number(u);(0,L.isNumber)(d)?a===void 0?a=d:l===void 0&&(l=d):o=o?[o,u].join(":"):u}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:l!==void 0?l:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,15]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.keys(c).forEach(w=>{c[w]&&typeof c[w]=="object"?p[w]=k(c[w]):p[w]=c[w]}),p}e.deepClone=k;function A(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const w=p.shift();Object.freeze(w);for(const C in w)if(L.call(w,C)){const D=w[C];typeof D=="object"&&!Object.isFrozen(D)&&p.push(D)}}return c}e.deepFreeze=A;const L=Object.prototype.hasOwnProperty;function U(c,p){return O(c,p,new Set)}e.cloneAndChange=U;function O(c,p,w){if((0,S.isUndefinedOrNull)(c))return c;const C=p(c);if(typeof C!="undefined")return C;if((0,S.isArray)(c)){const D=[];for(const f of c)D.push(O(f,p,w));return D}if((0,S.isObject)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const D={};for(let f in c)L.call(c,f)&&(D[f]=O(c[f],p,w));return w.delete(c),D}return c}function m(c,p,w=!0){return(0,S.isObject)(c)?((0,S.isObject)(p)&&Object.keys(p).forEach(C=>{C in c?w&&((0,S.isObject)(c[C])&&(0,S.isObject)(p[C])?m(c[C],p[C],w):c[C]=p[C]):c[C]=p[C]}),c):p}e.mixin=m;function v(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let w,C;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(w=0;w<c.length;w++)if(!v(c[w],p[w]))return!1}else{const D=[];for(C in c)D.push(C);D.sort();const f=[];for(C in p)f.push(C);if(f.sort(),!v(D,f))return!1;for(w=0;w<D.length;w++)if(!v(c[D[w]],p[D[w]]))return!1}return!0}e.equals=v;function R(c){const p=new Set;return JSON.stringify(c,(w,C)=>{if((0,S.isObject)(C)||Array.isArray(C)){if(p.has(C))return"[Circular]";p.add(C)}return C})}e.safeStringify=R;function g(c,p,w){const C=p(c);return typeof C=="undefined"?w:C}e.getOrDefault=g;function y(c,p){const w=Object.create(null);return!c||!p||Object.keys(p).forEach(D=>{const f=c[D],s=p[D];v(f,s)||(w[D]=s)}),w}e.distinct=y;function b(c,p){const w=p.toLowerCase(),C=Object.keys(c).find(D=>D.toLowerCase()===w);return C?c[C]:c[p]}e.getCaseInsensitive=b}),define(Z[4],ee([0,1,7,8]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,U=/^\/\//;function O(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,o){return!n&&!o?"file":n}function v(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==g&&(o=g+o):o=g;break}return o}const R="",g="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(o,a,l,u,d,E=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=m(o,E),this.authority=a||R,this.path=v(this.scheme,l||R),this.query=u||R,this.fragment=d||R,O(this,E))}static isUri(o){return o instanceof b?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:l,path:u,query:d,fragment:E}=o;return a===void 0?a=this.scheme:a===null&&(a=R),l===void 0?l=this.authority:l===null&&(l=R),u===void 0?u=this.path:u===null&&(u=R),d===void 0?d=this.query:d===null&&(d=R),E===void 0?E=this.fragment:E===null&&(E=R),a===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&E===this.fragment?this:new p(a,l,u,d,E)}static parse(o,a=!1){const l=y.exec(o);return l?new p(l[2]||R,i(l[4]||R),i(l[5]||R),i(l[7]||R),i(l[9]||R),a):new p(R,R,R,R,R)}static file(o){let a=R;if(S.isWindows&&(o=o.replace(/\\/g,g)),o[0]===g&&o[1]===g){const l=o.indexOf(g,2);l===-1?(a=o.substring(2),o=g):(a=o.substring(2,l),o=o.substring(l)||g)}return new p("file",a,o,R,R)}static from(o){return new p(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return S.isWindows&&o.scheme==="file"?l=b.file(k.win32.join(f(o,!0),...a)).path:l=k.posix.join(o.path,...a),o.with({path:l})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof b)return o;{const a=new p(o);return a._formatted=o.external,a._fsPath=o._sep===c?o.fsPath:null,a}}else return o}}e.URI=b;const c=S.isWindows?1:void 0;class p extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=c),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function C(n,o){let a,l=-1;for(let u=0;u<n.length;u++){const d=n.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||o&&d===47)l!==-1&&(a+=encodeURIComponent(n.substring(l,u)),l=-1),a!==void 0&&(a+=n.charAt(u));else{a===void 0&&(a=n.substr(0,u));const E=w[d];E!==void 0?(l!==-1&&(a+=encodeURIComponent(n.substring(l,u)),l=-1),a+=E):l===-1&&(l=u)}}return l!==-1&&(a+=encodeURIComponent(n.substring(l))),a!==void 0?a:n}function D(n){let o;for(let a=0;a<n.length;a++){const l=n.charCodeAt(a);l===35||l===63?(o===void 0&&(o=n.substr(0,a)),o+=w[l]):o!==void 0&&(o+=n[a])}return o!==void 0?o:n}function f(n,o){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,S.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function s(n,o){const a=o?D:C;let l="",{scheme:u,authority:d,path:E,query:h,fragment:P}=n;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=g,l+=g),d){let _=d.indexOf("@");if(_!==-1){const j=d.substr(0,_);d=d.substr(_+1),_=j.indexOf(":"),_===-1?l+=a(j,!1):(l+=a(j.substr(0,_),!1),l+=":",l+=a(j.substr(_+1),!1)),l+="@"}d=d.toLowerCase(),_=d.indexOf(":"),_===-1?l+=a(d,!1):(l+=a(d.substr(0,_),!1),l+=d.substr(_))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const _=E.charCodeAt(1);_>=65&&_<=90&&(E=`/${String.fromCharCode(_+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const _=E.charCodeAt(0);_>=65&&_<=90&&(E=`${String.fromCharCode(_+32)}:${E.substr(2)}`)}l+=a(E,!0)}return h&&(l+="?",l+=a(h,!1)),P&&(l+="#",l+=o?P:C(P,!1)),l}function r(n){try{return decodeURIComponent(n)}catch(o){return n.length>3?n.substr(0,3)+r(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,o=>r(o)):n}}),define(Z[87],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=k;function A(v){const R=[];let g;try{const y=JSON.parse(v.arguments),b=y[y.length-1];b&&b.__$stack&&(y.pop(),g=b.__$stack),R.push(...y)}catch(y){R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:g}}e.parse=A;function L(v){if(typeof v!="string")return L(A(v).stack);const R=v;if(R){const g=U(R),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=L;function U(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function O(v,R){const{args:g,stack:y}=A(v),b=typeof g[0]=="string"&&g.length===1;let c=U(y);c&&(c=`(${c.trim()})`);let p=[];if(typeof g[0]=="string"?c&&b?p=[`%c[${R}] %c${g[0]} %c${c}`,m("blue"),m(""),m("grey")]:p=[`%c[${R}] %c${g[0]}`,m("blue"),m(""),...g.slice(1)]:p=[`%c[${R}]%`,m("blue"),...g],c&&!b&&p.push(c),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,p)}e.log=O;function m(v){return`color: ${v}`}});var lt=this&&this.__classPrivateFieldSet||function(K,e,S,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!A:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(K,S):A?A.value=S:e.set(K,S),S},je=this&&this.__classPrivateFieldGet||function(K,e,S,k){if(S==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?k:S==="a"?k.call(K):k?k.value:e.get(K)};define(Z[37],ee([0,1,4,21]),function(K,e,S,k){"use strict";var A,L,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function O(t,i,n){let o=t.get(i);return o===void 0&&(o=n,t.set(i,o)),o}e.getOrSet=O;function m(t){const i=[];return t.forEach((n,o)=>{i.push(`${o} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=m;function v(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=v;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return n-o}value(){return this._value[this._pos]}}e.StringIterator=R;class g{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class y{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class p{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(i){this._iter=i}static forUris(i=()=>!1){return new w(new c(i))}static forPaths(){return new w(new y)}static forStrings(){return new w(new R)}static forConfigKeys(){return new w(new g)}clear(){this._root=void 0}set(i,n){const o=this._iter.reset(i);let a;for(this._root||(this._root=new p,this._root.segment=o.value()),a=this._root;;){const u=o.cmp(a.segment);if(u>0)a.left||(a.left=new p,a.left.segment=o.value()),a=a.left;else if(u<0)a.right||(a.right=new p,a.right.segment=o.value()),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new p,a.mid.segment=o.value()),a=a.mid;else break}const l=a.value;return a.value=n,a.key=i,l}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const a=n.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const o=this._iter.reset(i),a=[];let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)a.push([1,l]),l=l.left;else if(u<0)a.push([-1,l]),l=l.right;else if(o.hasNext())o.next(),a.push([0,l]),l=l.mid;else{for(n?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;a.length>0&&l.isEmpty();){let[d,E]=a.pop();switch(d){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}l=E}break}}}findSubstr(i){const n=this._iter.reset(i);let o=this._root,a;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const a=n.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[n,o]of this)i(o,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=w;class C{constructor(i,n){this[A]="ResourceMap",i instanceof C?(this.map=new Map(i.map),this.toKey=n!=null?n:C.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:C.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[o,a]of this.map)i(a,S.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield S.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[S.URI.parse(i[0]),i[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[S.URI.parse(i[0]),i[1]]}}e.ResourceMap=C,C.defaultToKey=t=>t.toString();var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class f{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const o=this._map.get(i);if(!!o)return n!==0&&this.touch(o,n),o.value}set(i,n,o=0){let a=this._map.get(i);if(a)a.value=n,o!==0&&this.touch(a,o);else{switch(a={key:i,value:n,next:void 0,previous:void 0},o){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,n){const o=this._state;let a=this._head;for(;a;){if(n?i.bind(n)(a.value,a.key,this):i(a.value,a.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.key,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return a}values(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.value,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return a}entries(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:[o.key,o.value],done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return a}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let n=this._head,o=this.size;for(;n&&o>i;)this._map.delete(n.key),n=n.next,o--;this._head=n,this._size=o,n&&(n.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,o=i.previous;if(!n||!o)throw new Error("Invalid list");n.previous=o,o.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const o=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(o.previous=a,a.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const o=i.next,a=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=a,a.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,o)=>{i.push([o,n])}),i}fromJSON(i){this.clear();for(const[n,o]of i)this.set(n,o)}}e.LinkedMap=f;class s extends f{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class r{constructor(i){U.set(this,void 0),lt(this,U,i,"f")}get size(){return je(this,U,"f").size}forEach(i,n){je(this,U,"f").forEach(i,n)}get(i){return je(this,U,"f").get(i)}has(i){return je(this,U,"f").has(i)}entries(){return je(this,U,"f").entries()}keys(){return je(this,U,"f").keys()}values(){return je(this,U,"f").values()}[(U=new WeakMap,Symbol.iterator)](){return je(this,U,"f").entries()}}e.ReadonlyMapView=r}),define(Z[88],ee([0,1,23,21,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(v){return JSON.stringify(v,O)}e.stringify=L;function U(v){let R=JSON.parse(v);return R=m(R),R}e.parse=U;function O(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,k.regExpFlags)(R)}:R}function m(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return A.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof S.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let g=0;g<v.length;++g)v[g]=m(v[g],R+1);else for(const g in v)Object.hasOwnProperty.call(v,g)&&(v[g]=m(v[g],R+1))}return v}e.revive=m}),define(Z[16],ee([0,1,4,7]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(O){O.inMemory="inmemory",O.vscode="vscode",O.internal="private",O.walkThrough="walkThrough",O.walkThroughSnippet="walkThroughSnippet",O.http="http",O.https="https",O.file="file",O.mailto="mailto",O.untitled="untitled",O.data="data",O.command="command",O.vscodeRemote="vscode-remote",O.vscodeRemoteResource="vscode-remote-resource",O.userData="vscode-userdata",O.vscodeCustomEditor="vscode-custom-editor",O.vscodeNotebook="vscode-notebook",O.vscodeNotebookCell="vscode-notebook-cell",O.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",O.vscodeSettings="vscode-settings",O.vscodeWorkspaceTrust="vscode-workspace-trust",O.vscodeTerminal="vscode-terminal",O.webviewPanel="webview-panel",O.vscodeWebview="vscode-webview",O.extension="extension",O.vscodeFileResource="vscode-file",O.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,v,R){this._hosts[m]=v,this._ports[m]=R}setConnectionToken(m,v){this._connectionTokens[m]=v}rewrite(m){if(this._delegate)return this._delegate(m);const v=m.authority;let R=this._hosts[v];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const g=this._ports[v],y=this._connectionTokens[v];let b=`path=${encodeURIComponent(m.path)}`;return typeof y=="string"&&(b+=`&tkn=${encodeURIComponent(y)}`),S.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${g}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new L;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(m,v,R){const g=this.toUri(m,v);return g.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(g):k.isNative&&(R||k.isPreferringBrowserCodeLoad)&&g.scheme===A.file?g.with({scheme:A.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(m,v){const R=this.toUri(m,v);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(m,v){return S.URI.isUri(m)?m:S.URI.parse(v.toUrl(m))}}e.FileAccess=new U}),define(Z[65],ee([0,1,37]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new S.LRUCache(1e4);function A(v){return m(v,"NFC",k)}e.normalizeNFC=A;const L=new S.LRUCache(1e4);function U(v){return m(v,"NFD",L)}e.normalizeNFD=U;const O=/[^\u0000-\u0080]/;function m(v,R,g){if(!e.canNormalize||!v)return v;const y=g.get(v);if(y)return y;let b;return O.test(v)?b=v.normalize(R):b=v,g.set(v,b),b}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(R){return U(R).replace(v,"")}}else return function(v){return v}}()}),define(Z[12],ee([0,1,42,8,4,21,16,7]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=m;class v{constructor(c){this._ignorePathCasing=c}compare(c,p,w=!1){return c===p?0:(0,L.compare)(this.getComparisonKey(c,w),this.getComparisonKey(p,w))}isEqual(c,p,w=!1){return c===p?!0:!c||!p?!1:this.getComparisonKey(c,w)===this.getComparisonKey(p,w)}getComparisonKey(c,p=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,p,w=!1){if(c.scheme===p.scheme){if(c.scheme===U.Schemas.file)return S.isEqualOrParent(m(c),m(p),this._ignorePathCasing(c))&&c.query===p.query&&(w||c.fragment===p.fragment);if((0,e.isEqualAuthority)(c.authority,p.authority))return S.isEqualOrParent(c.path,p.path,this._ignorePathCasing(c),"/")&&c.query===p.query&&(w||c.fragment===p.fragment)}return!1}joinPath(c,...p){return A.URI.joinPath(c,...p)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return k.posix.basename(c.path)}extname(c){return k.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let p;return c.scheme===U.Schemas.file?p=A.URI.file(k.dirname(m(c))).path:(p=k.posix.dirname(c.path),c.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),p="/")),c.with({path:p})}normalizePath(c){if(!c.path.length)return c;let p;return c.scheme===U.Schemas.file?p=A.URI.file(k.normalize(m(c))).path:p=k.posix.normalize(c.path),c.with({path:p})}relativePath(c,p){if(!(c.scheme!==p.scheme||!(0,e.isEqualAuthority)(c.authority,p.authority))){if(c.scheme===U.Schemas.file){const D=k.relative(m(c),m(p));return O.isWindows?S.toSlashes(D):D}let w=c.path||"/",C=p.path||"/";if(this._ignorePathCasing(c)){let D=0;for(const f=Math.min(w.length,C.length);D<f&&!(w.charCodeAt(D)!==C.charCodeAt(D)&&w.charAt(D).toLowerCase()!==C.charAt(D).toLowerCase());D++);w=C.substr(0,D)+w.substr(D)}return k.posix.relative(w,C)}}resolvePath(c,p){if(c.scheme===U.Schemas.file){const w=A.URI.file(k.resolve(m(c),p));return c.with({authority:w.authority,path:w.path})}return p.indexOf("/")===-1&&(p=S.toSlashes(p),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p)),c.with({path:k.posix.resolve(c.path,p)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,p){return c===p||(0,L.equalsIgnoreCase)(c,p)}hasTrailingPathSeparator(c,p=k.sep){if(c.scheme===U.Schemas.file){const w=m(c);return w.length>S.getRoot(w).length&&w[w.length-1]===p}else{const w=c.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,p=k.sep){return(0,e.hasTrailingPathSeparator)(c,p)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,p=k.sep){let w=!1;if(c.scheme===U.Schemas.file){const C=m(c);w=C!==void 0&&C.length===S.getRoot(C).length&&C[C.length-1]===p}else{p="/";const C=c.path;w=C.length===1&&C.charCodeAt(C.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(c,p)?c.with({path:c.path+"/"}):c}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(b=>b.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new v(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(b,c){const p=[];for(let w=0;w<b.length;w++){const C=c(b[w]);b.some((D,f)=>f===w?!1:(0,e.isEqualOrParent)(C,c(D)))||p.push(b[w])}return p}e.distinctParents=R;var g;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function c(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[s,r]=f.split(":");s&&r&&w.set(s,r)});const D=p.path.substring(0,p.path.indexOf(";"));return D&&w.set(b.META_DATA_MIME,D),w}b.parseMetaData=c})(g=e.DataUri||(e.DataUri={}));function y(b,c,p){if(c){let w=b.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),b.with({scheme:p,authority:c,path:w})}return b.with({scheme:p})}e.toLocalResource=y}),define(Z[6],ee([0,1,30,11,3,2,64,12]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(z){return!!z&&typeof z.then=="function"}e.isThenable=m;function v(z){const I=new S.CancellationTokenSource,T=z(I.token),F=new Promise((N,x)=>{I.token.onCancellationRequested(()=>{x((0,k.canceled)())}),Promise.resolve(T).then(G=>{I.dispose(),N(G)},G=>{I.dispose(),x(G)})});return new class{cancel(){I.cancel()}then(N,x){return F.then(N,x)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=v;function R(z,I,T){return Promise.race([z,new Promise(F=>I.onCancellationRequested(()=>F(T)))])}e.raceCancellation=R;async function g(z){let I=-1;const T=z.map((N,x)=>N.then(G=>(I=x,G))),F=await Promise.race(T);return z.forEach((N,x)=>{x!==I&&N.cancel()}),F}e.raceCancellablePromises=g;function y(z,I,T){let F;const N=setTimeout(()=>{F==null||F(void 0),T==null||T()},I);return Promise.race([z.finally(()=>clearTimeout(N)),new Promise(x=>F=x)])}e.raceTimeout=y;function b(z){return new Promise((I,T)=>{const F=z();m(F)?F.then(I,T):I(F)})}e.asPromise=b;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(I){if(this.activePromise){if(this.queuedPromiseFactory=I,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(T,T).then(F)})}return new Promise((T,F)=>{this.queuedPromise.then(T,F)})}return this.activePromise=I(),new Promise((T,F)=>{this.activePromise.then(N=>{this.activePromise=null,T(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=c;class p{constructor(){this.current=Promise.resolve(null)}queue(I){return this.current=this.current.then(()=>I(),()=>I())}}e.Sequencer=p;class w{constructor(){this.promiseMap=new Map}queue(I,T){var F;const x=((F=this.promiseMap.get(I))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(I)===x&&this.promiseMap.delete(I)});return this.promiseMap.set(I,x),x}}e.SequencerByKey=w;class C{constructor(I){this.defaultDelay=I,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(I,T=this.defaultDelay){return this.task=I,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=C;class D{constructor(I){this.delayer=new C(I),this.throttler=new c}trigger(I,T){return this.delayer.trigger(()=>this.throttler.queue(I),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class f{constructor(){this._isOpen=!1,this._promise=new Promise((I,T)=>{this._completePromise=I})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class s extends f{constructor(I){super();this._timeout=setTimeout(()=>this.open(),I)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(z,I){return I?new Promise((T,F)=>{const N=setTimeout(T,z);I.onCancellationRequested(()=>{clearTimeout(N),F((0,k.canceled)())})}):v(T=>r(z,T))}e.timeout=r;function t(z,I=0){const T=setTimeout(z,I);return(0,L.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=t;function i(z){return z.then(void 0,I=>{})}e.ignoreErrors=i;function n(z){const I=[];let T=0;const F=z.length;function N(){return T<F?z[T++]():null}function x(G){G!=null&&I.push(G);const J=N();return J?J.then(x):Promise.resolve(I)}return Promise.resolve(null).then(x)}e.sequence=n;function o(z,I=F=>!!F,T=null){let F=0;const N=z.length,x=()=>{if(F>=N)return Promise.resolve(T);const G=z[F++];return Promise.resolve(G()).then(Q=>I(Q)?Promise.resolve(Q):x())};return x()}e.first=o;function a(z,I=F=>!!F,T=null){if(z.length===0)return Promise.resolve(T);let F=z.length;const N=()=>{var x,G;F=-1;for(const J of z)(G=(x=J).cancel)===null||G===void 0||G.call(x)};return new Promise((x,G)=>{for(const J of z)J.then(Q=>{--F>=0&&I(Q)?(N(),x(Q)):F===0&&x(T)}).catch(Q=>{--F>=0&&(N(),G(Q))})})}e.firstParallel=a;class l{constructor(I){this._size=0,this.maxDegreeOfParalellism=I,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(I){return this._size++,new Promise((T,F)=>{this.outstandingPromises.push({factory:I,c:T,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const I=this.outstandingPromises.shift();this.runningPromises++;const T=I.factory();T.then(I.c,I.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class u extends l{constructor(){super(1)}}e.Queue=u;class d{constructor(){this.queues=new Map}queueFor(I,T=O.extUri){const F=T.getComparisonKey(I);let N=this.queues.get(F);return N||(N=new u,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(I=>I.dispose()),this.queues.clear()}}e.ResourceQueue=d;class E{constructor(I,T){this._token=-1,typeof I=="function"&&typeof T=="number"&&this.setIfNotSet(I,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(I,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,I()},T)}setIfNotSet(I,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,I()},T))}}e.TimeoutTimer=E;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(I,T){this.cancel(),this._token=setInterval(()=>{I()},T)}}e.IntervalTimer=h;class P{constructor(I,T){this.timeoutToken=-1,this.runner=I,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(I=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,I)}get delay(){return this.timeout}set delay(I){this.timeout=I}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(I,T){super(I,T);this.units=[]}work(I){this.units.push(I),this.isScheduled()||this.schedule()}doRun(){const I=this.units;this.units=[],this.runner&&this.runner(I)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=I=>{const T=setTimeout(()=>I(z));let F=!1;return{dispose(){F||(F=!0,clearTimeout(T))}}}}else e.runWhenIdle=(z,I)=>{const T=requestIdleCallback(z,typeof I=="number"?{timeout:I}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(T))}}}}();class j{constructor(I){this._didRun=!1,this._executor=()=>{try{this._value=I()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function B(z,I,T){let F;for(let N=0;N<T;N++)try{return await z()}catch(x){F=x,await r(I)}throw F}e.retry=B;class M{hasPending(I){return this._pending?typeof I=="number"?this._pending.taskId===I:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var I;(I=this._pending)===null||I===void 0||I.cancel()}setPending(I,T,F){return this._pending={taskId:I,cancel:()=>F==null?void 0:F(),promise:T},T.then(()=>this.donePending(I),()=>this.donePending(I)),T}donePending(I){this._pending&&I===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const I=this._next;this._next=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}setNext(I){if(this._next)this._next.run=I;else{let T,F;const N=new Promise((x,G)=>{T=x,F=G});this._next={run:I,promise:N,promiseResolve:T,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class ${constructor(I){this.interval=I,this.lastIncrementTime=0,this.value=0}increment(){const I=Date.now();return I-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=I,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((I,T)=>{this.completeCallback=I,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(I){return new Promise(T=>{this.completeCallback(I),this.resolved=!0,T()})}error(I){return new Promise(T=>{this.errorCallback(I),this.rejected=!0,T()})}cancel(){new Promise(I=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,I()})}}e.DeferredPromise=V;class q extends A.Emitter{async fireAsync(I,T,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,I]);for(;this._asyncDeliveryQueue.size>0&&!T.isCancellationRequested;){const[N,x]=this._asyncDeliveryQueue.shift(),G=[],J=Object.assign(Object.assign({},x),{waitUntil:Q=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),G.push(Q)}});try{typeof N=="function"?N.call(void 0,J):N[0].call(N[1],J)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(G),await H.settled(G).catch(Q=>(0,k.onUnexpectedError)(Q))}}}}e.AsyncEmitter=q;var H;(function(z){async function I(x){return typeof Promise.allSettled=="function"?T(x):F(x)}z.allSettled=I;async function T(x){return Promise.allSettled(x)}async function F(x){return Promise.all(x.map(G=>G.then(J=>({status:"fulfilled",value:J}),J=>({status:"rejected",reason:J}))))}async function N(x){let G;const J=await Promise.all(x.map(Q=>Q.then(ne=>ne,ne=>{G||(G=ne)})));if(typeof G!="undefined")throw G;return J}z.settled=N})(H=e.Promises||(e.Promises={}))}),define(Z[89],ee([0,1,21,42,8,37,6]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function O(){return Object.create(null)}e.getEmptyExpression=O;const m="**",v="/",R="[/\\\\]",g="[^/\\\\]",y=/\//g;function b(T){switch(T){case 0:return"";case 1:return`${g}*?`;default:return`(?:${R}|${g}+${R}|${R}${g}+)*?`}}function c(T,F){if(!T)return[];const N=[];let x=!1,G=!1,J="";for(const Q of T){switch(Q){case F:if(!x&&!G){N.push(J),J="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":G=!0;break;case"]":G=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=c;function p(T){if(!T)return"";let F="";const N=c(T,v);if(N.every(x=>x===m))F=".*";else{let x=!1;N.forEach((G,J)=>{if(G===m){x||(F+=b(2),x=!0);return}let Q=!1,ne="",ie=!1,ce="";for(const ue of G){if(ue!=="}"&&Q){ne+=ue;continue}if(ie&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===v?ge="":ge=S.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${c(ne,",").map(Ie=>p(Ie)).join("|")})`,Q=!1,ne="";break;case"]":F+="["+ce+"]",ie=!1,ce="";break;case"?":F+=g;continue;case"*":F+=b(1);continue;default:F+=S.escapeRegExpCharacters(ue)}}J<N.length-1&&(N[J+1]!==m||J+2<N.length)&&(F+=R),x=!1})}return F}const w=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(T,F){if(!T)return n;let N;typeof T!="string"?N=T.pattern:N=T,N=N.trim();const x=`${N}_${!!F.trimForExclusions}`;let G=t.get(x);if(G)return a(G,T);let J;if(w.test(N)){const Q=N.substr(4);G=function(ne,ie){return typeof ne=="string"&&ne.endsWith(Q)?N:null}}else(J=C.exec(l(N,F)))?G=u(J[1],N):(F.trimForExclusions?f:D).test(N)?G=d(N,F):(J=s.exec(l(N,F)))?G=E(J[1].substr(1),N,!0):(J=r.exec(l(N,F)))?G=E(J[1],N,!1):G=h(N);return t.set(x,G),a(G,T)}function a(T,F){return typeof F=="string"?T:function(N,x){return k.isEqualOrParent(N,F.base)?T(A.relative(F.base,N),x):null}}function l(T,F){return F.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function u(T,F){const N=`/${T}`,x=`\\${T}`,G=function(Q,ne){return typeof Q!="string"?null:ne?ne===T?F:null:Q===T||Q.endsWith(N)||Q.endsWith(x)?F:null},J=[T];return G.basenames=J,G.patterns=[F],G.allBasenames=J,G}function d(T,F){const N=I(T.slice(1,-1).split(",").map(ne=>o(ne,F)).filter(ne=>ne!==n),T),x=N.length;if(!x)return n;if(x===1)return N[0];const G=function(ne,ie){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ne,ie))return T;return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function E(T,F,N){const x=A.sep===A.posix.sep,G=x?T:T.replace(y,A.sep),J=A.sep+G,Q=A.posix.sep+T,ne=N?function(ie,ce){return typeof ie=="string"&&(ie===G||ie.endsWith(J)||!x&&(ie===T||ie.endsWith(Q)))?F:null}:function(ie,ce){return typeof ie=="string"&&(ie===G||!x&&ie===T)?F:null};return ne.allPaths=[(N?"*/":"./")+T],ne}function h(T){try{const F=new RegExp(`^${p(T)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?T:null}}catch(F){return n}}function P(T,F,N){return!T||typeof F!="string"?!1:_(T)(F,void 0,N)}e.match=P;function _(T,F={}){if(!T)return i;if(typeof T=="string"||$(T)){const N=o(T,F);if(N===n)return i;const x=function(G,J){return!!N(G,J)};return N.allBasenames&&(x.allBasenames=N.allBasenames),N.allPaths&&(x.allPaths=N.allPaths),x}return H(T,F)}e.parse=_;function j(T){if(!!T){let F;return N=>(F||(F=(T()||Promise.resolve([])).then(x=>x?M(x):{})),F.then(x=>!!x[N]))}}e.hasSiblingPromiseFn=j;function B(T){if(!!T){let F;return N=>{if(!F){const x=T();F=x?M(x):{}}return!!F[N]}}}e.hasSiblingFn=B;function M(T){const F={};for(const N of T)F[N]=!0;return F}function $(T){const F=T;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=$;function V(T){return T.allBasenames||[]}e.getBasenameTerms=V;function q(T){return T.allPaths||[]}e.getPathTerms=q;function H(T,F){const N=I(Object.getOwnPropertyNames(T).map(ne=>z(ne,T[ne],F)).filter(ne=>ne!==n)),x=N.length;if(!x)return n;if(!N.some(ne=>!!ne.requiresSiblings)){if(x===1)return N[0];const ne=function(ue,ge){for(let Ee=0,Ie=N.length;Ee<Ie;Ee++){const Oe=N[Ee](ue,ge);if(Oe)return Oe}return null},ie=N.find(ue=>!!ue.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ne.allPaths=ce),ne}const G=function(ne,ie,ce){let ue;for(let ge=0,Ee=N.length;ge<Ee;ge++){const Ie=N[ge];Ie.requiresSiblings&&ce&&(ie||(ie=A.basename(ne)),ue||(ue=ie.substr(0,ie.length-A.extname(ne).length)));const Oe=Ie(ne,ie,ue,ce);if(Oe)return Oe}return null},J=N.find(ne=>!!ne.allBasenames);J&&(G.allBasenames=J.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(G.allPaths=Q),G}function z(T,F,N){if(F===!1)return n;const x=o(T,N);if(x===n)return n;if(typeof F=="boolean")return x;if(F){const G=F.when;if(typeof G=="string"){const J=(Q,ne,ie,ce)=>{if(!ce||!x(Q,ne))return null;const ue=G.replace("$(basename)",ie),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(Ee=>Ee?T:null):ge?T:null};return J.requiresSiblings=!0,J}}return x}function I(T,F){const N=T.filter(ne=>!!ne.basenames);if(N.length<2)return T;const x=N.reduce((ne,ie)=>{const ce=ie.basenames;return ce?ne.concat(ce):ne},[]);let G;if(F){G=[];for(let ne=0,ie=x.length;ne<ie;ne++)G.push(F)}else G=N.reduce((ne,ie)=>{const ce=ie.patterns;return ce?ne.concat(ce):ne},[]);const J=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let ue;for(ue=ne.length;ue>0;ue--){const ge=ne.charCodeAt(ue-1);if(ge===47||ge===92)break}ie=ne.substr(ue)}const ce=x.indexOf(ie);return ce!==-1?G[ce]:null};J.basenames=x,J.patterns=G,J.allBasenames=x;const Q=T.filter(ne=>!ne.basenames);return Q.push(J),Q}}),define(Z[90],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(R){return R.toJSON()}class A{constructor(g){this._uriTransformer=g}transformIncoming(g){const y=this._uriTransformer.transformIncoming(g);return y===g?g:k(S.URI.from(y))}transformOutgoing(g){const y=this._uriTransformer.transformOutgoing(g);return y===g?g:k(S.URI.from(y))}transformOutgoingURI(g){const y=this._uriTransformer.transformOutgoing(g);return y===g?g:S.URI.from(y)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,g,y){if(!R||y>200)return null;if(typeof R=="object"){if(R instanceof S.URI)return g.transformOutgoing(R);for(let b in R)if(Object.hasOwnProperty.call(R,b)){const c=L(R[b],g,y+1);c!==null&&(R[b]=c)}}return null}function U(R,g){const y=L(R,g,0);return y===null?R:y}e.transformOutgoingURIs=U;function O(R,g,y,b){if(!R||b>200)return null;if(typeof R=="object"){if(R.$mid===1)return y?S.URI.revive(g.transformIncoming(R)):g.transformIncoming(R);for(let c in R)if(Object.hasOwnProperty.call(R,c)){const p=O(R[c],g,y,b+1);p!==null&&(R[c]=p)}}return null}function m(R,g){const y=O(R,g,!1,0);return y===null?R:y}e.transformIncomingURIs=m;function v(R,g){const y=O(R,g,!0,0);return y===null?R:y}e.transformAndReviveIncomingURIs=v}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(m){return S.test(m)}e.isUUID=k;const A=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(m){for(let v=0;v<m.length;v++)m[v]=Math.floor(Math.random()*256);return m};function O(){U(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let m=0,v="";return v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+="-",v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v+=L[A[m++]],v}e.generateUuid=O}),define(Z[66],ee([0,1,199]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(L="utf8"){this.stringDecoder=new S.StringDecoder(L),this.remaining=null}write(L){const U=[],O=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(O.length<1)return U;let m=0,v,R=m;for(;R<O.length;)if(v=O.charCodeAt(R),v===13||v===10){if(U.push(O.substring(m,R)),R++,R<O.length){const g=v;v=O.charCodeAt(R),(g===13&&v===10||g===10&&v===13)&&R++}m=R}else R++;return this.remaining=m<O.length?O.substr(m):null,U}end(){return this.remaining}}e.LineDecoder=k}),define(Z[91],ee([0,1,38]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const m=O.replace(/\-/g,":").toLowerCase();return!k.has(m)}function L(){return new Promise(async(O,m)=>{const v=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{O(await U())}catch(R){m(R)}finally{clearTimeout(v)}})}e.getMac=L;function U(){return new Promise((O,m)=>{try{const v=(0,S.networkInterfaces)();for(let R in v){const g=v[R];if(g){for(const{mac:y}of g)if(A(y))return O(y)}}m("Unable to retrieve mac address (unexpected format)")}catch(v){m(v)}})}}),define(Z[92],ee([0,1,11,31,38,37,91]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,g=0;const y=(0,A.networkInterfaces)();for(let b in y){const c=y[b];if(c)for(const{mac:p,internal:w}of c)w||(g+=1,this._isVirtualMachineMacAdress(p.toUpperCase())&&(R+=1))}this._value=g>0?R/g:0}return this._value}};let O;async function m(){return O||(O=(async()=>await v()||k.generateUuid())()),O}e.getMachineId=m;async function v(){try{const R=await new Promise((y,b)=>{K(["crypto"],y,b)}),g=await(0,U.getMac)();return R.createHash("sha256").update(g,"utf8").digest("hex")}catch(R){S.onUnexpectedError(R);return}}}),define(Z[24],ee([0,1,27,38,8,6,7,42,31,65,12,4]),function(K,e,S,k,A,L,U,O,m,v,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var y;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function b(V,q=y.UNLINK){if((0,O.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return q===y.UNLINK?p(V):c(V)}e.rimraf=b;async function c(V){try{const q=(0,A.join)((0,k.tmpdir)(),(0,m.generateUuid)());try{await S.promises.rename(V,q)}catch(H){return p(V)}p(q).catch(H=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function p(V){return S.promises.rmdir(V,{recursive:!0,maxRetries:3})}function w(V){if((0,O.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(V,{recursive:!0})}e.rimrafSync=w;async function C(V,q){return s(await(q?D(V):S.promises.readdir(V)))}e.readdir=C;async function D(V){try{return await S.promises.readdir(V,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const q=[],H=await C(V);for(const z of H){let I=!1,T=!1,F=!1;try{const N=await S.promises.lstat((0,A.join)(V,z));I=N.isFile(),T=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}q.push({name:z,isFile:()=>I,isDirectory:()=>T,isSymbolicLink:()=>F})}return q}function f(V){return s(S.readdirSync(V))}e.readdirSync=f;function s(V){return V.map(q=>typeof q=="string"?U.isMacintosh?(0,v.normalizeNFC)(q):q:(q.name=U.isMacintosh?(0,v.normalizeNFC)(q.name):q.name,q))}async function r(V){const q=await C(V),H=[];for(const z of q)await i.existsDirectory((0,A.join)(V,z))&&H.push(z);return H}e.readDirsInDir=r;function t(V,q=1e3){return new Promise(H=>{let z=!1;const I=setInterval(()=>{z||(z=!0,S.access(V,T=>{z=!1,T&&(clearInterval(I),H(void 0))}))},q)})}e.whenDeleted=t;var i;(function(V){async function q(I){let T;try{if(T=await S.promises.lstat(I),!T.isSymbolicLink())return{stat:T}}catch(F){}try{return{stat:await S.promises.stat(I),symbolicLink:(T==null?void 0:T.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await S.promises.stat(await S.promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw N}throw F}}V.stat=q;async function H(I){try{const{stat:T,symbolicLink:F}=await V.stat(I);return T.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(T){}return!1}V.existsFile=H;async function z(I){try{const{stat:T,symbolicLink:F}=await V.stat(I);return T.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(T){}return!1}V.existsDirectory=z})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new L.ResourceQueue;function o(V,q,H){return n.queueFor(g.URI.file(V),R.extUriBiasedIgnorePathCase).queue(()=>{const z=d(H);return new Promise((I,T)=>l(V,q,z,F=>F?T(F):I()))})}e.writeFile=o;let a=!0;function l(V,q,H,z){if(!a)return S.writeFile(V,q,{mode:H.mode,flag:H.flag},z);S.open(V,H.flag,H.mode,(I,T)=>{if(I)return z(I);S.writeFile(T,q,F=>{if(F)return S.close(T,()=>z(F));S.fdatasync(T,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),a=!1),S.close(T,x=>z(x))))})})}function u(V,q,H){const z=d(H);if(!a)return S.writeFileSync(V,q,{mode:z.mode,flag:z.flag});const I=S.openSync(V,z.flag,z.mode);try{S.writeFileSync(I,q);try{S.fdatasyncSync(I)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),a=!1}}finally{S.closeSync(I)}}e.writeFileSync=u;function d(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function E(V,q){if(V!==q){async function H(z){try{const I=await S.promises.lstat(z);if(I.isDirectory()||I.isSymbolicLink())return;const T=await S.promises.open(z,"a");try{await T.utimes(I.atime,new Date)}finally{await T.close()}}catch(I){}}try{await S.promises.rename(V,q),await H(q)}catch(z){if(V.toLowerCase()!==q.toLowerCase()&&z.code==="EXDEV"||V.endsWith("."))await h(V,q,{preserveSymlinks:!1}),await b(V,y.MOVE),await H(q);else throw z}}}e.move=E;async function h(V,q,H){return _(V,q,{root:{source:V,target:q},options:H,handledSourcePaths:new Set})}e.copy=h;const P=511;async function _(V,q,H){if(!H.handledSourcePaths.has(V)){H.handledSourcePaths.add(V);const{stat:z,symbolicLink:I}=await i.stat(V);if(I){if(H.options.preserveSymlinks)try{return await M(V,q,H)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(I.dangling)return}return z.isDirectory()?j(V,q,z.mode&P,H):B(V,q,z.mode&P)}}async function j(V,q,H,z){await S.promises.mkdir(q,{recursive:!0,mode:H});const I=await C(V);for(const T of I)await _((0,A.join)(V,T),(0,A.join)(q,T),z)}async function B(V,q,H){await S.promises.copyFile(V,q),await S.promises.chmod(q,H)}async function M(V,q,H){let z=await S.promises.readlink(V);(0,O.isEqualOrParent)(z,H.root.source,!U.isLinux)&&(z=(0,A.join)(H.root.target,z.substr(H.root.source.length+1))),await S.promises.symlink(z,q)}async function $(V){try{return await S.promises.access(V),!0}catch(q){return!1}}e.exists=$}),define(Z[93],ee([0,1,27,94,21,8,24]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(g){const y=(0,L.dirname)(g);if(g===y)return g;const b=((0,L.basename)(g)||g).toLowerCase();try{const p=(0,U.readdirSync)(y).filter(w=>w.toLowerCase()===b);if(p.length===1){const w=O(y);if(w)return(0,L.join)(w,p[0])}else if(p.length>1){const w=p.indexOf(b);if(w>=0){const C=O(y);if(C)return(0,L.join)(C,p[w])}}}catch(c){}return null}e.realcaseSync=O;async function m(g){try{return await(0,k.promisify)(S.realpath)(g)}catch(y){const b=R(g);return await S.promises.access(b,S.constants.R_OK),b}}e.realpath=m;function v(g){try{return S.realpathSync(g)}catch(y){const b=R(g);return S.accessSync(b,S.constants.R_OK),b}}e.realpathSync=v;function R(g){return(0,A.rtrim)((0,L.normalize)(g),L.sep)}}),define(Z[95],ee([0,1,48,16]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(U){return new Promise((O,m)=>{let v;const R=new Map;function g(c,p,w,C,D){const f=R.get(p);if(c===U||f){const s={name:y(w),cmd:w,pid:c,ppid:p,load:C,mem:D};R.set(c,s),c===U&&(v=s),f&&(f.children||(f.children=[]),f.children.push(s),f.children.length>1&&(f.children=f.children.sort((r,t)=>r.pid-t.pid)))}}function y(c){const p=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,C=/--crashes-directory/,D=/\\pipe\\winpty-control/,f=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(w.exec(c))return"watcherService ";if(C.exec(c))return"electron-crash-reporter";if(D.exec(c))return"winpty-process";if(f.exec(c))return"console-window-host (Windows internal process)";let r=s.exec(c);if(r&&r.length===2)return r[1]==="renderer"?p.exec(c)?"shared-process":"window":r[1];const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(c),r&&(i+=r+" ");while(r);return i&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron_node ${i}`:c}if(process.platform==="win32"){const c=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,w)=>{K(["windows-process-tree"],p,w)}).then(p=>{p.getProcessList(U,w=>{p.getProcessCpuUsage(w,C=>{const D=new Map;C.forEach(f=>{const s=c(f.commandLine||"");D.set(f.pid,{name:y(s),cmd:s,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),v=D.get(U),v?(D.forEach(f=>{const s=D.get(f.ppid);s&&(s.children||(s.children=[]),s.children.push(f))}),D.forEach(f=>{f.children&&(f.children=f.children.sort((s,r)=>s.pid-r.pid))}),O(v)):m(new Error(`Root process ${U} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{function b(){let c=[v];const p=[];for(;c.length;){const C=c.shift();C&&(p.push(C.pid),C.children&&(c=c.concat(C.children)))}let w=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);w+=" "+p.join(" "),(0,S.exec)(w,{},(C,D,f)=>{if(C||f)m(C||new Error(f.toString()));else{const s=D.toString().split(`
`);for(let r=0;r<p.length;r++){const t=R.get(p[r]);t.load=parseFloat(s[r])}if(!v){m(new Error(`Root process ${U} not found`));return}O(v)}})}(0,S.exec)("which ps",{},(c,p,w)=>{if(c||w)if(process.platform!=="linux")m(c||new Error(w.toString()));else{const C=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,S.exec)(C,{},(D,f,s)=>{D||s?m(D||new Error(s.toString())):(L(f,g),b())})}else{const C=p.toString().trim(),D="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${C} ${D}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,s,r)=>{f||r&&!r.includes("screen size is bogus")?m(f||new Error(r.toString())):(L(s,g),process.platform==="linux"?b():v?O(v):m(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=A;function L(U,O){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=U.toString().split(`
`);for(const R of v){const g=m.exec(R.trim());g&&g.length===6&&O(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(Z[96],ee([0,1,8,27,7,65,2,24]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function m(g,y,b){return R({path:g,isDirectory:!1},y,b)}e.watchFile=m;function v(g,y,b){return R({path:g,isDirectory:!0},y,b)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function R(g,y,b){const c=(0,S.basename)(g.path),p=new Map;let w=!1,C=[(0,U.toDisposable)(()=>{p.forEach(D=>(0,U.dispose)(D)),p.clear()})];try{const D=(0,k.watch)(g.path);C.push((0,U.toDisposable)(()=>{D.removeAllListeners(),D.close()}));const f=new Set;g.isDirectory&&(0,O.readdir)(g.path).then(s=>s.forEach(r=>f.add(r))),D.on("error",(s,r)=>{w||b(`Failed to watch ${g.path} for changes using fs.watch() (${s}, ${r})`)}),D.on("change",(s,r)=>{if(!w){let t="";if(r&&(t=r.toString(),A.isMacintosh&&(t=(0,L.normalizeNFC)(t))),!(!t||s!=="change"&&s!=="rename")){const i=g.isDirectory?(0,S.join)(g.path,t):g.path;if(g.isDirectory)if(s==="rename"){const n=p.get(i);n&&(0,U.dispose)(n);const o=setTimeout(async()=>{p.delete(i);const a=await(0,O.exists)(i);if(!w){let l;a?f.has(t)?l="changed":(l="added",f.add(t)):(f.delete(t),l="deleted"),y(l,i)}},e.CHANGE_BUFFER_DELAY);p.set(i,(0,U.toDisposable)(()=>clearTimeout(o)))}else{let n;f.has(t)?n="changed":(n="added",f.add(t)),y(n,i)}else if(s==="rename"||t!==c){const n=setTimeout(async()=>{const o=await(0,O.exists)(i);w||(o?(y("changed",i),C=[R(g,y,b)]):y("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(C),C=[(0,U.toDisposable)(()=>clearTimeout(n))]}else y("changed",i)}}})}catch(D){(0,O.exists)(g.path).then(f=>{f&&!w&&b(`Failed to watch ${g.path} for changes using fs.watch() (${D.toString()})`)})}return(0,U.toDisposable)(()=>{w=!0,C=(0,U.dispose)(C)})}}),define(Z[34],ee([0,1,3,2,6,30,11,23,18,15,88,21]),function(K,e,S,k,A,L,U,O,m,v,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function b(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function p(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(w||(w={}));class C{constructor(I){this.buffer=I,this.pos=0}read(I){const T=this.buffer.slice(this.pos,this.pos+I);return this.pos+=T.byteLength,T}}class D{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(I){this.buffers.push(I)}}var f;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(f||(f={}));function s(z){const I=O.VSBuffer.alloc(4);return I.writeUInt32BE(z,0),I}function r(z){return z.read(4).readUInt32BE(0)}function t(z){const I=O.VSBuffer.alloc(1);return I.writeUInt8(z,0),I}const i={Undefined:t(f.Undefined),String:t(f.String),Buffer:t(f.Buffer),VSBuffer:t(f.VSBuffer),Array:t(f.Array),Object:t(f.Object)},n=typeof Buffer!="undefined";function o(z,I){if(typeof I=="undefined")z.write(i.Undefined);else if(typeof I=="string"){const T=O.VSBuffer.fromString(I);z.write(i.String),z.write(s(T.byteLength)),z.write(T)}else if(n&&Buffer.isBuffer(I)){const T=O.VSBuffer.wrap(I);z.write(i.Buffer),z.write(s(T.byteLength)),z.write(T)}else if(I instanceof O.VSBuffer)z.write(i.VSBuffer),z.write(s(I.byteLength)),z.write(I);else if(Array.isArray(I)){z.write(i.Array),z.write(s(I.length));for(const T of I)o(z,T)}else{const T=O.VSBuffer.fromString(JSON.stringify(I));z.write(i.Object),z.write(s(T.byteLength)),z.write(T)}}function a(z){switch(z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return z.read(r(z)).toString();case f.Buffer:return z.read(r(z)).buffer;case f.VSBuffer:return z.read(r(z));case f.Array:{const T=r(z),F=[];for(let N=0;N<T;N++)F.push(a(z));return F}case f.Object:return JSON.parse(z.read(r(z)).toString())}}class l{constructor(I,T,F=null,N=1e3){this.protocol=I,this.ctx=T,this.logger=F,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel(I,T){this.channels.set(I,T),setTimeout(()=>this.flushPendingRequests(I),0)}sendResponse(I){switch(I.type){case 200:{const T=this.send([I.type]);this.logger&&this.logger.logOutgoing(T,0,1,p(I.type));return}case 201:case 202:case 204:case 203:{const T=this.send([I.type,I.id],I.data);this.logger&&this.logger.logOutgoing(T,I.id,1,p(I.type),I.data);return}}}send(I,T=void 0){const F=new D;return o(F,I),o(F,T),this.sendBuffer(F.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(T){return 0}}onRawMessage(I){const T=new C(I),F=a(T),N=a(T),x=F[0];switch(x){case 100:return this.logger&&this.logger.logIncoming(I.byteLength,F[1],1,`${b(x)}: ${F[2]}.${F[3]}`,N),this.onPromise({type:x,id:F[1],channelName:F[2],name:F[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(I.byteLength,F[1],1,`${b(x)}: ${F[2]}.${F[3]}`,N),this.onEventListen({type:x,id:F[1],channelName:F[2],name:F[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(I.byteLength,F[1],1,`${b(x)}`),this.disposeActiveRequest({type:x,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(I.byteLength,F[1],1,`${b(x)}`),this.disposeActiveRequest({type:x,id:F[1]})}}onPromise(I){const T=this.channels.get(I.channelName);if(!T){this.collectPendingRequest(I);return}const F=new L.CancellationTokenSource;let N;try{N=T.call(this.ctx,I.name,I.arg,F.token)}catch(J){N=Promise.reject(J)}const x=I.id;N.then(J=>{this.sendResponse({id:x,data:J,type:201}),this.activeRequests.delete(I.id)},J=>{J instanceof Error?this.sendResponse({id:x,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:x,data:J,type:203}),this.activeRequests.delete(I.id)});const G=(0,k.toDisposable)(()=>F.cancel());this.activeRequests.set(I.id,G)}onEventListen(I){const T=this.channels.get(I.channelName);if(!T){this.collectPendingRequest(I);return}const F=I.id,x=T.listen(this.ctx,I.name,I.arg)(G=>this.sendResponse({id:F,data:G,type:204}));this.activeRequests.set(I.id,x)}disposeActiveRequest(I){const T=this.activeRequests.get(I.id);T&&(T.dispose(),this.activeRequests.delete(I.id))}collectPendingRequest(I){let T=this.pendingRequests.get(I.channelName);T||(T=[],this.pendingRequests.set(I.channelName,T));const F=setTimeout(()=>{console.error(`Unknown channel: ${I.channelName}`),I.type===100&&this.sendResponse({id:I.id,data:{name:"Unknown channel",message:`Channel name '${I.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);T.push({request:I,timeoutTimer:F})}flushPendingRequests(I){const T=this.pendingRequests.get(I);if(T){for(const F of T)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(I)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var u;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(I,T=null){this.protocol=I,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=T}getChannel(I){const T=this;return{call(F,N,x){return T.isDisposed?Promise.reject(U.canceled()):T.requestPromise(I,F,N,x)},listen(F,N){return T.isDisposed?Promise.reject(U.canceled()):T.requestEvent(I,F,N)}}}requestPromise(I,T,F,N=L.CancellationToken.None){const x=this.lastRequestId++,J={id:x,type:100,channelName:I,name:T,arg:F};if(N.isCancellationRequested)return Promise.reject(U.canceled());let Q;return new Promise((ie,ce)=>{if(N.isCancellationRequested)return ce(U.canceled());const ue=()=>{const Oe=Ae=>{switch(Ae.type){case 201:this.handlers.delete(x),ie(Ae.data);break;case 202:this.handlers.delete(x);const Ue=new Error(Ae.data.message);Ue.stack=Ae.data.stack,Ue.name=Ae.data.name,ce(Ue);break;case 203:this.handlers.delete(x),ce(Ae.data);break}};this.handlers.set(x,Oe),this.sendRequest(J)};let ge=null;this.state===w.Idle?ue():(ge=(0,A.createCancelablePromise)(Oe=>this.whenInitialized()),ge.then(()=>{ge=null,ue()}));const Ee=()=>{ge?(ge.cancel(),ge=null):this.sendRequest({id:x,type:101}),ce(U.canceled())},Ie=N.onCancellationRequested(Ee);Q=(0,k.combinedDisposable)((0,k.toDisposable)(Ee),Ie),this.activeRequests.add(Q)}).finally(()=>{this.activeRequests.delete(Q)})}requestEvent(I,T,F){const N=this.lastRequestId++,G={id:N,type:102,channelName:I,name:T,arg:F};let J=null;const Q=new S.Emitter({onFirstListenerAdd:()=>{J=(0,A.createCancelablePromise)(ie=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(Q),this.sendRequest(G)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(Q),this.sendRequest({id:N,type:103}))}}),ne=ie=>Q.fire(ie.data);return this.handlers.set(N,ne),Q.event}sendRequest(I){switch(I.type){case 100:case 102:{const T=this.send([I.type,I.id,I.channelName,I.name],I.arg);this.logger&&this.logger.logOutgoing(T,I.id,0,`${b(I.type)}: ${I.channelName}.${I.name}`,I.arg);return}case 101:case 103:{const T=this.send([I.type,I.id]);this.logger&&this.logger.logOutgoing(T,I.id,0,b(I.type));return}}}send(I,T=void 0){const F=new D;return o(F,I),o(F,T),this.sendBuffer(F.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(T){return 0}}onBuffer(I){const T=new C(I),F=a(T),N=a(T),x=F[0];switch(x){case 200:return this.logger&&this.logger.logIncoming(I.byteLength,0,0,p(x)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(I.byteLength,F[1],0,p(x),N),this.onResponse({type:F[0],id:F[1],data:N})}}onResponse(I){if(I.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const T=this.handlers.get(I.id);T&&T(I)}whenInitialized(){return this.state===w.Idle?Promise.resolve():S.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}e.ChannelClient=d;class E{constructor(I){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,I(({protocol:T,onDidClientDisconnect:F})=>{S.Event.once(T.onMessage)(x=>{const G=new C(x),J=a(G),Q=new l(T,J),ne=new d(T);this.channels.forEach((ce,ue)=>Q.registerChannel(ue,ce));const ie={channelServer:Q,channelClient:ne,ctx:J};this._connections.add(ie),this._onDidAddConnection.fire(ie),F(()=>{Q.dispose(),ne.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const I=[];return this._connections.forEach(T=>I.push(T)),I}getChannel(I,T){const F=this;return{call(N,x,G){let J;if((0,v.isFunction)(T)){let ne=(0,m.getRandomElement)(F.connections.filter(T));J=ne?Promise.resolve(ne):S.Event.toPromise(S.Event.filter(F.onDidAddConnection,T))}else J=T.routeCall(F,N,x);const Q=J.then(ne=>ne.channelClient.getChannel(I));return P(Q).call(N,x,G)},listen(N,x){if((0,v.isFunction)(T))return F.getMulticastEvent(I,T,N,x);const G=T.routeEvent(F,N,x).then(J=>J.channelClient.getChannel(I));return P(G).listen(N,x)}}}getMulticastEvent(I,T,F,N){const x=this;let G=new k.DisposableStore;const J=new S.Emitter({onFirstListenerAdd:()=>{G=new k.DisposableStore;const Q=new S.EventMultiplexer,ne=new Map,ie=ue=>{const Ee=ue.channelClient.getChannel(I).listen(F,N),Ie=Q.add(Ee);ne.set(ue,Ie)},ce=ue=>{const ge=ne.get(ue);!ge||(ge.dispose(),ne.delete(ue))};x.connections.filter(T).forEach(ie),S.Event.filter(x.onDidAddConnection,T)(ie,void 0,G),x.onDidRemoveConnection(ce,void 0,G),Q.event(J.fire,J,G),G.add(Q)},onLastListenerRemove:()=>{G.dispose()}});return J.event}registerChannel(I,T){this.channels.set(I,T),this._connections.forEach(F=>{F.channelServer.registerChannel(I,T)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class h{constructor(I,T,F=null){const N=new D;o(N,T),I.send(N.buffer),this.channelClient=new d(I,F),this.channelServer=new l(I,T,F)}getChannel(I){return this.channelClient.getChannel(I)}registerChannel(I,T){this.channelServer.registerChannel(I,T)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=h;function P(z){return{call(I,T,F){return z.then(N=>N.call(I,T,F))},listen(I,T){const F=new S.Relay;return z.then(N=>F.input=N.listen(I,T)),F.event}}}e.getDelayedChannel=P;function _(z){let I=!1;return{call(T,F,N){return I?z.call(T,F,N):(0,A.timeout)(0).then(()=>I=!0).then(()=>z.call(T,F,N))},listen(T,F){if(I)return z.listen(T,F);const N=new S.Relay;return(0,A.timeout)(0).then(()=>I=!0).then(()=>N.input=z.listen(T,F)),N.event}}}e.getNextTickChannel=_;class j{constructor(I){this.fn=I}routeCall(I){return this.route(I)}routeEvent(I){return this.route(I)}async route(I){for(const T of I.connections)if(await Promise.resolve(this.fn(T.ctx)))return Promise.resolve(T);return await S.Event.toPromise(I.onDidAddConnection),await this.route(I)}}e.StaticRouter=j;var B;(function(z){function I(N,x){const G=N,J=x&&x.disableMarshalling,Q=new Map;for(const ne in G)F(ne)&&Q.set(ne,S.Event.buffer(G[ne],!0));return new class{listen(ne,ie){const ce=Q.get(ie);if(ce)return ce;throw new Error(`Event not found: ${ie}`)}call(ne,ie,ce){const ue=G[ie];if(typeof ue=="function"){if(!J&&Array.isArray(ce))for(let ge=0;ge<ce.length;ge++)ce[ge]=(0,R.revive)(ce[ge]);return ue.apply(G,ce)}throw new Error(`Method not found: ${ie}`)}}}z.fromService=I;function T(N,x){const G=x&&x.disableMarshalling;return new Proxy({},{get(J,Q){var ne;if(typeof Q=="string")return((ne=x==null?void 0:x.properties)===null||ne===void 0?void 0:ne.has(Q))?x.properties.get(Q):F(Q)?N.listen(Q):async function(...ie){let ce;x&&!(0,v.isUndefinedOrNull)(x.context)?ce=[x.context,...ie]:ce=ie;const ue=await N.call(Q,ce);return G?ue:(0,R.revive)(ue)};throw new Error(`Property not found: ${String(Q)}`)}})}z.toService=T;function F(N){return N[0]==="o"&&N[1]==="n"&&g.isUpperAsciiLetter(N.charCodeAt(2))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let I=z.toString();if(I!=="[object Object]")return I}return z}function V(z){return Array.isArray(z)?z.map($):$(z)}function q(z,I,T,F,N,x,G){G=V(G);const J=M[N],Q=J[F%J.length];let ne=[`%c[${z}]%c[${String(I).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(x)?(ne=ne.concat(G),ne.push(")")):ne.push(G),console.log.apply(console,ne)}e.logWithColors=q;class H{constructor(I,T){this._outgoingPrefix=I,this._incomingPrefix=T,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(I,T,F,N,x){this._totalOutgoing+=I,q(this._outgoingPrefix,this._totalOutgoing,I,T,F,N,x)}logIncoming(I,T,F,N,x){this._totalIncoming+=I,q(this._incomingPrefix,this._totalIncoming,I,T,F,N,x)}}e.IPCLogger=H}),define(Z[97],ee([0,1,3,34,23]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(m){this.port=m,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",v=>A.VSBuffer.wrap(v.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class U extends k.IPCClient{constructor(m,v){const R=new L(m);super(R,v);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[98],ee([0,1,99,3,34,97]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends A.IPCServer{static getOnDidClientConnect(){const m=k.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(v,R)=>R);return k.Event.map(m,v=>{const{port1:R,port2:g}=new MessageChannel,b={protocol:new L.Protocol(R),onDidClientDisconnect:k.Event.fromDOMEventEmitter(R,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",v,[g]),b})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[100],ee([0,1,11,23]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(O,m){O.proxyAuthorization&&(O.headers=Object.assign(Object.assign({},O.headers||{}),{"Proxy-Authorization":O.proxyAuthorization}));const v=new XMLHttpRequest;return new Promise((R,g)=>{v.open(O.type||"GET",O.url||"",!0,O.user,O.password),L(v,O),v.responseType="arraybuffer",v.onerror=y=>g(new Error(v.statusText&&"XHR failed: "+v.statusText||"XHR failed")),v.onload=y=>{R({res:{statusCode:v.status,headers:U(v)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(v.response)))})},v.ontimeout=y=>g(new Error(`XHR timeout: ${O.timeout}ms`)),O.timeout&&(v.timeout=O.timeout),v.send(O.data),m.onCancellationRequested(()=>{v.abort(),g((0,S.canceled)())})})}e.request=A;function L(O,m){if(m.headers){e:for(let v in m.headers){switch(v){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}O.setRequestHeader(v,m.headers[v])}}}function U(O){const m=Object.create(null);for(const v of O.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(v){const R=v.indexOf(":");m[v.substr(0,R).trim().toLowerCase()]=v.substr(R+1).trim()}return m}}),define(Z[67],ee([0,1,2,3,6,15]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var O;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(O||(O={}));class m extends S.Disposable{constructor(g,y=Object.create(null)){super();this.database=g,this.options=y,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=O.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var y,b;(y=g.changed)===null||y===void 0||y.forEach((c,p)=>this.accept(p,c)),(b=g.deleted)===null||b===void 0||b.forEach(c=>this.accept(c,void 0))}accept(g,y){if(this.state!==O.Closed){let b=!1;(0,L.isUndefinedOrNull)(y)?b=this.cache.delete(g):this.cache.get(g)!==y&&(this.cache.set(g,y),b=!0),b&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===O.None&&(this.state=O.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,y){const b=this.cache.get(g);return(0,L.isUndefinedOrNull)(b)?y:b}getBoolean(g,y){const b=this.get(g);return(0,L.isUndefinedOrNull)(b)?y:b==="true"}getNumber(g,y){const b=this.get(g);return(0,L.isUndefinedOrNull)(b)?y:parseInt(b,10)}async set(g,y){if(this.state!==O.Closed){if((0,L.isUndefinedOrNull)(y))return this.delete(g);const b=String(y);if(this.cache.get(g)!==b)return this.cache.set(g,b),this.pendingInserts.set(g,b),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==O.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=O.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var y;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(y=this.whenFlushedCallbacks.pop())===null||y===void 0||y()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((y,b)=>this.items.set(b,y)),g.delete&&g.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[101],ee([13,14]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[54],ee([0,1,101]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,L=A*24,U=L*7,O=L*30,m=L*365;function v(g,y){typeof g!="number"&&(g=g.getTime());const b=Math.round((new Date().getTime()-g)/1e3);if(b<-30)return(0,S.localize)(0,null,v(new Date().getTime()+b*1e3,!1));if(b<30)return(0,S.localize)(1,null);let c;return b<k?(c=b,y?c===1?(0,S.localize)(2,null,c):(0,S.localize)(3,null,c):c===1?(0,S.localize)(4,null,c):(0,S.localize)(5,null,c)):b<A?(c=Math.floor(b/k),y?c===1?(0,S.localize)(6,null,c):(0,S.localize)(7,null,c):c===1?(0,S.localize)(8,null,c):(0,S.localize)(9,null,c)):b<L?(c=Math.floor(b/A),y?c===1?(0,S.localize)(10,null,c):(0,S.localize)(11,null,c):c===1?(0,S.localize)(12,null,c):(0,S.localize)(13,null,c)):b<U?(c=Math.floor(b/L),y?c===1?(0,S.localize)(14,null,c):(0,S.localize)(15,null,c):c===1?(0,S.localize)(16,null,c):(0,S.localize)(17,null,c)):b<O?(c=Math.floor(b/U),y?c===1?(0,S.localize)(18,null,c):(0,S.localize)(19,null,c):c===1?(0,S.localize)(20,null,c):(0,S.localize)(21,null,c)):b<m?(c=Math.floor(b/O),y?c===1?(0,S.localize)(22,null,c):(0,S.localize)(23,null,c):c===1?(0,S.localize)(24,null,c):(0,S.localize)(25,null,c)):(c=Math.floor(b/m),y?c===1?(0,S.localize)(26,null,c):(0,S.localize)(27,null,c):c===1?(0,S.localize)(28,null,c):(0,S.localize)(29,null,c))}e.fromNow=v;function R(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Z[102],ee([13,14]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,102,15,18]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(v,R){return R&&(v.stack||v.stacktrace)?S.localize(0,null,O(v),U(v.stack)||U(v.stacktrace)):O(v)}function U(v){return Array.isArray(v)?v.join(`
`):v}function O(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function m(v=null,R=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const g=A.coalesce(v),y=m(g[0],R);return g.length>1?S.localize(4,null,y,g.length):y}if(k.isString(v))return v;if(v.detail){const g=v.detail;if(g.error)return L(g.error,R);if(g.exception)return L(g.exception,R)}return v.stack?L(v,R):v.message?v.message:S.localize(5,null)}e.toErrorMessage=m}),define(Z[103],ee([13,14]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[104],ee([0,1,8,27,24,48,103,36,15,26,42,7,66,16]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function c(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(r,t){if(g.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const n=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{n.once("error",a=>{o({success:!1,error:a})}),n.once("exit",(a,l)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?c(i.status):1})}else if(g.isLinux||g.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{L.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,a,l)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function w(r=O.env){return r.comspec||"cmd.exe"}e.getWindowsShell=w;class C{constructor(t,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=t,this.args=i,this.shell=n,this.options=o;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(O.env).forEach(l=>{a[l]=O.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(S.sep);return i!==-1&&(t=t.substring(i+1)),C.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(O.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let n,o;const a=new Promise((l,u)=>{n=l,o=u});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=L.exec(l,this.options,(u,d,E)=>{this.childProcess=null;const h=u;h&&h.killed?o({killed:this.terminateRequested,stdout:d.toString(),stderr:E.toString()}):this.handleExec(n,t,u,d,E)})}else{let l=null;const u=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,t,o);const E={terminated:this.terminateRequested};m.isNumber(d)&&(E.cmdCode=d),n(E)};if(this.shell&&g.isWindows){const d=v.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let E=!1,h=!1;const P=[];let _=this.ensureQuotes(this.cmd);P.push(_.value),E=_.quoted,this.args&&this.args.forEach(B=>{_=this.ensureQuotes(B),P.push(_.value),h=h&&_.quoted});const j=["/s","/c"];E?h?j.push('"'+P.join(" ")+'"'):P.length>1?j.push('"'+P[0]+'" '+P.slice(1).join(" ")):j.push('"'+P[0]+'"'):j.push(P.join(" ")),l=L.spawn(w(),j,d)}else this.cmd&&(l=L.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(m.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,o({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",u),this.handleSpawn(l,n,t,o,!0)))}return a})}handleClose(t,i,n,o){}ensureQuotes(t){return C.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const i=L.spawn(w(),["/s","/c"]);i.on("error",n=>t(!0)),i.on("exit",n=>t(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class D extends C{constructor(t,i,n,o){super(t,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,n,o,a){[o,a].forEach((l,u)=>{const d=new y.LineDecoder;d.write(l).forEach(P=>{i({line:P,source:u===0?0:1})});const h=d.end();h&&i({line:h,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,i,n,o,a){const l=new y.LineDecoder,u=new y.LineDecoder;t.stdout.on("data",d=>{l.write(d).forEach(h=>n({line:h,source:0}))}),t.stderr.on("data",d=>{u.write(d).forEach(h=>n({line:h,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=u}handleClose(t,i,n,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&n({line:l,source:1})}}e.LineProcess=D;function f(r){let t=[],i=!1;const n=function(o){if(i){t.push(o);return}(!r.send(o,l=>{if(l&&console.error(l),i=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(d=>n(d))}})||g.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=f;var s;(function(r){async function t(i,n,o){if(S.isAbsolute(i))return i;if(n===void 0&&(n=O.cwd()),S.dirname(i)!=="."||(o===void 0&&m.isString(O.env.PATH)&&(o=O.env.PATH.split(S.delimiter)),o===void 0||o.length===0))return S.join(n,i);async function l(u){return await A.exists(u)?!(await k.promises.stat(u)).isDirectory():!1}for(let u of o){let d;if(S.isAbsolute(u)?d=S.join(u,i):d=S.join(n,u,i),await l(d))return d;let E=d+".com";if(await l(E)||(E=d+".exe",await l(E)))return E}return S.join(n,i)}r.findExecutable=t})(s=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,104,34,87,30,11,23,7]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends m.ChannelServer{constructor(C){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(f){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",D=>y.VSBuffer.wrap(Buffer.from(D,"base64")))},C);process.once("disconnect",()=>this.dispose())}}e.Server=c;class p{constructor(C,D){this.modulePath=C,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new A.Delayer(f),this.child=null,this._client=null}getChannel(C){const D=this;return{call(f,s,r){return D.requestPromise(C,f,s,r)},listen(f,s){return D.requestEvent(C,f,s)}}}requestPromise(C,D,f,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(C),t=(0,A.createCancelablePromise)(o=>r.call(D,f,o)),i=s.onCancellationRequested(()=>t.cancel()),n=(0,k.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(C,D,f){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let s;const r=new U.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(C).listen(D,f)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env=Object.assign(Object.assign({},(0,L.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(D.env=Object.assign(Object.assign({},D.env),this.options.env)),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),b.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,C,D);const f=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,v.isRemoteConsoleLog)(a)){(0,v.log)(a,`IPC Library: ${this.options.serverName}`);return}f.fire(y.VSBuffer.wrap(Buffer.from(a,"base64")))});const r=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),i=f.event,n={send:t,onMessage:i};this._client=new m.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,l)=>{process.removeListener("exit",o),this.activeRequests.forEach(u=>(0,k.dispose)(u)),this.activeRequests.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:l})})}return this._client}getCachedChannel(C){let D=this.channels.get(C);return D||(D=this.client.getChannel(C),this.channels.set(C,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(Z[105],ee([13,14]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[106],ee([13,14]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[107],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[108],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[109],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[110],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[111],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[112],ee([13,14]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[113],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[114],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[115],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[116],ee([13,14]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[117],ee([13,14]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[118],ee([13,14]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[119],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[120],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[121],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[122],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[123],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[124],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)});var he=this&&this.__decorate||function(K,e,S,k){var A=arguments.length,L=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,S):k,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(K,e,S,k);else for(var O=K.length-1;O>=0;O--)(U=K[O])&&(L=(A<3?U(L):A>3?U(e,S,L):U(e,S))||L);return A>3&&L&&Object.defineProperty(e,S,L),L};define(Z[125],ee([0,1,8,12,85,54,16,4,36]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(c,p,w){this._args=c,this.paths=p,this.productService=w}get appRoot(){return(0,S.dirname)(U.FileAccess.asFileUri("",K).fsPath)}get userHome(){return O.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return O.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return O.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(O.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return O.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return O.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=m.env.VSCODE_PORTABLE;return c?O.URI.file((0,S.join)(c,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,S.resolve)(c):(0,S.normalize)((0,S.join)(U.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,S.resolve)(c):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,S.resolve)(c);const p=m.env.VSCODE_EXTENSIONS;if(p)return p;const w=m.env.VSCODE_PORTABLE;return w?(0,S.join)(w,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(p=>/^[^:/?#]+?:\/\//.test(p)?O.URI.parse(p):O.URI.file((0,S.normalize)(p)))}get extensionDevelopmentKind(){var c;return(c=this.args.extensionDevelopmentKind)===null||c===void 0?void 0:c.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?O.URI.parse(c):O.URI.file((0,S.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!m.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return O.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}he([A.memoize],v.prototype,"appRoot",null),he([A.memoize],v.prototype,"userHome",null),he([A.memoize],v.prototype,"userDataPath",null),he([A.memoize],v.prototype,"appSettingsHome",null),he([A.memoize],v.prototype,"tmpDir",null),he([A.memoize],v.prototype,"userRoamingDataHome",null),he([A.memoize],v.prototype,"settingsResource",null),he([A.memoize],v.prototype,"userDataSyncHome",null),he([A.memoize],v.prototype,"userDataSyncLogResource",null),he([A.memoize],v.prototype,"sync",null),he([A.memoize],v.prototype,"machineSettingsResource",null),he([A.memoize],v.prototype,"globalStorageHome",null),he([A.memoize],v.prototype,"workspaceStorageHome",null),he([A.memoize],v.prototype,"keybindingsResource",null),he([A.memoize],v.prototype,"keyboardLayoutResource",null),he([A.memoize],v.prototype,"argvResource",null),he([A.memoize],v.prototype,"snippetsHome",null),he([A.memoize],v.prototype,"isExtensionDevelopment",null),he([A.memoize],v.prototype,"untitledWorkspacesHome",null),he([A.memoize],v.prototype,"installSourcePath",null),he([A.memoize],v.prototype,"builtinExtensionsPath",null),he([A.memoize],v.prototype,"extensionsPath",null),he([A.memoize],v.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],v.prototype,"extensionDevelopmentKind",null),he([A.memoize],v.prototype,"extensionTestsLocationURI",null),he([A.memoize],v.prototype,"debugExtensionHost",null),he([A.memoize],v.prototype,"serviceMachineIdResource",null),he([A.memoize],v.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=v;function R(b,c){return y(b["inspect-extensions"],b["inspect-brk-extensions"],5870,c,b.debugId)}e.parseExtensionHostPort=R;function g(b,c){return y(b["inspect-search"],b["inspect-brk-search"],5876,c)}e.parseSearchPort=g;function y(b,c,p,w,C){const f=Number(c||b)||(w?null:p),s=f?Boolean(!!c):!1;return{port:f,break:s,debugId:C}}}),function(){"use strict";function K(e,S,k,A){function L(O){const m=U(O),v=[m];return e.isAbsolute(m)||v.unshift(A),e.resolve(...v)}function U(O){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");const v=O["user-data-dir"];if(v)return v;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=e.join(g,"AppData","Roaming")}break;case"darwin":R=e.join(S.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(R,k)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[126],ee([0,200,38,16,12,36]),function(e,S,k,A,L,U){const O=L.dirname(A.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(L.joinPath(O,"package.json").fsPath);return K(S,k,m.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),k=require("os");module.exports=K(S,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[127],ee([0,1,38,126,125]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends A.AbstractNativeEnvironmentService{constructor(O,m){super(O,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(O)},m)}}e.NativeEnvironmentService=L}),define(Z[128],ee([0,1,4]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,O=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function v(w){const C=w.match(U);return C?C[1]:null}function R(w){if(w.indexOf("://")===-1){const C=w.match(k);return C?v(C[2]):null}try{const C=S.URI.parse(w);if(C.authority)return v(C.authority)}catch(C){}return null}function g(w,C){const D=new Set;let f;for(;f=O.exec(w);){const r=R(f[1]);r&&D.add(r)}const s=new Set(C);return Array.from(D).map(r=>s.has(r)?r:r.replace(m,"a"))}e.getDomainsOfRemotes=g;function y(w){const C=w.match(L);return C?C[2]:null}function b(w,C,D){return w&&C?(D&&C.endsWith(".git")&&(C=C.substr(0,C.length-4)),C.indexOf("/")===0?`${w}${C}`:`${w}/${C}`):null}function c(w,C){if(w.indexOf("://")===-1){const D=w.match(A);if(D)return b(D[2],D[3],C)}try{const D=S.URI.parse(w);if(D.authority)return b(y(D.authority),D.path,C)}catch(D){}return null}function p(w,C=!1){const D=[];let f;for(;f=O.exec(w);){const s=c(f[1],C);s&&D.push(s)}return D}e.getRemotes=p}),define(Z[129],ee([0,1,3,4,90,26,2]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function O(c,p){return k.URI.revive(p?p.transformIncoming(c):c)}function m(c,p){return p?p.transformOutgoingURI(c):c}function v(c,p){p=p||A.DefaultURITransformer;const w=c.manifest,C=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},c),{manifest:void 0}),p);return Object.assign(Object.assign({},C),{manifest:w})}function R(c,p){return p?(0,L.cloneAndChange)(c,w=>w instanceof k.URI?p.transformOutgoingURI(w):void 0):c}class g{constructor(p,w){this.service=p,this.getUriTransformer=w,this.onInstallExtension=S.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtension=S.Event.buffer(p.onDidInstallExtension,!0),this.onUninstallExtension=S.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,w){const C=this.getUriTransformer(p);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return S.Event.map(this.onDidInstallExtension,D=>Object.assign(Object.assign({},D),{local:D.local?R(D.local,C):D.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,w,C){const D=this.getUriTransformer(p);switch(w){case"zip":return this.service.zip(v(C[0],D)).then(f=>m(f,D));case"unzip":return this.service.unzip(O(C[0],D));case"install":return this.service.install(O(C[0],D));case"getManifest":return this.service.getManifest(O(C[0],D));case"canInstall":return this.service.canInstall(C[0]);case"installFromGallery":return this.service.installFromGallery(C[0],C[1]);case"uninstall":return this.service.uninstall(v(C[0],D),C[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(v(C[0],D));case"getInstalled":return this.service.getInstalled(C[0]).then(f=>f.map(s=>R(s,D)));case"updateMetadata":return this.service.updateMetadata(v(C[0],D),C[1]).then(f=>R(f,D));case"updateExtensionScope":return this.service.updateExtensionScope(v(C[0],D),C[1]).then(f=>R(f,D));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class y extends U.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new S.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire(w))),this._register(this.channel.listen("onDidInstallExtension")(w=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},w),{local:w.local?v(w.local,null):w.local})))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(w=>k.URI.revive(w)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p){return Promise.resolve(this.channel.call("install",[p])).then(w=>v(w,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}async canInstall(p){return!0}installFromGallery(p,w){return Promise.resolve(this.channel.call("installFromGallery",[p,w])).then(C=>v(C,null))}uninstall(p,w){return Promise.resolve(this.channel.call("uninstall",[p,w]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null){return Promise.resolve(this.channel.call("getInstalled",[p])).then(w=>w.map(C=>v(C,null)))}updateMetadata(p,w){return Promise.resolve(this.channel.call("updateMetadata",[p,w])).then(C=>v(C,null))}updateExtensionScope(p,w){return Promise.resolve(this.channel.call("updateExtensionScope",[p,w])).then(C=>v(C,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=y;class b{constructor(p){this.service=p}listen(p,w){throw new Error("Invalid listen")}call(p,w,C){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(C[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[130],ee([0,1,26]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function A(L,U){const O=m=>{if(typeof m=="string"){const v=k.exec(m);if(!!v)return U[v[1]]||m}};return(0,S.cloneAndChange)(L,O)}e.localizeManifest=A}),define(Z[131],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,U,O,m){return this.channel.call("promptImportantExtensionsInstallNotification",[L,U,O,m])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class k{constructor(L){this.service=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,O){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(O[0],O[1],O[2],O[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[68],ee([0,1,112]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(g){return g=g.trim(),g==="*"||k.test(g)}e.isValidVersionStr=A;function L(g){if(!A(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=g.match(k);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=L;function U(g){if(!g)return null;let y=g.majorBase,b=g.majorMustEqual,c=g.minorBase,p=g.minorMustEqual,w=g.patchBase,C=g.patchMustEqual;return g.hasCaret&&(y===0||(p=!1),C=!1),{majorBase:y,majorMustEqual:b,minorBase:c,minorMustEqual:p,patchBase:w,patchMustEqual:C,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=U;function O(g,y){let b;typeof g=="string"?b=U(L(g)):b=g;let c;if(typeof y=="string"?c=U(L(y)):c=y,!b||!c)return!1;let p=b.majorBase,w=b.minorBase,C=b.patchBase,D=c.majorBase,f=c.minorBase,s=c.patchBase,r=c.majorMustEqual,t=c.minorMustEqual,i=c.patchMustEqual;return c.isMinimum?p>D?!0:p<D?!1:w>f?!0:w<f?!1:C>=s:(p===1&&D===0&&(!r||!t||!i)&&(D=1,f=0,s=0,r=!0,t=!1,i=!1),p<D?!1:p>D?!r:w<f?!1:w>f?!t:C<s?!1:C>s?!i:!0)}e.isValidVersion=O;function m(g,y,b){return y.isBuiltin||typeof y.main=="undefined"?!0:R(g,y.engines.vscode,b)}e.isValidExtensionVersion=m;function v(g,y){return g==="*"||R(y,g)}e.isEngineValid=v;function R(g,y,b=[]){let c=U(L(y));if(!c)return b.push(S.localize(0,null,y)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return b.push(S.localize(1,null,y)),!1}else if(!c.majorMustEqual)return b.push(S.localize(2,null,y)),!1;return O(g,c)?!0:(b.push(S.localize(3,null,g,y)),!1)}e.isVersionValid=R}),define(Z[132],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(m,v,R,g){super();this.folders=m,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(m,v,R,g,y={}){super();this.folders=m,this.onDidFilesChange=v,this.onLogMessage=R,this.verboseLogging=g,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(m.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[134],ee([0,1,48,66,89,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(m,v,R,g,y){this.watchedFolder=m,this.eventCallback=R,this.logCallback=g,this.verboseLogging=y,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(b=>A.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=S.spawn(L.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,m);const v=new k.LineDecoder;this.handle.stdout.on("data",R=>{const g=[];v.write(R).forEach(y=>{const b=y.split("|");if(b.length===2){const c=Number(b[0]),p=b[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(w=>w(p))){this.verboseLogging&&this.log(p);return}g.push({type:U.changeTypeMap[c],path:p})}else this.log(b[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,g)=>this.onExit(R,g))}onError(m){this.error("process error: "+m.toString())}onExit(m,v){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${v})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[135],ee([0,1,134,8,21]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L{constructor(O,m,v,R){this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=R,this.service=void 0,this.folder=O[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,O=>this.onFileEvents(O),O=>this.onLogMessage(O),this.verboseLogging)}setVerboseLogging(O){this.verboseLogging=O,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(O){this.isDisposed||O.length>0&&this.onDidFilesChange(O)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=L}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class S{constructor(L,U=[],O=!1){this.ctor=L,this.staticArguments=U,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=S;const k=(A,...L)=>new S(A,L);e.createSyncDescriptor=k}),define(Z[136],ee([0,1,50]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(U,O,m){O instanceof S.SyncDescriptor||(O=new S.SyncDescriptor(O,[],m)),k.push([U,O])}e.registerSingleton=A;function L(){return k}e.getSingletonServiceDescriptors=L}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=S;class k{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let U of this._nodes.values())U.outgoing.size===0&&L.push(U);return L}insertEdge(L,U){const O=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(U);O.outgoing.set(this._hashFn(U),m),m.incoming.set(this._hashFn(L),O)}removeNode(L){const U=this._hashFn(L);this._nodes.delete(U);for(let O of this._nodes.values())O.outgoing.delete(U),O.incoming.delete(U)}lookupOrInsertNode(L){const U=this._hashFn(L);let O=this._nodes.get(U);return O||(O=new S(L),this._nodes.set(U,O)),O}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[U,O]of this._nodes)L.push(`${U}, (incoming)[${[...O.incoming.keys()].join(", ")}], (outgoing)[${[...O.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,U]of this._nodes){const O=new Set([L]),m=this._findCycle(U,O);if(m)return m}}_findCycle(L,U){for(let[O,m]of L.outgoing){if(U.has(O))return[...U,O].join(" -> ");U.add(O);const v=this._findCycle(m,U);if(v)return v;U.delete(O)}}}e.Graph=k}),define(Z[5],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function m(v){return v[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=m})(S=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(O,m,v,R){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:O,index:v,optional:R}):(m[S.DI_DEPENDENCIES]=[{id:O,index:v,optional:R}],m[S.DI_TARGET]=m)}function A(O){if(S.serviceIds.has(O))return S.serviceIds.get(O);const m=function(v,R,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(m,v,g,!1)};return m.toString=()=>O,S.serviceIds.set(O,m),m}e.createDecorator=A;function L(O){return O}e.refineServiceDecorator=L;function U(O){return function(m,v,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(O,m,R,!0)}}e.optional=U}),define(Z[138],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(Z[139],ee([0,1,21,5,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=A.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",A.isMacintosh),U.set("isLinux",A.isLinux),U.set("isWindows",A.isWindows),U.set("isWeb",A.isWeb),U.set("isMacNative",A.isMacintosh&&!A.isWeb),U.set("isEdge",L.indexOf("Edg/")>=0),U.set("isFirefox",L.indexOf("Firefox")>=0),U.set("isChrome",L.indexOf("Chrome")>=0),U.set("isSafari",L.indexOf("Safari")>=0),U.set("isIPad",L.indexOf("iPad")>=0);const O=Object.prototype.hasOwnProperty;var m;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class v{static false(){return g.INSTANCE}static true(){return y.INSTANCE}static has(h){return b.create(h)}static equals(h,P){return c.create(h,P)}static notEquals(h,P){return C.create(h,P)}static regex(h,P){return i.create(h,P)}static in(h,P){return p.create(h,P)}static not(h){return D.create(h)}static and(...h){return o.create(h)}static or(...h){return a.create(h)}static greater(h,P){return f.create(h,P)}static less(h,P){return r.create(h,P)}static deserialize(h,P=!1){if(!!h)return this._deserializeOrExpression(h,P)}static _deserializeOrExpression(h,P){let _=h.split("||");return a.create(_.map(j=>this._deserializeAndExpression(j,P)))}static _deserializeAndExpression(h,P){let _=h.split("&&");return o.create(_.map(j=>this._deserializeOne(j,P)))}static _deserializeOne(h,P){if(h=h.trim(),h.indexOf("!=")>=0){let _=h.split("!=");return C.create(_[0].trim(),this._deserializeValue(_[1],P))}if(h.indexOf("==")>=0){let _=h.split("==");return c.create(_[0].trim(),this._deserializeValue(_[1],P))}if(h.indexOf("=~")>=0){let _=h.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(h.indexOf(" in ")>=0){let _=h.split(" in ");return p.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const _=h.split(">=");return s.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const _=h.split(">");return f.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const _=h.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const _=h.split("<");return r.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(h)?D.create(h.substr(1).trim()):b.create(h)}static _deserializeValue(h,P){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let _=/^'([^']*)'$/.exec(h);return _?_[1].trim():h}static _deserializeRegexValue(h,P){if((0,S.isFalsyOrWhitespace)(h)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=h.indexOf("/"),j=h.lastIndexOf("/");if(_===j||_<0){if(P)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let B=h.slice(_+1,j),M=h[j+1]==="i"?"i":"";try{return new RegExp(B,M)}catch($){if(P)throw new Error(`bad regexp-value '${h}', parse error: ${$}`);return console.warn(`bad regexp-value '${h}', parse error: ${$}`),null}}}e.ContextKeyExpr=v;function R(E,h){return E.cmp(h)}class g{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class y{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class b{constructor(h){this.key=h,this.type=2}static create(h){const P=U.get(h);return typeof P=="boolean"?P?y.INSTANCE:g.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:u(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return D.create(this.key)}}e.ContextKeyDefinedExpr=b;class c{constructor(h,P){this.key=h,this.value=P,this.type=4}static create(h,P){if(typeof P=="boolean")return P?b.create(h):D.create(h);const _=U.get(h);return typeof _=="boolean"?P===(_?"true":"false")?y.INSTANCE:g.INSTANCE:new c(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return C.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class p{constructor(h,P){this.key=h,this.valueKey=P,this.type=10}static create(h,P){return new p(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const P=h.getValue(this.valueKey),_=h.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?O.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=p;class w{constructor(h){this._actual=h,this.type=11}static create(h){return new w(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new w(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class C{constructor(h,P){this.key=h,this.value=P,this.type=5}static create(h,P){if(typeof P=="boolean")return P?D.create(h):b.create(h);const _=U.get(h);return typeof _=="boolean"?P===(_?"true":"false")?g.INSTANCE:y.INSTANCE:new C(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=C;class D{constructor(h){this.key=h,this.type=3}static create(h){const P=U.get(h);return typeof P=="boolean"?P?g.INSTANCE:y.INSTANCE:new D(h)}cmp(h){return h.type!==this.type?this.type-h.type:u(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=D;class f{constructor(h,P){this.key=h,this.value=P,this.type=12}static create(h,P){return new f(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class s{constructor(h,P){this.key=h,this.value=P,this.type=13}static create(h,P){return new s(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class r{constructor(h,P){this.key=h,this.value=P,this.type=14}static create(h,P){return new r(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=r;class t{constructor(h,P){this.key=h,this.value=P,this.type=15}static create(h,P){return new t(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(h,P){this.key=h,this.regexp=P,this.type=7}static create(h,P){return new i(h,P)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const P=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return P<_?-1:P>_?1:0}equals(h){if(h.type===this.type){const P=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return this.key===h.key&&P===_}return!1}evaluate(h){let P=h.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(h){this._actual=h,this.type=8}static create(h){return new n(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new n(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class o{constructor(h){this.expr=h,this.type=6}static create(h){return o._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const j=R(this.expr[P],h.expr[P]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}evaluate(h){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(h))return!1;return!0}static _normalizeArr(h){const P=[];let _=!1;for(const j of h)if(!!j){if(j.type===1){_=!0;continue}if(j.type===0)return g.INSTANCE;if(j.type===6){P.push(...j.expr);continue}P.push(j)}if(P.length===0&&_)return y.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(R);P.length>1;){const j=P[P.length-1];if(j.type!==9)break;P.pop();const B=P.pop(),M=a.create(j.expr.map($=>o.create([$,B])));M&&(P.push(M),P.sort(R))}return P.length===1?P[0]:new o(P)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let P of this.expr)h.push(...P.keys());return h}map(h){return new o(this.expr.map(P=>P.map(h)))}negate(){let h=[];for(let P of this.expr)h.push(P.negate());return a.create(h)}}e.ContextKeyAndExpr=o;class a{constructor(h){this.expr=h,this.type=9}static create(h){const P=a._normalizeArr(h);if(P.length!==0)return P.length===1?P[0]:new a(P)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const j=R(this.expr[P],h.expr[P]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}evaluate(h){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(h))return!0;return!1}static _normalizeArr(h){let P=[],_=!1;if(h){for(let j=0,B=h.length;j<B;j++){const M=h[j];if(!!M){if(M.type===0){_=!0;continue}if(M.type===1)return[y.INSTANCE];if(M.type===9){P=P.concat(M.expr);continue}P.push(M)}}if(P.length===0&&_)return[g.INSTANCE];P.sort(R)}return P}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let P of this.expr)h.push(...P.keys());return h}map(h){return new a(this.expr.map(P=>P.map(h)))}negate(){let h=[];for(let _ of this.expr)h.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;h.length>1;){const _=h.shift(),j=h.shift(),B=[];for(const M of P(_))for(const $ of P(j))B.push(v.and(M,$));h.unshift(v.or(...B))}return h[0]}}e.ContextKeyOrExpr=a;class l extends b{constructor(h,P,_){super(h);this._defaultValue=P,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:h})):_!==!0&&l._info.push({key:h,description:_,type:P!=null?typeof P:void 0})}static all(){return l._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return v.not(this.key)}isEqualTo(h){return v.equals(this.key,h)}notEqualsTo(h){return v.notEquals(this.key,h)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(E,h){return E<h?-1:E>h?1:0}function d(E,h,P,_){return E<P?-1:E>P?1:h<_?-1:h>_?1:0}}),define(Z[69],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function k(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[70],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(Z[9],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(S,k){e(S,k,K)}};define(Z[140],ee([0,1,9,8,24,11,2,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let m=class extends U.Disposable{constructor(R){super();this.environmentService=R,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let R=setTimeout(()=>{R=void 0;const g=(0,k.basename)(this.environmentService.logsPath),y=(0,k.dirname)(this.environmentService.logsPath);(0,A.readdir)(y).then(b=>{const p=b.filter(C=>/^\d{8}T\d{6}$/.test(C)).sort().filter((C,D)=>C!==g),w=p.slice(0,Math.max(0,p.length-9));return O.Promises.settled(w.map(C=>(0,A.rimraf)((0,k.join)(y,C))))}).then(null,L.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};m=he([Y(0,S.IEnvironmentService)],m),e.LogsDataCleaner=m}),define(Z[141],ee([0,1,27,9,8,24,11,2]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let m=class ct extends O.Disposable{constructor(R,g){super();this.backupWorkspacesPath=R,this.environmentService=g,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let R=setTimeout(()=>{R=void 0,(async()=>{try{const g=await S.promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(g).emptyWorkspaceInfos.map(w=>w.backupFolder),c=await(0,L.readdir)(this.environmentService.workspaceStorageHome.fsPath),p=[];c.forEach(w=>{w.length!==ct.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(w)===-1&&p.push((0,L.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,w)))}),await Promise.all(p)}catch(g){(0,U.onUnexpectedError)(g)}})()},30*1e3);this._register((0,O.toDisposable)(()=>{R&&(clearTimeout(R),R=void 0)}))}};m.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,m=he([Y(1,k.INativeEnvironmentService)],m),e.StorageDataCleaner=m}),define(Z[29],ee([0,1,107,5,16]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=L;var U;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var O;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(O=e.SortOrder||(e.SortOrder={}));var m;(function(g){g.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var v;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(y,b){super(y);this.code=b}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[142],ee([0,1,2,29]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends S.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=he([Y(0,k.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[71],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function A(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var L;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[72],ee([0,1,21,5]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L=e.ExtensionType||(e.ExtensionType={}));class U{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,g){if(typeof R=="undefined"||R===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof R=="string"||typeof g=="string"){let y=typeof R=="string"?R:R.value,b=typeof g=="string"?g:g.value;return S.equalsIgnoreCase(y,b)}return R._lower===g._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=U;function O(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function m(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=m,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,72]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(b,c){return b.uuid&&c.uuid?b.uuid===c.uuid:b.id===c.id?!0:(0,S.compareIgnoreCase)(b.id,c.id)===0}e.areSameExtensions=A;class L{constructor(c,p){this.version=p,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof L?A(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=L;function U(b,c){return`${b}.${c}`}e.getExtensionId=U;function O(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function m(b,c){return O(U(b,c))}e.getGalleryExtensionId=m;function v(b,c){const p=[],w=C=>{for(const D of p)if(D.some(f=>A(c(f),c(C))))return D;return null};for(const C of b){const D=w(C);D?D.push(C):p.push([C])}return p}e.groupByExtension=v;function R(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function g(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function y(b){const c=new Set;for(const p of b)p.malicious&&c.add(p.id.id);return c}e.getMaliciousExtensionsSet=y}),define(Z[143],ee([0,1,2,8,72,24]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends S.Disposable{constructor(m,v){super();this.environmentService=m,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(v.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(m){m.error||this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){L.rimraf(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,114,8,4,5,21,15,37]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,L.createDecorator)("fileService");function v(M){return M.create===!0}e.isFileOpenForWriteOptions=v;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var g;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function b(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=b;function c(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function p(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=p;var w;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor($,V){super($);this.code=V}}e.FileSystemProviderError=C;function D(M,$){const V=new C(M.toString(),$);return s(V,$),V}e.createFileSystemProviderError=D;function f(M){return M||D((0,S.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=f;function s(M,$){return M.name=$?`${$} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=s;function r(M){if(!M)return w.Unknown;if(M instanceof C)return M.code;const $=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!$)return w.Unknown;switch($[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=r;function t(M){if(M instanceof u)return M.fileOperationResult;switch(r(M)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor($,V,q){this.resource=$,this.operation=V,this.target=q}isOperation($){return this.operation===$}}e.FileOperationEvent=n;var o;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor($,V){this.ignorePathCasing=V,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const q of $)switch(q.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(q.resource,q);break}}contains($,...V){return this.doContains($,{includeChildren:!1},...V)}affects($,...V){return this.doContains($,{includeChildren:!0},...V)}doContains($,V,...q){var H,z,I,T,F,N;if(!$)return!1;const x=q.length>0;return!!((!x||q.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get($))||V.includeChildren&&((z=this.added)===null||z===void 0?void 0:z.findSuperstr($)))||(!x||q.includes(0))&&(((I=this.updated)===null||I===void 0?void 0:I.get($))||V.includeChildren&&((T=this.updated)===null||T===void 0?void 0:T.findSuperstr($)))||(!x||q.includes(2))&&(((F=this.deleted)===null||F===void 0?void 0:F.findSubstr($))||V.includeChildren&&((N=this.deleted)===null||N===void 0?void 0:N.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const V=[],q=$===1?this.added:$===0?this.updated:this.deleted;if(q)for(const[,H]of q)V.push(H);return V}filter($){return new a(this.changes.filter(V=>$(V)),this.ignorePathCasing)}}e.FileChangesEvent=a;function l(M,$,V){return!M||!$||M===$||$.length>M.length?!1:($.charAt($.length-1)!==k.sep&&($+=k.sep),V?(0,U.startsWithIgnoreCase)(M,$):M.indexOf($)===0)}e.isParent=l;class u extends Error{constructor($,V,q){super($);this.fileOperationResult=V,this.options=q}static isFileOperationError($){return $ instanceof Error&&!(0,O.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=u;var d;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var E;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(E=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=h;async function P(M,$){if(!$.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise(V=>{const q=$.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(q.dispose(),V())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize($){return(0,O.isNumber)($)||($=0),$<_.KB?(0,S.localize)(1,null,$.toFixed(0)):$<_.MB?(0,S.localize)(2,null,($/_.KB).toFixed(2)):$<_.GB?(0,S.localize)(3,null,($/_.MB).toFixed(2)):$<_.TB?(0,S.localize)(4,null,($/_.GB).toFixed(2)):(0,S.localize)(5,null,($/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var j;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*_.MB:16*_.GB,maxHeapSize:M===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=B}),define(Z[144],ee([0,1,145,47,10]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(O){this.fileService=O}checksum(O){return new Promise(async(m,v)=>{const R=(0,S.createHash)("md5"),g=(await this.fileService.readFileStream(O)).value;(0,k.listenStream)(g,{onData:y=>R.update(y.buffer),onError:y=>v(y),onEnd:()=>m(R.digest("base64").replace(/=+$/,""))})})}};L=he([Y(0,A.IFileService)],L),e.ChecksumService=L}),define(Z[73],ee([0,1,4,10,7]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function L(m){return m.map(v=>({type:v.type,resource:S.URI.file(v.path)}))}e.toFileChanges=L;function U(m){const v=new O;for(const R of m)v.processEvent(R);return v.normalize()}e.normalizeFileChanges=U;class O{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const R=this.mapPathToChange.get(v.path);if(R){const g=R.type,y=v.type;g===1&&y===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(R),1)):g===2&&y===1?R.type=0:g===1&&y===0||(R.type=y)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],R=[];return this.normalized.filter(g=>g.type!==2?(v.push(g),!1):!0).sort((g,y)=>g.path.length-y.path.length).filter(g=>R.some(y=>(0,k.isParent)(g.path,y,!A.isLinux))?!1:(R.push(g.path),!0)).concat(v)}}}),define(Z[146],ee([0,1,73,2,24,93,96,6,8]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends k.Disposable{constructor(g,y,b,c){super();this.path=g,this.onDidFilesChange=y,this.onLogMessage=b,this.verboseLogging=c,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:y}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(y)try{b=await(0,L.realpath)(b)}catch(c){if(this.onError(c),y.dangling)return}g.isDirectory()?this._register((0,U.watchFolder)(b,(c,p)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,m.join)(this.path,(0,m.basename)(p))})},c=>this.onError(c))):this._register((0,U.watchFile)(b,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,S.normalizeFileChanges)(y);this.verboseLogging&&b.forEach(c=>{this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(Z[74],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...A){this._entries=new Map;for(let[L,U]of A)this.set(L,U)}set(A,L){const U=this._entries.get(A);return this._entries.set(A,L),U}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=S}),define(Z[147],ee([0,1,11,137,50,5,74,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class v extends Error{constructor(c){var p;super("cyclic dependency between services");this.message=(p=c.findCycleSlow())!==null&&p!==void 0?p:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class R{constructor(c=new U.ServiceCollection,p=!1,w){this._activeInstantiations=new Set,this._services=c,this._strict=p,this._parent=w,this._services.set(L.IInstantiationService,this)}createChild(c){return new R(c,this._strict,this)}invokeFunction(c,...p){let w=y.traceInvocation(c),C=!1;try{return c({get:(f,s)=>{if(C)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(f,w);if(!r&&s!==L.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return r}},...p)}finally{C=!0,w.stop()}}createInstance(c,...p){let w,C;return c instanceof A.SyncDescriptor?(w=y.traceCreation(c.ctor),C=this._createInstance(c.ctor,c.staticArguments.concat(p),w)):(w=y.traceCreation(c),C=this._createInstance(c,p,w)),w.stop(),C}_createInstance(c,p=[],w){let C=L._util.getServiceDependencies(c).sort((s,r)=>s.index-r.index),D=[];for(const s of C){let r=this._getOrCreateServiceInstance(s.id,w);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${s.id}.`);D.push(r)}let f=C.length>0?C[0].index:p.length;if(p.length!==f){console.warn(`[createInstance] First service dependency of ${c.name} at position ${f+1} conflicts with ${p.length} static arguments`);let s=f-p.length;s>0?p=p.concat(new Array(s)):p=p.slice(0,f)}return new c(...[...p,...D])}_setServiceInstance(c,p){if(this._services.get(c)instanceof A.SyncDescriptor)this._services.set(c,p);else if(this._parent)this._parent._setServiceInstance(c,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let p=this._services.get(c);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):p}_getOrCreateServiceInstance(c,p){let w=this._getServiceInstanceOrDescriptor(c);return w instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,w,p.branch(c,!0)):(p.branch(c,!1),w)}_safeCreateAndCacheServiceInstance(c,p,w){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,p,w)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,p,w){const C=new k.Graph(s=>s.id.toString());let D=0;const f=[{id:c,desc:p,_trace:w}];for(;f.length;){const s=f.pop();if(C.lookupOrInsertNode(s),D++>1e3)throw new v(C);for(let r of L._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(r.id);if(!t&&!r.optional&&console.warn(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:r.id,desc:t,_trace:s._trace.branch(r.id,!0)};C.insertEdge(s,i),f.push(i)}}}for(;;){const s=C.roots();if(s.length===0){if(!C.isEmpty())throw new v(C);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}C.removeNode(r)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,p,w=[],C,D){if(this._services.get(c)instanceof A.SyncDescriptor)return this._createServiceInstance(p,w,C,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,p,w,C,D);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(c,p=[],w,C){if(w){const D=new O.IdleValue(()=>this._createInstance(c,p,C));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let r=D.value,t=r[s];return typeof t!="function"||(t=t.bind(r),f[s]=t),t},set(f,s,r){return D.value[s]=r,!0}})}else return this._createInstance(c,p,C)}}e.InstantiationService=R;var g;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(g||(g={}));class y{constructor(c,p){this.type=c,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return m?new y(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(c){return m?new y(0,c.name):y._None}branch(c,p){let w=new y(2,c.toString());return this._dep.push([c,p,w]),w}stop(){let c=Date.now()-this._start;y._totals+=c;let p=!1;function w(D,f){let s=[],r=new Array(D+1).join("	");for(const[t,i,n]of f._dep)if(i&&n){p=!0,s.push(`${r}CREATES -> ${t}`);let o=w(D+1,n);o&&s.push(o)}else s.push(`${r}uses -> ${t}`);return s.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(c>2||p)&&console.log(C.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(A,L){this.server=A,this.router=L}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,L){this.server.registerChannel(A,L)}}e.MessagePortMainProcessService=S}),define(Z[149],ee([0,1,34,50,136,5]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(b,c,p){const w=p.getChannel(b);return O(c)?new c.channelClientCtor(w):S.ProxyChannel.toService(w,c==null?void 0:c.proxyOptions)}}function O(y){const b=y;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let m=class extends U{constructor(b,c,p){super(b,c,p)}};m=he([Y(2,e.IMainProcessService)],m);function v(y,b,c){(0,A.registerSingleton)(y,new k.SyncDescriptor(m,[b,c],c==null?void 0:c.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=v,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let R=class extends U{constructor(b,c,p){super(b,c,p)}};R=he([Y(2,e.ISharedProcessService)],R);function g(y,b,c){(0,A.registerSingleton)(y,new k.SyncDescriptor(R,[b,c],c==null?void 0:c.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=g}),define(Z[55],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function k(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const L of A.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[150],ee([0,1,2,55]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends S.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=he([Y(0,k.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[17],ee([0,1,5,2,7,3,43]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function O(){return new Date().toISOString()}var m;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class v extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class R extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let o=t[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(n>0?" ":"")+o}return i}}e.AbstractMessageLogger=R;class g extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}debug(t,...i){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}info(t,...i){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}warn(t,...i){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${O()}][0m`,t,...i):console.warn(`[main ${O()}]`,t,...i))}error(t,...i){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}critical(t,...i){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class y extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=y;class b extends v{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class c extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=p;class w extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?m.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class C{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=C;function D(r){if(r.verbose)return m.Trace;if(typeof r.logLevel=="string"){const t=f(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function f(r){switch(r){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=f;function s(r){switch(r){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=s}),define(Z[151],ee([0,1,27,2,10,29,9,4,12,33,17,31,56,7,6,11]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let C=class extends k.Disposable{constructor(f,s,r,t){super();this.fileService=s,this.extensionGalleryService=r,this.logService=t,this.extensionsDownloadDir=O.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const r=this.getName(f),t=(0,m.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(t)){const i=(0,m.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,s);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,p.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(f){}async rename(f,s,r){try{await S.promises.rename(f.fsPath,s.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,r);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],r=[];for(const n of f.children){const o=this.parse(n.name);o&&r.push([o,n])}const t=(0,v.groupByExtension)(r,([n])=>n),i=[];for(const n of t)n.sort((o,a)=>y.rcompare(o[0].version,a[0].version)),s.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new v.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,g.generateUuid)()}parse(f){const s=w.exec(f);return s&&s[1]&&s[2]?new v.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};C=he([Y(0,U.INativeEnvironmentService),Y(1,A.IFileService),Y(2,L.IExtensionGalleryService),Y(3,R.ILogService)],C),e.ExtensionsDownloader=C}),define(Z[152],ee([0,1,2,17,48,43,8,6,3,16,24,9]),function(K,e,S,k,A,L,U,O,m,v,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends S.Disposable{constructor(c,p){super();this.environmentService=c,this.logService=p,this.processesLimiter=new O.Limiter(5)}async postUninstall(c){const p=this.parseScript(c,"uninstall");return p&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${w}`)))),(0,R.rimraf)(this.getExtensionStoragePath(c)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(c,p){const w=`vscode:${p}`;if(c.location.scheme===v.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[w]=="string"){const C=c.manifest.scripts[w].split(" ");return C.length<2||C[0]!=="node"||!C[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${w} should be a node script`),null):{script:(0,U.join)(c.location.fsPath,C[1]),args:C.slice(2)||[]}}return null}runLifecycleHook(c,p,w,C,D){return new Promise((f,s)=>{const r=this.start(c,p,w,D);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?s(n):f(void 0)};r.on("error",n=>{i((0,L.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,o)=>{i(n?`post-${p} process exited with code ${n}`:void 0)}),C&&(t=setTimeout(()=>{t=null,r.kill(),s("timed out")},5e3))})}start(c,p,w,C){const D={silent:!0,execArgv:void 0},f=(0,A.fork)(c,[`--type=extension-post-${p}`,...w],D);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=m.Event.fromNodeEventEmitter(f.stdout,"data"),r=m.Event.fromNodeEventEmitter(f.stderr,"data");s(n=>this.logService.info(C.identifier.id,C.manifest.version,`post-${p}`,n)),r(n=>this.logService.error(C.identifier.id,C.manifest.version,`post-${p}`,n));const t=m.Event.any(m.Event.map(s,n=>({data:`%c${n}`,format:[""]})),m.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return m.Event.debounce(t,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(C.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(c){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};y=he([Y(0,g.IEnvironmentService),Y(1,k.ILogService)],y),e.ExtensionsLifecycle=y}),define(Z[153],ee([0,1,2,9,3,10,4,33,12,17]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends S.Disposable{constructor(y,b,c,p){super();this.extensionsManagementService=y,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(D=>this.onInstallExtension(D))),this._register(y.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(y.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const w=U.URI.file(c.extensionsPath),C=new m.ExtUri(D=>!b.hasCapability(D,1024));this._register(b.watch(w)),this._register(A.Event.filter(b.onDidFilesChange,D=>D.changes.some(f=>this.doesChangeAffects(f,w,C)))(()=>this.onDidChange()))}doesChangeAffects(y,b,c){return c.isEqual(c.dirname(y.resource),b)?c.isEqual(y.resource,c.joinPath(b,".obsolete"))?!0:!(y.type!==1&&y.type!==2||c.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtension(y){this.removeInstallingExtension(y.identifier),y.error||this.addInstalledExtension(y.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(b=>!(0,O.areSameExtensions)(b,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,O.areSameExtensions)(b,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),b=y.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,O.areSameExtensions)(w,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),c=this.installedExtensions.filter(p=>this.installingExtensions.some(w=>(0,O.areSameExtensions)(w,p))?!1:y.every(w=>!(0,O.areSameExtensions)(w.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=y.map(p=>p.identifier),(b.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:c})}}};R=he([Y(1,L.IFileService),Y(2,k.INativeEnvironmentService),Y(3,v.ILogService)],R),e.ExtensionsWatcher=R}),define(Z[154],ee([0,1,24,27,145,29,2,9,6,33,17,55,18,3,16,8]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let w=class extends U.Disposable{constructor(f,s,r){super();this.extensionManagementService=f,this.logService=r,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new C(s,r)),this._register(f.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(f.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(f=>{const s=["en",...Object.keys(f)];return(0,y.distinct)(s)})}onDidInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",f.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(f){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(t=>(0,v.areSameExtensions)(t.extensionIdentifier,f)))&&(this.logService.debug("Removing language packs from the extension",f.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[f,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,y.equals)(Object.keys(f),Object.keys(r))}};w=he([Y(0,L.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,R.ILogService)],w),e.LocalizationsService=w;let C=class extends U.Disposable{constructor(f,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new m.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,r);Object.keys(f).forEach(r=>this.updateHash(f[r]))}createLanguagePacksFromExtension(f,s){const r=s.identifier,t=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of t)if(s.location.scheme===c.Schemas.file&&(0,g.isValidLocalization)(i)){let n=f[i.languageId];n||(n={hash:"",extensions:[],translations:{}},f[i.languageId]=n);let o=n.extensions.filter(a=>(0,v.areSameExtensions)(a.extensionIdentifier,r))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const a of i.translations)n.translations[a.id]=(0,p.join)(s.location.fsPath,a.path)}}updateHash(f){if(f){const s=(0,A.createHash)("md5");for(const r of f.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);f.hash=s.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return k.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(t){return{}}}).then(r=>(s=f(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,S.writeFile)(this.languagePacksFilePath,t)}).then(()=>s,r=>this.logService.error(r))})}};C=he([Y(0,O.INativeEnvironmentService),Y(1,R.ILogService)],C)}),define(Z[75],ee([0,1,17,3,4]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(y){this.service=y,this.onDidChangeLogLevel=k.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(y,b,c){switch(b){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=L;class U{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){U.setLevel(this.channel,y)}static setLevel(y,b){return y.call("setLevel",b)}}e.LogLevelChannelClient=U;class O{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,b){throw new Error(`Event not found: ${b}`)}async call(y,b,c){switch(b){case"createLogger":this.createLogger(A.URI.revive(c[0]),c[1]);return;case"log":return this.log(A.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${b}`)}createLogger(y,b){this.loggers.set(y.toString(),this.loggerService.createLogger(y,b))}consoleLog(y,b){let c=console.log;switch(y){case S.LogLevel.Error:c=console.error;break;case S.LogLevel.Warning:c=console.warn;break;case S.LogLevel.Info:c=console.info;break}c.call(console,...b)}log(y,b){const c=this.loggers.get(y.toString());if(!c)throw new Error("Create the logger before logging");for(const[p,w]of b)switch(p){case S.LogLevel.Trace:c.trace(w);break;case S.LogLevel.Debug:c.debug(w);break;case S.LogLevel.Info:c.info(w);break;case S.LogLevel.Warning:c.warn(w);break;case S.LogLevel.Error:c.error(w);break;case S.LogLevel.Critical:c.critical(w);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=O;class m extends S.AbstractLoggerService{constructor(y,b,c){super(y,b);this.channel=c}createConsoleMainLogger(){return new S.AdapterLogger({log:(y,b)=>{this.channel.call("consoleLog",[y,b])}})}doCreateLogger(y,b,c){return new v(this.channel,y,b,c)}}e.LoggerChannelClient=m;class v extends S.AbstractMessageLogger{constructor(y,b,c,p){super(p==null?void 0:p.always);this.channel=y,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[b,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,b){const c=[[y,b]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(y){this.channel.call("log",[this.file,y])}}class R extends S.LogService{constructor(y,b){super(b);this.parent=y,this._register(y.onDidChangeLogLevel(c=>b.setLevel(c)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=R}),define(Z[57],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,7,36,12]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof k.globals.vscode!="undefined"){const O=k.globals.vscode.context.configuration();if(O)U=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const O=(0,L.dirname)(S.FileAccess.asFileUri("",K));U=K.__$__nodeRequire((0,L.joinPath)(O,"product.json").fsPath);const m=K.__$__nodeRequire((0,L.joinPath)(O,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:m.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.56.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[76],ee([0,1,115,23,10,11,51]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(g,y,b,c,p,w){let C;try{await m(g,y,b,c,p,w)}catch(D){C=D}finally{C&&p.errorTransformer&&(C=p.errorTransformer(C)),typeof C!="undefined"&&b.error(C),b.end()}}e.readFileIntoStream=O;async function m(g,y,b,c,p,w){v(w);const C=await g.open(y,{create:!1});try{v(w);let D=0,f=0,s=p&&typeof p.length=="number"?p.length:void 0,r=k.VSBuffer.alloc(Math.min(p.bufferSize,typeof s=="number"?s:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,i=0;do f=await g.read(C,t,r.buffer,i,r.byteLength-i),t+=f,i+=f,D+=f,typeof s=="number"&&(s-=f),i===r.byteLength&&(await b.write(c(r)),r=k.VSBuffer.alloc(Math.min(p.bufferSize,typeof s=="number"?s:p.bufferSize)),i=0);while(f>0&&(typeof s!="number"||s>0)&&v(w)&&R(D,p));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),b.write(c(r.slice(0,n)))}}catch(D){throw(0,A.ensureFileSystemProviderError)(D)}finally{await g.close(C)}}function v(g){if(g.isCancellationRequested)throw(0,L.canceled)();return!0}function R(g,y){if(y==null?void 0:y.limits){if(typeof y.limits.memory=="number"&&g>y.limits.memory)throw(0,A.createFileSystemProviderError)((0,S.localize)(0,null,U.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&g>y.limits.size)throw(0,A.createFileSystemProviderError)((0,S.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[155],ee([0,1,113,156,2,10,3,12,37,18,17,23,47,6,30,16,76,53]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class extends A.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const t=new A.DisposableStore;return t.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new L.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),t.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&t.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,A.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){r.push(t)}}),!this.provider.has(s)&&await b.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return C.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,O.isAbsolutePath)(s))throw new L.FileOperationError((0,S.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,s.toString()),t}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasReadWriteCapability)(r)||(0,L.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,L.hasOpenReadWriteCloseCapability)(r)||(0,L.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(t){throw(0,L.toFileSystemProviderErrorCode)(t)===L.FileSystemProviderErrorCode.FileNotFound?new L.FileOperationError((0,S.localize)(2,null,this.resourceForError(s)),1):(0,L.ensureFileSystemProviderError)(t)}}async doResolveFile(s,r){const t=await this.withProvider(s),i=this.isPathCaseSensitive(t),n=r==null?void 0:r.resolveTo,o=r==null?void 0:r.resolveSingleChildDescendants,a=r==null?void 0:r.resolveMetadata,l=await t.stat(s);let u;return this.toFileStat(t,s,l,void 0,!!a,(d,E)=>(u||(u=m.TernarySearchTree.forUris(()=>!i),u.set(s,!0),(0,v.isNonEmptyArray)(n)&&n.forEach(h=>u.set(h,!0))),Boolean(u.findSuperstr(d.resource)||u.get(d.resource))?!0:d.isDirectory&&o?E===1:!1))}async toFileStat(s,r,t,i,n,o){const{providerExtUri:a}=this.getExtUri(s),l={resource:r,name:a.basename(r),isFile:(t.type&L.FileType.File)!=0,isDirectory:(t.type&L.FileType.Directory)!=0,isSymbolicLink:(t.type&L.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,L.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&o(l,i)){try{const u=await s.readdir(r),d=await b.Promises.settled(u.map(async([E,h])=>{try{const P=a.joinPath(r,E),_=n?await s.stat(P):{type:h};return await this.toFileStat(s,P,_,u.length,n,o)}catch(P){return this.logService.trace(P),null}}));l.children=(0,v.coalesce)(d)}catch(u){this.logService.trace(u),l.children=[]}return l}return l}async resolveAll(s){return b.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(t){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(t){return t}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new L.FileOperationError((0,S.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new L.FileOperationEvent(s,0,i)),i}async writeFile(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,t)||await this.mkdirp(i,n.dirname(s));let a;if((0,L.hasReadWriteCapability)(i)&&!(r instanceof g.VSBuffer))if((0,y.isReadableStream)(r)){const l=await(0,y.peekStream)(r,3);l.ended?a=g.VSBuffer.concat(l.buffer):a=l}else a=(0,y.peekReadable)(r,l=>g.VSBuffer.concat(l),3);else a=r;!(0,L.hasOpenReadWriteCloseCapability)(i)||(0,L.hasReadWriteCapability)(i)&&a instanceof g.VSBuffer?await this.doWriteUnbuffered(i,s,t,a):await this.doWriteBuffered(i,s,t,a instanceof g.VSBuffer?(0,g.bufferToReadable)(a):a)}catch(o){throw new L.FileOperationError((0,S.localize)(4,null,this.resourceForError(s),(0,L.ensureFileSystemProviderError)(o).toString()),(0,L.toFileOperationResult)(o),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,t){if(!!(t==null?void 0:t.unlock)&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(o){return}if((n.type&L.FileType.Directory)!=0)throw new L.FileOperationError((0,S.localize)(6,null,this.resourceForError(r)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,L.etag)({mtime:t.mtime,size:n.size}))throw new L.FileOperationError((0,S.localize)(7,null),3,t);return n}async readFile(s,r){const t=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(t,s,r):this.doReadFile(t,s,r)}async doReadFileAtomic(s,r,t){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,r,t);i(o)}catch(o){n(o)}})})}async doReadFile(s,r,t){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,g.streamToBuffer)(i.value)})}async readFileStream(s,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,r)}async doReadFileStream(s,r,t){const i=new c.CancellationTokenSource,n=this.validateReadFile(r,t).then(a=>a,a=>{throw i.cancel(),a});let o;try{t&&typeof t.etag=="string"&&t.etag!==L.ETAG_DISABLED&&await n,!((0,L.hasOpenReadWriteCloseCapability)(s)||(0,L.hasFileReadStreamCapability)(s))||(0,L.hasReadWriteCapability)(s)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(s,r,t):(0,L.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,r,i.token,t):o=this.readFileBuffered(s,r,i.token,t);const a=await n;return Object.assign(Object.assign({},a),{value:o})}catch(a){throw o&&await(0,y.consumeStream)(o),new L.FileOperationError((0,S.localize)(8,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(a).toString()),(0,L.toFileOperationResult)(a),t)}}readFileStreamed(s,r,t,i=Object.create(null)){const n=s.readFileStream(r,i,t);return(0,y.transform)(n,{data:o=>o instanceof g.VSBuffer?o:g.VSBuffer.wrap(o),error:o=>new L.FileOperationError((0,S.localize)(9,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(o).toString()),(0,L.toFileOperationResult)(o),i)},o=>g.VSBuffer.concat(o))}readFileBuffered(s,r,t,i=Object.create(null)){const n=(0,g.newWriteableBufferStream)();return(0,w.readFileIntoStream)(s,r,n,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new L.FileOperationError((0,S.localize)(10,null,this.resourceForError(r),(0,L.ensureFileSystemProviderError)(o).toString()),(0,L.toFileOperationResult)(o),i)}),t),n}readFileUnbuffered(s,r,t){const i=(0,y.newWriteableStream)(n=>g.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(r,n.byteLength,t),i.end(g.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new L.FileOperationError((0,S.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==L.ETAG_DISABLED&&r.etag===t.etag)throw new L.FileOperationError((0,S.localize)(12,null),2,r);return this.validateReadFileLimits(s,t.size,r),t}validateReadFileLimits(s,r,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new L.FileOperationError((0,S.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,t){return this.doCanMoveCopy(s,r,"move",t)}async canCopy(s,r,t){return this.doCanMoveCopy(s,r,"copy",t)}async doCanMoveCopy(s,r,t,i){if(s.toString()!==r.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,o,r,t,i)}catch(n){return n}return!0}async move(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"move",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(s,o==="move"?2:3,a)),a}async copy(s,r,t){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"copy",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(s,o==="copy"?3:2,a)),a}async doMoveCopy(s,r,t,i,n,o){if(r.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(s,r,t,i,n,o);if(a&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(s===t&&(0,L.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:o});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(s,u,t,i):await this.doCopyFile(s,r,t,i)}return n}else return s===t?(await s.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(s,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,t,i){if((0,L.hasOpenReadWriteCloseCapability)(s)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,r,t,i);if((0,L.hasOpenReadWriteCloseCapability)(s)&&(0,L.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,r,t,i);if((0,L.hasReadWriteCapability)(s)&&(0,L.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,r,t,i);if((0,L.hasReadWriteCapability)(s)&&(0,L.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,r,t,i)}async doCopyFolder(s,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await b.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),t,o):this.doCopyFile(s,n.resource,t,o)}))}async doValidateMoveCopy(s,r,t,i,n,o){let a=!1;if(s===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(s);if(d||(a=u.isEqual(r,i)),a&&n==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&u.isEqualOrParent(i,r))throw new Error((0,S.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!o)throw new L.FileOperationError((0,S.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===t){const{providerExtUri:u}=this.getExtUri(s);if(u.isEqualOrParent(r,i))throw new Error((0,S.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?O.extUri:O.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new L.FileOperationEvent(s,0,t)),t}async mkdirp(s,r){const t=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&L.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,L.toFileSystemProviderErrorCode)(n)!==L.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(r)),r=i.dirname(r)}for(let n=t.length-1;n>=0;n--){r=i.joinPath(r,t[n]);try{await s.mkdir(r)}catch(o){if((0,L.toFileSystemProviderErrorCode)(o)!==L.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(t){return t}return!0}async doValidateDelete(s,r){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new L.FileOperationError((0,S.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(s)))}return t}async del(s,r){const t=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await t.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new L.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(s,r).then(n=>{t?(0,A.dispose)(n):i=()=>(0,A.dispose)(n)},n=>this.logService.error(n)),(0,A.toDisposable)(()=>i())}async doWatch(s,r){const t=await this.withProvider(s),i=this.toWatchKey(t,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,A.toDisposable)(()=>{n.count--,n.count===0&&((0,A.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,t){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,A.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const o=await s.open(r,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,o,i):await this.doWriteReadableBufferedQueued(s,o,i)}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await s.close(o)}})}async doWriteStreamBufferedQueued(s,r,t){let i=0,n;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(o,a)=>{(0,y.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(s,r,l,l.byteLength,i,0)}catch(u){return a(u)}i+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>a(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,r,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,t,i,n,o){let a=0;for(;a<i;)a+=await s.write(r,n+a,t.buffer,o+a,i-a)}async doWriteUnbuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,t,i))}async doWriteUnbufferedQueued(s,r,t,i){var n;let o;i instanceof g.VSBuffer?o=i:(0,y.isReadableStream)(i)?o=await(0,g.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?o=await(0,g.bufferedStreamToBuffer)(i):o=(0,g.readableToBuffer)(i),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,t,i))}async doPipeBufferedQueued(s,r,t,i){let n,o;try{n=await s.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const a=g.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,d=0;do d=await s.read(n,l,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(t,o,a,d,l,u),l+=d,u+=d,u===a.byteLength&&(u=0);while(d>0)}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,t,i))}async doPipeUnbufferedQueued(s,r,t,i){return t.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,t,i))}async doPipeUnbufferedToBufferedQueued(s,r,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(r);await this.doWriteBuffer(t,n,g.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,L.ensureFileSystemProviderError)(o)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(s,r,t,i){const n=await(0,g.streamToBuffer)(this.readFileBuffered(s,r,c.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new L.FileOperationError((0,S.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}};D=he([Y(0,R.ILogService)],D),e.FileService=D}),define(Z[157],ee([0,1,27,94,2,10,3,7,24,8,12,42,6,17,116,73,133,135,132,146,47,76,18,23]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends A.Disposable{constructor(a,l){var u;super();this.logService=a,this.options=l,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:l,symbolicLink:u}=await m.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(l,u),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(a){try{const l=await(0,m.readdir)(this.toFilePath(a),{withFileTypes:!0}),u=[];return await Promise.all(l.map(async d=>{try{let E;d.isSymbolicLink()?E=(await this.stat((0,R.joinPath)(a,d.name))).type:E=this.toType(d),u.push([d.name,E])}catch(E){this.logService.trace(E)}})),u}catch(l){throw this.toFileSystemProviderError(l)}}toType(a,l){let u;return(l==null?void 0:l.dangling)?u=L.FileType.Unknown:a.isFile()?u=L.FileType.File:a.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,l&&(u|=L.FileType.SymbolicLink),u}async readFile(a){try{const l=this.toFilePath(a);return await S.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(a,l,u){const d=(0,s.newWriteableStream)(E=>i.VSBuffer.concat(E.map(h=>i.VSBuffer.wrap(h))).buffer);return(0,r.readFileIntoStream)(this,a,d,E=>E.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),u),d}async writeFile(a,l,u){let d;try{const E=this.toFilePath(a);if(!u.create||!u.overwrite){if(await(0,m.exists)(E)){if(!u.overwrite)throw(0,L.createFileSystemProviderError)((0,c.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,L.createFileSystemProviderError)((0,c.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(a,{create:!0,unlock:u.unlock}),await this.write(d,0,l,0,l.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(a,E)}finally{typeof d=="number"&&await this.close(d)}}async open(a,l){try{const u=this.toFilePath(a);if((0,L.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(u);h.mode&128||await S.promises.chmod(u,h.mode|128)}catch(h){this.logService.trace(h)}let d;if((0,L.isFileOpenForWriteOptions)(l)){if(O.isWindows)try{await S.promises.truncate(u,0),d="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}d||(d="w")}else d="r";const E=await(0,k.promisify)(S.open)(u,d);return this.mapHandleToPos.set(E,0),(0,L.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(E,a),E}catch(u){throw(0,L.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(a,u):this.toFileSystemProviderError(u)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await(0,k.promisify)(S.fdatasync)(a)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,k.promisify)(S.close)(a)}catch(l){throw this.toFileSystemProviderError(l)}}async read(a,l,u,d,E){const h=this.normalizePos(a,l);let P=null;try{const _=await(0,k.promisify)(S.read)(a,u,d,E,h);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(a,h,P)}}normalizePos(a,l){return l===this.mapHandleToPos.get(a)?null:l}updatePos(a,l,u){const d=this.mapHandleToPos.get(a);typeof d=="number"&&(typeof l=="number"||(typeof u=="number"?this.mapHandleToPos.set(a,d+u):this.mapHandleToPos.delete(a)))}async write(a,l,u,d,E){return(0,y.retry)(()=>this.doWrite(a,l,u,d,E),100,3)}async doWrite(a,l,u,d,E){const h=this.normalizePos(a,l);let P=null;try{const _=await(0,k.promisify)(S.write)(a,u,d,E,h);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),_)}finally{this.updatePos(a,h,P)}}async mkdir(a){try{await S.promises.mkdir(this.toFilePath(a))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(a,l){try{const u=this.toFilePath(a);await this.doDelete(u,l)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(a,l){l.recursive?await(0,m.rimraf)(a,m.RimRafMode.MOVE):await S.promises.unlink(a)}async rename(a,l,u){const d=this.toFilePath(a),E=this.toFilePath(l);if(d!==E)try{await this.validateTargetDeleted(a,l,"move",u.overwrite),await(0,m.move)(d,E)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,c.localize)(2,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(E)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(a,l,u){const d=this.toFilePath(a),E=this.toFilePath(l);if(d!==E)try{await this.validateTargetDeleted(a,l,"copy",u.overwrite),await(0,m.copy)(d,E,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,c.localize)(3,null,(0,v.basename)(d),(0,v.basename)((0,v.dirname)(E)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(a,l,u,d){const E=this.toFilePath(a),h=this.toFilePath(l);let P=!1;if(!!(this.capabilities&1024)||(P=(0,g.isEqual)(E,h,!0)),P&&u==="copy")throw(0,L.createFileSystemProviderError)((0,c.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,m.exists)(h)){if(!d)throw(0,L.createFileSystemProviderError)((0,c.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(a,l){return l.recursive?this.watchRecursive(a,l.excludes):this.watchNonRecursive(a)}watchRecursive(a,l){const u={path:this.toFilePath(a),excludes:l},d=(0,t.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var a,l,u;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let d,E;((l=(a=this.options)===null||a===void 0?void 0:a.watcher)===null||l===void 0?void 0:l.usePolling)?(d=w.FileWatcher,E=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?O.isWindows?d=C.FileWatcher:d=w.FileWatcher:d=D.FileWatcher,this.recursiveWatcher=new d(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,p.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===b.LogLevel.Trace,E),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(a){const l=new f.FileWatcher(this.toFilePath(a),d=>this._onDidChangeFile.fire((0,p.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===b.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,A.combinedDisposable)(l,u)}toFilePath(a){return(0,v.normalize)(a.fsPath)}toFileSystemProviderError(a){if(a instanceof L.FileSystemProviderError)return a;let l;switch(a.code){case"ENOENT":l=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=L.FileSystemProviderErrorCode.NoPermissions;break;default:l=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(a,l)}async toFileSystemProviderWriteError(a,l){let u=this.toFileSystemProviderError(l);if(a&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await m.SymlinkSupport.stat(this.toFilePath(a));d.mode&128||(u=(0,L.createFileSystemProviderError)(l,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return u}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=n}),define(Z[28],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(Z[158],ee([0,1,27,8,24,28,2,11,17,9]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends U.Disposable{constructor(y,b,c){super();this._environmentService=y,this._logService=b,this._productService=c,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let y=setTimeout(async()=>{y=void 0,this._logService.info("Starting to clean up unused language packs.");try{const b=Object.create(null),c=JSON.parse(await S.promises.readFile(k.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let D of Object.keys(c)){const f=c[D];b[`${f.hash}.${D}`]=!0}const p=k.join(this._environmentService.userDataPath,"clp");if(!await A.exists(p))return;for(let D of await A.readdir(p)){if(b[D]){this._logService.info(`Skipping directory ${D}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",D),await A.rimraf(k.join(p,D))}const C=Date.now();for(let D of Object.keys(b)){const f=k.join(p,D);for(let s of await A.readdir(f))if(s!=="tcf.json"){const r=k.join(f,s),t=await S.promises.stat(r);t.isDirectory()&&C-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",k.join(D,s)),await A.rimraf(r))}}}catch(b){(0,O.onUnexpectedError)(b)}},40*1e3);this._register((0,U.toDisposable)(()=>{y!==void 0&&clearTimeout(y)}))}};R=he([Y(0,v.INativeEnvironmentService),Y(1,m.ILogService),Y(2,L.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(Z[159],ee([0,1,27,8,11,2,24,28]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let m=class{constructor(R,g){this.nodeCachedDataDir=R,this.productService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new L.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const R=(0,k.dirname)(this.nodeCachedDataDir),g=(0,k.basename)(this.nodeCachedDataDir);let y=setTimeout(()=>{y=void 0,(0,U.readdir)(R).then(b=>{const c=Date.now(),p=[];return b.forEach(w=>{if(w!==g){const C=(0,k.join)(R,w);p.push(S.promises.stat(C).then(D=>{if(D.isDirectory()&&c-D.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(C)}))}}),Promise.all(p)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,L.toDisposable)(()=>{y&&(clearTimeout(y),y=void 0)}))}}};m=he([Y(1,O.IProductService)],m),e.NodeCachedDataCleaner=m}),define(Z[35],ee([0,1,15,84]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(U,O){k.ok(S.isString(U)),k.ok(S.isObject(O)),k.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,O)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new A}),define(Z[77],ee([0,1,35,3]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,v){this.schemasById[A(m)]=v,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new L;S.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[39],ee([0,1,106,3,35,15,77]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=A.Registry.as(U.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,D=!0){this.registerConfigurations([C],D)}registerConfigurations(C,D=!0){const f=[];C.forEach(s=>{f.push(...this.validateAndRegisterProperties(s,D,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(C){const D=[],f=s=>{if(s.properties)for(const r in s.properties)D.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>f(r))};for(const s of C){f(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(C){const D=[],f=[];for(const s of C)for(const r in s)if(D.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const t={type:"object",default:this.defaultValues[r],description:S.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};f.push(g(r)),this.configurationProperties[r]=t,this.defaultLanguageConfigurationOverridesNode.properties[r]=t}else{this.defaultValues[r]=s[r];const t=this.configurationProperties[r];t&&(this.updatePropertyDefaultValue(r,t),this.updateSchema(r,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(C){const D=[];for(const f of C)for(const s in f)if(D.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const D of C)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,D=!0,f,s=3){var r;s=L.isUndefinedOrNull(C.scope)?s:C.scope;let t=[],i=C.properties;if(i)for(let o in i){if(D&&c(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),e.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=L.isUndefinedOrNull(a.scope)?s:a.scope,a.requireTrust=L.isUndefinedOrNull(a.requireTrust)?!!((r=f==null?void 0:f.requireTrustForConfigurations)===null||r===void 0?void 0:r.includes(o)):a.requireTrust),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let n=C.allOf;if(n)for(let o of n)t.push(...this.validateAndRegisterProperties(o,D,f,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const D=f=>{let s=f.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let r=f.allOf;r&&r.forEach(D)};D(C)}updateSchema(C,D){switch(e.allSettings.properties[C]=D,D.scope){case 1:e.applicationSettings.properties[C]=D;break;case 2:e.machineSettings.properties[C]=D;break;case 6:e.machineOverridableSettings.properties[C]=D;break;case 3:e.windowSettings.properties[C]=D;break;case 4:e.resourceSettings.properties[C]=D;break;case 5:e.resourceSettings.properties[C]=D,this.resourceLanguageSettingsSchema.properties[C]=D;break}}removeFromSchema(C,D){switch(delete e.allSettings.properties[C],D.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const D=`[${C}]`,f={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,f),e.allSettings.properties[D]=f,e.applicationSettings.properties[D]=f,e.machineSettings.properties[D]=f,e.machineOverridableSettings.properties[D]=f,e.windowSettings.properties[D]=f,e.resourceSettings.properties[D]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,D){let f=this.defaultValues[C];L.isUndefined(f)&&(f=D.default),L.isUndefined(f)&&(f=y(D.type)),D.default=f}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function g(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=g;function y(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const b=new v;A.Registry.add(e.Extensions.Configuration,b);function c(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?S.localize(5,null,w):b.getConfigurationProperties()[w]!==void 0?S.localize(6,null,w):null:S.localize(4,null)}e.validateProperty=c;function p(){const w=[],C=b.getConfigurationProperties();for(const D of Object.keys(C))w.push([D,C[D].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(Z[25],ee([0,1,26,15,4,35,5,39]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function m(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=m;var v;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function g(i,n){const o=n?i?n.keys.filter(P=>i.keys.indexOf(P)===-1):[...n.keys]:[],a=i?n?i.keys.filter(P=>n.keys.indexOf(P)===-1):[...i.keys]:[],l=[];if(n&&i){for(const P of i.keys)if(n.keys.indexOf(P)!==-1){const _=C(i.contents,P),j=C(n.contents,P);S.equals(_,j)||l.push(P)}}const u=[],d=P=>{const _={};for(const j of P)for(const B of j.identifiers)_[r(B)]=j;return _},E=n?d(n.overrides):{},h=i?d(i.overrides):{};if(Object.keys(E).length)for(const P of o){const _=E[P];_&&u.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(h).length)for(const P of a){const _=h[P];_&&u.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(E).length&&Object.keys(h).length)for(const P of l){const _=h[P],j=E[P];if(_&&j){const B=g({contents:_.contents,keys:_.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});u.push([(0,O.overrideIdentifierFromKey)(P),[...B.added,...B.removed,...B.updated]])}}return{added:o,removed:a,updated:l,overrides:u}}e.compare=g;function y(i,n){const o=[];for(const a of Object.keys(i))if(O.OVERRIDE_PROPERTY_PATTERN.test(a)){const l={};for(const u in i[a])l[u]=i[a][u];o.push({identifiers:[(0,O.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(l),contents:b(l,n)})}return o}e.toOverrides=y;function b(i,n){const o=Object.create(null);for(let a in i)c(o,a,i[a],n);return o}e.toValuesTree=b;function c(i,n,o,a){const l=n.split("."),u=l.pop();let d=i;for(let E=0;E<l.length;E++){let h=l[E],P=d[h];switch(typeof P){case"undefined":P=d[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${l.slice(0,E+1).join(".")} is ${JSON.stringify(P)}`);return}d=P}if(typeof d=="object"&&d!==null)try{d[u]=o}catch(E){a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=c;function p(i,n){const o=n.split(".");w(i,o)}e.removeFromValueTree=p;function w(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(w(a,n),Object.keys(a).length===0&&delete i[o])}}function C(i,n,o){function a(d,E){let h=d;for(const P of E){if(typeof h!="object"||h===null)return;h=h[P]}return h}const l=n.split("."),u=a(i,l);return typeof u=="undefined"?o:u}e.getConfigurationValue=C;function D(i,n,o){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?k.isObject(i[a])&&k.isObject(n[a])?D(i[a],n[a],o):o&&(i[a]=n[a]):i[a]=n[a])})}e.merge=D;function f(){const i=L.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=f;function s(){const i=Object.create(null),n=L.Registry.as(O.Extensions.Configuration).getConfigurationProperties();for(let o in n){let a=n[o].default;c(i,o,a,l=>console.error(`Conflict in default settings: ${l}`))}return i}e.getDefaultValues=s;function r(i){return`[${i}]`}e.keyFromOverrideIdentifier=r;function t(i,n,o){const a=i.inspect(n),l=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:a.defaultValue}e.getMigratedSettingValue=t}),define(Z[160],ee([0,1,32,37,18,15,26,4,39,25,35,2,3]),function(K,e,S,k,A,L,U,O,m,v,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,v.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,v.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],l=i[o];l&&(typeof a=="object"&&typeof l=="object"?(a=U.deepClone(a),this.mergeContents(a,l)):a=l),n[o]=a}return new b(n,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),n=U.deepClone(this.overrides),o=[...this.keys];for(const a of t){this.mergeContents(i,a.contents);for(const l of a.overrides){const[u]=n.filter(d=>A.equals(d.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):n.push(U.deepClone(l))}for(const l of a.keys)o.indexOf(l)===-1&&o.push(l)}return new b(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&L.isObject(t[n])&&L.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=U.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,v.addToValueTree)(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,v.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class c extends b{constructor(){const t=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),n=[];for(const o of Object.keys(t))m.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,m.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,v.toValuesTree)(t[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,i,n)}}e.DefaultConfigurationModel=c;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!L.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:o,overrides:a,untrusted:l}=this.doParseRaw(t,i);this._configurationModel=new b(n,o,a),this._untrustedConfigurations=l||[]}doParseContent(t){let i={},n=null,o=[],a=[],l=[];function u(E){Array.isArray(o)?o.push(E):n&&(o[n]=E)}let d={onObjectBegin:()=>{let E={};u(E),a.push(o),o=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let E=[];u(E),a.push(o),o=E,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:u,onError:(E,h,P)=>{l.push({error:E,offset:h,length:P})}};if(t)try{S.visit(t,d),i=o[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return i}doParseRaw(t,i){const n=R.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,n,!0,i);t=o.raw;const a=(0,v.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),u=(0,v.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:l,overrides:u,untrusted:o.untrusted}}filter(t,i,n,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.isUntrusted))return{raw:t,untrusted:[]};const a={},l=[];for(let u in t)if(m.OVERRIDE_PROPERTY_PATTERN.test(u)&&n){const d=this.filter(t[u],i,!1,o);a[u]=d.raw,l.push(...d.untrusted)}else{const d=i[u],E=d?typeof d.scope!="undefined"?d.scope:3:void 0;(E===void 0||o.scopes===void 0||o.scopes.includes(E))&&(o.isUntrusted&&(d==null?void 0:d.requireTrust)?l.push(u):a[u]=t[u])}return{raw:a,untrusted:l}}}e.ConfigurationModelParser=p;class w extends g.Disposable{constructor(t,i,n,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=w;class C{constructor(t,i,n=new b,o=new b,a=new k.ResourceMap,l=new b,u=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new b,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const o=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,j=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(t):l.getValue(t),B=o.getValue(t),M=A.distinct(A.flatten(o.overrides.map($=>$.identifiers))).filter($=>o.getOverrideValue(t,$)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:E,userRemoteValue:h,workspaceValue:P,workspaceFolderValue:_,memoryValue:j,value:B,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:l.getValue(t),override:i.overrideIdentifier?l.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(o=>m.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,m.overrideIdentifierFromKey)(o),l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),d=[...u.filter(E=>l.indexOf(E)===-1),...l.filter(E=>u.indexOf(E)===-1),...l.filter(E=>!U.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,d]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,v.compare)(this.localUserConfiguration,t),l=[...i,...n,...o];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,v.compare)(this.remoteUserConfiguration,t);let l=[...i,...n,...o];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,v.compare)(this.workspaceConfiguration,t);let l=[...i,...n,...o];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:o,updated:a,removed:l,overrides:u}=(0,v.compare)(n,i);let d=[...o,...a,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,i),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:o,removed:a,overrides:l}=(0,v.compare)(i,void 0);return{keys:[...n,...o,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(t);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((l,u)=>(l.set(O.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new k.ResourceMap);return new C(i,n,new b,o,a,new b,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=C;function D(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,l])=>{const u=(0,k.getOrSet)(i,a,new Set);l.forEach(d=>u.add(d))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=D;class f{constructor(t,i,n,o){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const l=new b;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,a=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=(0,v.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(t=t[o],!t)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=f;class s extends f{constructor(t,i,n,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(Z[161],ee([0,1,35,39,2,25,160,3,6,12]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends A.Disposable{constructor(y,b){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,b)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new m.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,b){const c=typeof y=="string"?y:void 0,p=(0,L.isConfigurationOverrides)(y)?y:(0,L.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(c,p,void 0)}updateValue(y,b,c,p){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const b=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(c,b,1)}onDidDefaultConfigurationChange(y){const b=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,y);this.trigger(c,b,6)}trigger(y,b,c){const p=new U.ConfigurationChangeEvent(y,{data:b},this.configuration);p.source=c,p.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(Z[162],ee([0,1,25,17,100]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(O,m){this.configurationService=O,this.logService=m}request(O,m){return this.logService.trace("RequestService#request",O.url),O.proxyAuthorization||(O.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(O,m)}async resolveProxy(O){}};L=he([Y(0,S.IConfigurationService),Y(1,k.ILogService)],L),e.RequestService=L}),define(Z[40],ee([0,1,117,5,39,35,23]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function O(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=O;function m(c){return c.res.statusCode===204}async function v(c){if(!O(c))throw new Error("Server returned "+c.res.statusCode);return m(c)?null:(await(0,U.streamToBuffer)(c.stream)).toString()}e.asText=v;async function R(c){if(!O(c))throw new Error("Server returned "+c.res.statusCode);if(m(c))return null;const w=(await(0,U.streamToBuffer)(c.stream)).toString();try{return JSON.parse(w)}catch(C){throw C.message+=`:
`+w,C}}e.asJson=R;function g(c){b(c)}e.updateProxyConfigurationsScope=g;let y;function b(c){const p=L.Registry.as(A.Extensions.Configuration);y&&p.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),requireTrust:!0}}},p.registerConfiguration(y)}b(2)}),define(Z[163],ee([0,1,40,30,10,16]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(m,v){this.requestService=m,this.fileService=v}async download(m,v,R=k.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,v);return}const g={type:"GET",url:m.toString()},y=await this.requestService.request(g,R);if(y.res.statusCode===200)await this.fileService.writeFile(v,y.stream);else{const b=await(0,S.asText)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${b}`)}}};U=he([Y(0,S.IRequestService),Y(1,A.IFileService)],U),e.DownloadService=U}),define(Z[164],ee([0,1,28,10,18,62,40,30,17,12,128,2]),function(K,e,S,k,A,L,U,O,m,v,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends g.Disposable{constructor(c,p,w,C){super();this.fileService=c,this.productService=p,this.requestService=w,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:D})=>this.allConfigBasedTips.set(D.configPath,D))}getConfigBasedTips(c){return this.getValidConfigBasedTips(c)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(c){const p=[];for(const[w,C]of this.allConfigBasedTips)try{const D=await this.fileService.readFile((0,v.joinPath)(c,w)),f=new Map;(0,L.forEach)(C.recommendations,({key:r,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const i of t.remotes)f.set(i,{extensionId:r,extensionName:t.name,configName:C.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else p.push({extensionId:r,extensionName:t.name,configName:C.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,R.getDomainsOfRemotes)(D.value.toString(),[...f.keys()]);for(const r of s){const t=f.get(r);t&&p.push(t)}}catch(D){}return p}async fetchWorkspacesTips(){var c,p;if(!((c=this.productService.extensionsGallery)===null||c===void 0?void 0:c.recommendationsUrl))return[];try{const w=await this.requestService.request({type:"GET",url:(p=this.productService.extensionsGallery)===null||p===void 0?void 0:p.recommendationsUrl},O.CancellationToken.None);if(w.res.statusCode!==200)return[];const C=await(0,U.asJson)(w);return C?C.workspaceRecommendations||[]:[]}catch(w){return this.logService.error(w),[]}}};y=he([Y(0,k.IFileService),Y(1,S.IProductService),Y(2,U.IRequestService),Y(3,m.ILogService)],y),e.ExtensionTipsService=y}),define(Z[44],ee([0,1,31,23]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(L,U,O){let m=O&&O.get("storage.serviceMachineId",0)||null;if(m)return m;try{const R=(await U.readFile(L.serviceMachineIdResource)).value.toString();m=(0,S.isUUID)(R)?R:null}catch(v){m=null}if(!m){m=(0,S.generateUuid)();try{await U.writeFile(L.serviceMachineIdResource,k.VSBuffer.fromString(m))}catch(v){}}return O&&O.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=A}),define(Z[19],ee([0,1,5,3,2,15,67,6]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var v;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var R;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(R=e.StorageScope||(e.StorageScope={}));var g;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class y extends A.Disposable{constructor(w={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,C){C===m?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:C,target:this.getKeyTargets(w)[C]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,C,D){var f;return(f=this.getStorage(C))===null||f===void 0?void 0:f.get(w,D)}getBoolean(w,C,D){var f;return(f=this.getStorage(C))===null||f===void 0?void 0:f.getBoolean(w,D)}getNumber(w,C,D){var f;return(f=this.getStorage(C))===null||f===void 0?void 0:f.getNumber(w,D)}store(w,C,D,f){if((0,L.isUndefinedOrNull)(C)){this.remove(w,D);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(w,D,f),(s=this.getStorage(D))===null||s===void 0||s.set(w,C)})}remove(w,C){this.withPausedEmitters(()=>{var D;this.updateKeyTarget(w,C,void 0),(D=this.getStorage(C))===null||D===void 0||D.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,C){const D=[],f=this.getKeyTargets(w);for(const s of Object.keys(f))f[s]===C&&D.push(s);return D}updateKeyTarget(w,C,D){var f,s;const r=this.getKeyTargets(C);typeof D=="number"?r[w]!==D&&(r[w]=D,(f=this.getStorage(C))===null||f===void 0||f.set(m,JSON.stringify(r))):typeof r[w]=="number"&&(delete r[w],(s=this.getStorage(C))===null||s===void 0||s.set(m,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const C=this.get(m,w);if(C)try{return JSON.parse(C)}catch(D){}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(){var w,C,D,f;this._onWillSaveState.fire({reason:v.NONE}),await O.Promises.settled([(C=(w=this.getStorage(0))===null||w===void 0?void 0:w.whenFlushed())!==null&&C!==void 0?C:Promise.resolve(),(f=(D=this.getStorage(1))===null||D===void 0?void 0:D.whenFlushed())!==null&&f!==void 0?f:Promise.resolve()])}async logStorage(){var w,C,D,f,s,r;const t=(C=(w=this.getStorage(0))===null||w===void 0?void 0:w.items)!==null&&C!==void 0?C:new Map,i=(f=(D=this.getStorage(1))===null||D===void 0?void 0:D.items)!==null&&f!==void 0?f:new Map;return c(t,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends y{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=b;async function c(p,w,C,D){const f=a=>{try{return JSON.parse(a)}catch(l){return a}},s=new Map,r=new Map;p.forEach((a,l)=>{s.set(l,a),r.set(l,f(a))});const t=new Map,i=new Map;w.forEach((a,l)=>{t.set(l,a),i.set(l,f(a))}),console.group(`Storage: Global (path: ${C})`);let n=[];s.forEach((a,l)=>{n.push({key:l,value:a})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${D})`);let o=[];t.forEach((a,l)=>{o.push({key:l,value:a})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=c}),define(Z[165],ee([0,1,3,2,29,33,19,15]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends k.Disposable{constructor(g){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new v(g)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"})))}async enableExtension(g,y){return this._removeFromDisabledExtensions(g)?(this._onDidChangeEnablement.fire({extensions:[g],source:y}),!0):!1}async disableExtension(g,y){return this._addToDisabledExtensions(g)?(this._onDidChangeEnablement.fire({extensions:[g],source:y}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(g){let y=this.getDisabledExtensions();return y.every(b=>!(0,L.areSameExtensions)(b,g))?(y.push(g),this._setDisabledExtensions(y),!0):!1}_removeFromDisabledExtensions(g){let y=this.getDisabledExtensions();for(let b=0;b<y.length;b++){const c=y[b];if((0,L.areSameExtensions)(c,g))return y.splice(b,1),this._setDisabledExtensions(y),!0}return!1}_setDisabledExtensions(g){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,g)}_getExtensions(g){return this.storageManger.get(g,0)}_setExtensions(g,y){this.storageManger.set(g,y,0)}};m=he([Y(0,U.IStorageService)],m),e.GlobalExtensionEnablementService=m;class v extends k.Disposable{constructor(g){super();this.storageService=g,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(g.onDidChangeValue(y=>this.onDidStorageChange(y)))}get(g,y){let b;return y===0?((0,O.isUndefinedOrNull)(this.storage[g])&&(this.storage[g]=this._get(g,y)),b=this.storage[g]):b=this._get(g,y),JSON.parse(b)}set(g,y,b){let c=JSON.stringify(y.map(({id:w,uuid:C})=>({id:w,uuid:C})));this._get(g,b)!==c&&(b===0&&(y.length?this.storage[g]=c:delete this.storage[g]),this._set(g,y.length?c:void 0,b))}onDidStorageChange(g){if(g.scope===0&&!(0,O.isUndefinedOrNull)(this.storage[g.key])&&this._get(g.key,g.scope)!==this.storage[g.key]){const b=this.get(g.key,g.scope);delete this.storage[g.key];const c=this.get(g.key,g.scope),p=b.filter(C=>!c.some(D=>(0,L.areSameExtensions)(C,D))),w=c.filter(C=>!b.some(D=>(0,L.areSameExtensions)(D,C)));(p.length||w.length)&&this._onDidChange.fire([...p,...w])}}_get(g,y){return this.storageService.get(g,y,"[]")}_set(g,y,b){y?this.storageService.store(g,y,b,1):this.storageService.remove(g,b)}}e.StorageManager=v}),define(Z[166],ee([0,1,3,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R}async getItems(){const v={workspace:this.workspace},R=await this.channel.call("getItems",v);return new Map(R)}updateItems(v){const R={workspace:this.workspace};return v.insert&&(R.insert=Array.from(v.insert.entries())),v.delete&&(R.delete=Array.from(v.delete.values())),this.channel.call("updateItems",R)}}class L extends A{constructor(v){super(v,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(v=>this.onDidChangeGlobalStorage(v)))}onDidChangeGlobalStorage(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this._onDidChangeItemsExternal.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}async close(){this.dispose()}}class U extends A{constructor(v,R){super(v,R);this.onDidChangeItemsExternal=S.Event.None}async close(){const v={workspace:this.workspace};return this.channel.call("close",v)}}class O extends k.Disposable{constructor(v,R){super();this.channel=v,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=O}),define(Z[167],ee([0,1,2,19,67,6,156,166,12]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class v extends k.AbstractStorageService{constructor(g,y,b){super();this.mainProcessService=y,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(g)}createGlobalStorage(){const g=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),y=new A.Storage(g.globalStorage);return this._register(y.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),y}createWorkspaceStorage(g){const y=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),g);if(y.workspaceStorage){const b=new A.Storage(y.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(c=>this.emitDidChangeValue(1,c)),this.workspaceStorageId=g==null?void 0:g.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var g,y;(0,U.mark)("code/willInitStorage");try{await L.Promises.settled([this.globalStorage.init(),(y=(g=this.workspaceStorage)===null||g===void 0?void 0:g.init())!==null&&y!==void 0?y:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,m.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var g,y;this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),(y=(g=this.workspaceStorage)===null||g===void 0?void 0:g.close())!==null&&y!==void 0?y:Promise.resolve()])}async migrate(g){var y;const b=this.workspaceStorage,c=(y=b==null?void 0:b.items)!==null&&y!==void 0?y:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(g),await this.workspaceStorage.init();for(const[p,w]of c)this.workspaceStorage.set(p,w)}}e.NativeStorageService=v}),define(Z[168],ee([0,1,7,36,31,4]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function U(v){if(S.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function O(v,R,g,y,b,c,p,w,C,D){const f=Object.create(null);f["common.machineId"]=p,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=b,f.version=c,f["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,S.PlatformToString)(S.platform),f["common.nodePlatform"]=k.platform,f["common.nodeArch"]=y,f["common.product"]=D||"desktop";const s=m(w||[]);s&&(f["common.msftInternal"]=s);let r=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),S.isLinuxSnap&&(f["common.snap"]="true");const i=U(g);i&&(f["common.platformDetail"]=i);try{const n=await v.readFile(L.URI.file(C));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=O;function m(v){const R=k.env.USERDNSDOMAIN;if(!R)return!1;const g=R.toLowerCase();return v.some(y=>g===y)}}),define(Z[22],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[169],ee([0,1,38,92,69,27,8,32,95,28,7,4,22,53,16,10,24]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function C(t,i){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,a=new Map,l=2e4;function u(h,P,_,j){const B=P.substring(h.length+1);return new Promise(async M=>{var $,V,q;let H;try{H=await(0,w.readdir)(P,{withFileTypes:!0})}catch(T){M();return}if(j.count>=l){j.count+=H.length,j.maxReached=!0,M();return}let z=H.length;if(z===0){M();return}let I=H;j.count+H.length>l&&(j.maxReached=!0,z=l-j.count,I=H.slice(0,z)),j.count+=H.length;for(const T of I)if(T.isDirectory()){if(_.includes(T.name)||await u(h,(0,U.join)(P,T.name),_,j),--z==0){M();return}}else{const F=T.name.lastIndexOf(".");if(F>=0){const N=T.name.substring(F+1);N&&o.set(N,(($=o.get(N))!==null&&$!==void 0?$:0)+1)}for(const N of n)((V=N.relativePathPattern)===null||V===void 0?void 0:V.test(B))!==!1&&N.filePattern.test(T.name)&&a.set(N.tag,((q=a.get(N.tag))!==null&&q!==void 0?q:0)+1);if(--z==0){M();return}}})}const d={count:0,maxReached:!1};await u(t,t,i,d);const E=await s(t);return{configFiles:D(a),fileTypes:D(o),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:E}}e.collectWorkspaceStats=C;function D(t){return[...b.Iterable.map(t.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function f(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=f;function s(t){let i=new Map,n=(0,U.join)(t,".vscode","launch.json");return new Promise((o,a)=>{(0,L.exists)(n,l=>{if(l)(0,L.readFile)(n,(u,d)=>{if(u)return o([]);const E=[],h=(0,O.parse)(d.toString(),E);if(E.length)return console.log(`Unable to parse ${n}`),o([]);if((0,O.getNodeType)(h)==="object"&&h.configurations)for(const P of h.configurations){const _=P.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return o(D(i))});else return o([])})})}e.collectLaunchConfigs=s;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const o=S.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,m.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,l]=o,u=this.formatProcessList(i,a);return n.forEach(d=>{if((0,A.isRemoteDiagnosticError)(d))u+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(u+=`

Remote: ${d.hostName}`,d.processes&&(u+=`
${this.formatProcessList(i,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const E of Object.keys(d.workspaceMetadata)){const h=d.workspaceMetadata[E];let P=`${h.fileCount} files`;h.maxFilesReached&&(P=`more than ${P}`),l+=`|    Folder (${E}): ${P}`,l+=this.formatWorkspaceStats(h)}}}),{processInfo:u,workspaceInfo:l}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:l,cpus:u}=f(),d={os:l,memory:o,cpus:u,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(d.load=`${S.loadavg().map(E=>Math.round(E)).join(", ")}`),R.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(i,n){const o=[];return(0,m.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(l=>{if((0,A.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const u of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[u];let E=`${d.fileCount} files`;d.maxFilesReached&&(E=`more than ${E}`),o.push(`Folder (${u}): ${E}`),o.push(this.formatWorkspaceStats(d))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const l=(h,P)=>{const _=` ${h}(${P})`;a+_.length>o?(n.push(u),u="|                 ",a=u.length):a+=_.length,u+=_};let u="|      File types:";const d=10;let E=i.fileTypes.length>d?d:i.fileTypes.length;for(let h=0;h<E;h++){const P=i.fileTypes[h];l(P.name,P.count)}if(n.push(u),i.configFiles.length>=0&&(u="|      Conf files:",a=0,i.configFiles.forEach(h=>{l(h.name,h.count)}),n.push(u)),i.launchConfigFiles.length>0){let h="|      Launch Configs:";i.launchConfigFiles.forEach(P=>{h+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),n.push(h)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const u=g.URI.revive(l);if(u.scheme===c.Schemas.file){const d=u.fsPath;o.push(C(d,["node_modules",".git"]).then(E=>{let h=`${E.fileCount} files`;E.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,U.basename)(d)}): ${h}`),n.push(this.formatWorkspaceStats(E))}).catch(E=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${E.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,l){const u=l===0;let d;u?d=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(d=`${d} (${n.get(a.pid)})`));const E=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(E/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(a.children)&&a.children.forEach(h=>this.formatProcessItem(i,n,o,h,l+1))}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=g.URI.revive(n);if(o.scheme===c.Schemas.file){const a=o.fsPath;try{const l=await C(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),l.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),l.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})})}catch(l){}}}}};r=he([Y(0,y.ITelemetryService),Y(1,v.IProductService)],r),e.DiagnosticsService=r}),define(Z[170],ee([0,1,11,29,33,26,22,40,68,9,30,17,10,4,28,19,44,5,12]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var f;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished"})(f||(f={}));function s(...I){return String(I.reduce((T,F)=>T|F,0))}var r;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class a{constructor(T=o){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,F=this.state.pageSize){return new a(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:F}))}withFilter(T,...F){const N=[...this.state.criteria,...F.length?F.map(x=>({filterType:T,value:x})):[{filterType:T}]];return new a(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(T){return new a(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new a(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new a(Object.assign(Object.assign({},this.state),{flags:T.reduce((F,N)=>F|N,0)}))}withAssetTypes(...T){return new a(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:F,pageSize:N,sortBy:x,sortOrder:G,flags:J,assetTypes:Q}=this.state;return{filters:[{criteria:T,pageNumber:F,pageSize:N,sortBy:x,sortOrder:G}],assetTypes:Q,flags:J}}get searchText(){const T=this.state.criteria.filter(F=>F.filterType===r.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(I,T){const F=(I||[]).filter(N=>N.statisticName===T)[0];return F?F.value:0}function u(I){const T="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(N=>N.assetType.indexOf(T)===0).reduce((N,x)=>{const G=P(I,x.assetType);return G&&N.push([x.assetType.substring(T.length),G]),N},[])}function d(I){if(I.properties){const T=I.properties.filter(x=>x.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=T.filter(x=>F.test(x.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return P(I,t.Repository)}function E(I){return{uri:`${I.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${I.fallbackAssetUri}/${t.VSIX}`}}function h(I){const T=P(I,t.Icon);if(T)return T;const F=k.DefaultIconPath;return{uri:F,fallbackUri:F}}function P(I,T){return I.files.filter(N=>N.assetType===T)[0]?{uri:`${I.assetUri}/${T}`,fallbackUri:`${I.fallbackAssetUri}/${T}`}:null}function _(I,T){const F=I.properties?I.properties.filter(x=>x.key===T):[],N=F.length>0&&F[0].value;return N?N.split(",").map(x=>(0,A.adoptToGalleryExtensionId)(x)):[]}function j(I){const T=I.properties?I.properties.filter(F=>F.key===i.Engine):[];return T.length>0&&T[0].value||""}function B(I){const T=I.properties?I.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=T.length>0&&T[0].value||"";return F?F.split(","):[]}function M(I){return I.indexOf("preview")!==-1}function $(I){const T=I.properties?I.properties.find(F=>F.key===i.WebExtension):void 0;return!!T&&T.value==="true"}function V(I){return I.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,D.joinPath)(b.URI.parse(I.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function q(I,T,F,N,x){const G={manifest:P(T,t.Manifest),readme:P(T,t.Details),changelog:P(T,t.Changelog),license:P(T,t.License),repository:d(T),download:E(T),icon:h(T),coreTranslations:u(T)};return{identifier:{id:(0,A.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:T.version,date:T.lastUpdated,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,description:I.shortDescription||"",installCount:l(I.statistics,"install"),rating:l(I.statistics,"averagerating"),ratingCount:l(I.statistics,"ratingcount"),assetUri:b.URI.parse(T.assetUri),webResource:V(T),assetTypes:T.files.map(({assetType:J})=>J),assets:G,properties:{dependencies:_(T,i.Dependency),extensionPack:_(T,i.ExtensionPack),engine:j(T),localizedLanguages:B(T),webExtension:$(T)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,searchText:N.searchText,querySource:x},preview:M(I.flags)}}let H=class{constructor(T,F,N,x,G,J,Q){this.requestService=T,this.logService=F,this.environmentService=N,this.telemetryService=x,this.fileService=G,this.productService=J;const ne=J.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=z(J.version,this.environmentService,this.fileService,Q)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,F){const N=[];let{total:x,firstPage:G,getPage:J}=await this.query({names:T,pageSize:T.length},F);N.push(...G);for(let Q=1;N.length<x&&(G=await J(Q,F),G.length);Q++)N.push(...G);return N}async getCompatibleExtension(T,F){const N=await this.getCompatibleExtensionByEngine(T,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(T,F){const N=(0,k.isIExtensionIdentifier)(T)?null:T;if(N&&N.properties.engine&&(0,m.isEngineValid)(N.properties.engine,this.productService.version))return N;const{id:x,uuid:G}=N?N.identifier:T;let J=new a().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");G?J=J.withFilter(r.ExtensionId,G):J=J.withFilter(r.ExtensionName,x);const{galleryExtensions:Q}=await this.queryGallery(J,R.CancellationToken.None),[ne]=Q;if(!ne||!ne.versions.length)return null;if(F){const ce=ne.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=q(ne,ce,0,J);if(ue.properties.engine&&(0,m.isEngineValid)(ue.properties.engine,this.productService.version))return ue}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?q(ne,ie,0,J):null}async query(T,F){const N=R.CancellationToken.isCancellationToken(T)?{}:T,x=R.CancellationToken.isCancellationToken(T)?T:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let G=N.text||"";const J=(0,L.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new a().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,J).withFilter(r.Target,"Microsoft.VisualStudio.Code");G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(r.Category,Ie||Ee),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ie)=>(Q=Q.withFilter(r.Tag,Ie||Ee),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(r.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Q=Q.withFilter(r.SearchText,G)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(r.ExtensionId,...N.ids):N.names?Q=Q.withFilter(r.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(Q,x),ce=ne.map((ge,Ee)=>q(ge,ge.versions[0],Ee,Q,N.source)),ue=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw(0,S.canceled)();const Ie=Q.withPage(ge+1),{galleryExtensions:Oe}=await this.queryGallery(Ie,Ee);return Oe.map((Ae,Ue)=>q(Ae,Ae.versions[0],Ue,Ie,N.source))};return{firstPage:ce,total:ie,pageSize:Q.pageSize,getPage:ue}}async queryGallery(T,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,f.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(f.Unpublished));const N=await this.commonHeadersPromise,x=JSON.stringify(T.raw),G=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)}),J=new Date().getTime();let Q,ne,ie=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:G},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await(0,O.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,Ee=ue.resultMetadata&&ue.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ie=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw ne=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(x.length),duration:new Date().getTime()-J,success:!!Q&&(0,O.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ne?(0,S.isPromiseCanceledError)(ne)?"canceled":(0,S.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(T,F,N,x){if(!!this.isEnabled()){const G=await this.commonHeadersPromise,J=Object.assign(Object.assign({},G),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${F}/${N}/stats?statType=${x}`),headers:J},R.CancellationToken.None)}catch(Q){}}}async download(T,F,N){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const x=(0,A.getGalleryExtensionTelemetryData)(T),G=new Date().getTime(),J=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},x),{duration:ce})),Q=N===1?"install":N===2?"update":"",ne=Q?{uri:`${T.assets.download.uri}&${Q}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${Q}=true`}:T.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),J(new Date().getTime()-G)}async getReadme(T,F){if(T.assets.readme){const N=await this.getAsset(T.assets.readme,{},F);return await(0,O.asText)(N)||""}return""}async getManifest(T,F){if(T.assets.manifest){const N=await this.getAsset(T.assets.manifest,{},F),x=await(0,O.asText)(N);return x?JSON.parse(x):null}return null}async getCoreTranslation(T,F){const N=T.assets.coreTranslations.filter(x=>x[0]===F.toUpperCase())[0];if(N){const x=await this.getAsset(N[1]),G=await(0,O.asText)(x);return G?JSON.parse(G):null}return null}async getChangelog(T,F){if(T.assets.changelog){const N=await this.getAsset(T.assets.changelog,{},F);return await(0,O.asText)(N)||""}return""}async getAllVersions(T,F){let N=new a().withFlags(f.IncludeVersions,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?N=N.withFilter(r.ExtensionId,T.identifier.uuid):N=N.withFilter(r.ExtensionName,T.identifier.id);const x=[],{galleryExtensions:G}=await this.queryGallery(N,R.CancellationToken.None);return G.length&&(F?await Promise.all(G[0].versions.map(async J=>{let Q;try{Q=await this.getEngine(J)}catch(ne){}Q&&(0,m.isEngineValid)(Q,this.productService.version)&&x.push({version:J.version,date:J.lastUpdated})})):x.push(...G[0].versions.map(J=>({version:J.version,date:J.lastUpdated})))),x}async getAsset(T,F={},N=R.CancellationToken.None){const x=await this.commonHeadersPromise,G={type:"GET"},J=Object.assign(Object.assign({},x),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),G),{headers:J});const Q=T.uri,ne=T.fallbackUri,ie=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ie,N);if(ce.res.statusCode===200)return ce;const ue=await(0,O.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,S.isPromiseCanceledError)(ce))throw ce;const ue=(0,S.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(T,F){const N=this.getLastValidExtensionVersionFromProperties(T,F);return N||this.getLastValidExtensionVersionRecursively(T,F)}getLastValidExtensionVersionFromProperties(T,F){for(const N of F){const x=j(N);if(!x)return null;if((0,m.isEngineValid)(x,this.productService.version))return N}return null}async getEngine(T){const F=j(T);if(F)return F;const N=P(T,t.Manifest);if(!N)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},G=await this.getAsset(N,{headers:x}),J=await(0,O.asJson)(G);if(J)return J.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,F){if(!F.length)return null;const N=F[0],x=await this.getEngine(N);return(0,m.isEngineValid)(x,this.productService.version)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:x}),N):this.getLastValidExtensionVersionRecursively(T,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,O.asJson)(T),N=new Map;if(F)for(const x of F.malicious){const G=N.get(x)||{id:{id:x},malicious:!0,slow:!1};G.malicious=!0,N.set(x,G)}return[...N.values()]}};H=he([Y(0,O.IRequestService),Y(1,g.ILogService),Y(2,v.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,y.IFileService),Y(5,c.IProductService),Y(6,(0,C.optional)(p.IStorageService))],H),e.ExtensionGalleryService=H;async function z(I,T,F,N){const x={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I}`},G=await(0,w.getServiceMachineId)(T,F,N);return x["X-Market-User-Id"]=G,x}e.resolveMarketplaceHeaders=z}),define(Z[171],ee([0,1,4,8,28,9,36,10,7,18,29,62,40,17,164,6,22,71,108,19,3,57]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let n=class extends c.ExtensionTipsService{constructor(a,l,u,d,E,h,P,_,j,B){super(P,_,j,B);this.environmentService=a,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=E,this.extensionRecommendationNotificationService=h,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,g.forEach)(_.exeBasedExtensionTips,({key:M,value:$})=>{const V=[],q=[],H=[];(0,g.forEach)($.recommendations,({key:z,value:I})=>{I.important?$.important?V.push({extensionId:z,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):q.push({extensionId:z,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):H.push({extensionId:z,extensionName:I.name,isExtensionPack:!!I.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:V}),q.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:q}),H.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,p.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(a,l){const u=new Map;a.forEach(_=>u.set(_.extensionId.toLowerCase(),_));const{installed:d,uninstalled:E}=this.groupByInstalled([...u.keys()],l);for(const _ of d){const j=u.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}for(const _ of E){const j=u.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}const h=this.getPromptedExecutableTips(),P=new Map;for(const _ of E){const j=u.get(_);if(j&&(!h[j.exeName]||!h[j.exeName].includes(j.extensionId))){let B=P.get(j.exeName);B||(B=[],P.set(j.exeName,B)),B.push(j)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[a,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const d=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register((0,p.disposableTimeout)(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const a=this.getLastPromptedMediumExeTime(),l=Date.now()-a,u=7*24*60*60*1e3;if(l<u){const h=this._register((0,p.disposableTimeout)(()=>{h.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(h=>{switch(h){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(E[0].exeName,E);const P=this._register((0,p.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register((0,p.disposableTimeout)(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(a){const l=a.map(({extensionId:d})=>d.toLowerCase()),u=(0,D.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(i,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(i,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,l){const u=this.getPromptedExecutableTips();u[a]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(a,l){const u=[],d=[],E=l.reduce((h,P)=>(h.add(P.identifier.id.toLowerCase()),h),new Set);return a.forEach(h=>{E.has(h.toLowerCase())?u.push(h):d.push(h)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(a){const l=[],u=new Map;for(const d of a.keys()){const E=a.get(d);if(!(!E||!(0,v.isNonEmptyArray)(E.recommendations))){const h=[];m.isWindows?E.windowsPath&&h.push(E.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(h.push((0,k.join)("/usr/local/bin",d)),h.push((0,k.join)("/usr/bin",d)),h.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const P of h){let _=u.get(P);if(_===void 0&&(_=await this.fileService.exists(S.URI.file(P)),u.set(P,_)),_)for(const{extensionId:j,extensionName:B,isExtensionPack:M}of E.recommendations)l.push({extensionId:j,extensionName:B,isExtensionPack:M,exeName:d,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}}return l}};n=he([Y(0,L.INativeEnvironmentService),Y(1,w.ITelemetryService),Y(2,R.IExtensionManagementService),Y(3,f.IStorageService),Y(4,r.INativeHostService),Y(5,C.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,A.IProductService),Y(8,y.IRequestService),Y(9,b.ILogService)],n),e.ExtensionTipsService=n}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(L){this.appender=L}listen(L,U){throw new Error(`Event not found: ${U}`)}call(L,U,{eventName:O,data:m}){return this.appender.log(O,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class k{constructor(L){this.channel=L}log(L,U){return this.channel.call("log",{eventName:L,data:U}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[79],ee([0,1,51,118,21,5,25,39,2,26,35]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(c,p){this._configurationService=p,this._experimentProperties={},this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(w=>{const C=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!C})}))}setExperimentProperty(c,p){this._experimentProperties[c]=p}setEnabled(c){this._enabled=c}_updateUserOptIn(){var c;const p=(c=this._configurationService)===null||c===void 0?void 0:c.getValue(y);this._userOptIn=p?p.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let p=c.sessionID,w=c["common.instanceId"],C=c["common.machineId"],D=c["common.firstSessionDate"],f=c["common.msftInternal"];return{sessionId:p,instanceId:w,machineId:C,firstSessionDate:D,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(c,p,w){return this.isOptedIn?this._commonProperties.then(C=>{p=(0,v.mixin)(p,C),p=(0,v.mixin)(p,this._experimentProperties),p=(0,v.cloneAndChange)(p,D=>{if(typeof D=="string")return this._cleanupInfo(D,w)}),this._appender.log(c,p)},C=>{console.error(C)}):Promise.resolve(void 0)}publicLog2(c,p,w){return this.publicLog(c,p,w)}publicLogError(c,p){return this.sendErrorTelemetry?this.publicLog(c,p,!0):Promise.resolve(void 0)}publicLogError2(c,p){return this.publicLogError(c,p)}_cleanupInfo(c,p){let w=c;if(p){const C=[];for(let r of this._cleanupPatterns)for(;;){const t=r.exec(c);if(!t)break;C.push([t.index,r.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(w="";;){const r=f.exec(c);if(!r)break;!D.test(r[0])&&C.every(([t,i])=>r.index<t||r.index>=i)&&(w+=c.substring(s,r.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<c.length&&(w+=c.substr(s))}for(let C of this._cleanupPatterns)w=w.replace(C,"");return w}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=he([Y(1,(0,L.optional)(U.IConfigurationService))],g),e.TelemetryService=g;const y="telemetry";R.Registry.as(O.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(2,null,S.default.privacyStatementUrl):(0,k.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,25,26,15,6]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,p){return Promise.resolve(void 0)}publicLog2(c,p){return this.publicLog(c,p)}publicLogError(c,p){return Promise.resolve(void 0)}publicLogError2(c,p){return this.publicLogError(c,p)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(p,w,C){}async publicLogError(p,w,C){}}e.NullEndpointTelemetryService=U;function O(...c){return{log:(p,w)=>c.forEach(C=>C.log(p,w)),flush:()=>L.Promises.settled(c.map(p=>p.flush()))}}e.combinedAppender=O,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(c,p){return p.onDidChangeConfiguration(w=>{w.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(w.source),configurationKeys:y(w.sourceConfig)})})}e.configurationTelemetry=m;function v(c){const p=Object.create(null),w=Object.create(null),C=Object.create(null);g(c,C);for(let D in C){D=D.length>150?D.substr(D.length-149):D;const f=C[D];typeof f=="number"?w[D]=f:typeof f=="boolean"?w[D]=f?1:0:typeof f=="string"?p[D]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(p[D]=f)}return{properties:p,measurements:w}}e.validateTelemetryData=v;function R(c){if(!c)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{c.indexOf(`${C}+`)===0&&(p=C)}),p}e.cleanRemoteAuthority=R;function g(c,p,w=0,C){if(!!c)for(let D of Object.getOwnPropertyNames(c)){const f=c[D],s=C?C+D:D;Array.isArray(f)?p[s]=(0,k.safeStringify)(f):f instanceof Date?p[s]=f.toISOString():(0,A.isObject)(f)?w<2?g(f,p,w+1,s+"."):p[s]=(0,k.safeStringify)(f):p[s]=f}}function y(c){if(!c)return[];const p=[];return b(p,"",c),p}function b(c,p,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(C=>b(c,p?`${p}.${C}`:C,w[C])):c.push(p)}}),define(Z[172],ee([0,1,2,9,17,58]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends S.Disposable{constructor(m,v){super();this.logger=this._register(m.createLogger(v.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(m,v){this.logger.trace(`telemetry/${m}`,(0,L.validateTelemetryData)(v))}};U=he([Y(0,A.ILoggerService),Y(1,k.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[173],ee([0,1,11,26,58]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(O){const m=await new Promise((R,g)=>{K(["applicationinsights"],R,g)});let v;return m.defaultClient?(v=new m.TelemetryClient(O),v.channel.setUseDiskRetryCaching(!0)):(m.setup(O).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),v=m.defaultClient),O.indexOf("AIF-")===0&&(v.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),v}class U{constructor(m,v,R){this._eventPrefix=m,this._defaultData=v,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(v=>{m(v)},v=>{(0,S.onUnexpectedError)(v),console.error(v)})}}log(m,v){!this._aiClient||(v=(0,k.mixin)(v,this._defaultData),v=(0,A.validateTelemetryData)(v),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+m,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[174],ee([0,1,49,78,16,79,25,22]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(R,g){this.configurationService=R,this.telemetryService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(R){if(!this.customTelemetryServices.has(R.id)){const{machineId:g,sessionId:y}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=g,b["common.vscodesessionid"]=y;const c=[R.id,JSON.stringify(b),R.aiKey],w=new S.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),C=new k.TelemetryAppenderClient(w);this.customTelemetryServices.set(R.id,new L.TelemetryService({appender:C,sendErrorTelemetry:R.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(R.id)}async publicLog(R,g,y){await(await this.getCustomTelemetryService(R)).publicLog(g,y)}async publicLogError(R,g,y){await(await this.getCustomTelemetryService(R)).publicLogError(g,y)}};m=he([Y(0,U.IConfigurationService),Y(1,O.ITelemetryService)],m),e.CustomEndpointTelemetryService=m}),define(Z[80],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var k;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,S.createDecorator)("localTerminalService"),e.IPtyService=(0,S.createDecorator)("ptyService");var L;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(L=e.HeartbeatConstants||(e.HeartbeatConstants={}));var U;(function(m){m[m.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",m[m.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(U=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var O;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(O=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[175],ee([0,1,5]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(Z[176],ee([0,1,2,17,80,49,16,34,3,75,22]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let y=0,b=class extends S.Disposable{constructor(p,w){super();this._logService=p,this._telemetryService=w,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new m.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new m.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new m.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new m.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new m.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new m.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new m.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new m.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new m.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new m.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new m.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new m.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new m.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,S.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const p=new L.Client(U.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:y,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),O.ProxyChannel.toService(p.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(p.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const C=p.getChannel(A.TerminalIpcChannels.Log);this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(C,this._logService.getLevel())}));const D=O.ProxyChannel.toService(p.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(D.onProcessData(f=>this._onProcessData.fire(f))),this._register(D.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(D.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(D.onProcessTitleChanged(f=>this._onProcessTitleChanged.fire(f))),this._register(D.onProcessShellTypeChanged(f=>this._onProcessShellTypeChanged.fire(f))),this._register(D.onProcessOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f))),this._register(D.onProcessResolvedShellLaunchConfig(f=>this._onProcessResolvedShellLaunchConfig.fire(f))),this._register(D.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(D.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),[p,D]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(p,w,C,D,f,s,r,t,i,n){const o=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),a=await this._proxy.createProcess(p,w,C,D,f,s,r,t,i,n);return clearTimeout(o),y=Math.max(y,a),a}attachToProcess(p){return this._proxy.attachToProcess(p)}detachFromProcess(p){return this._proxy.detachFromProcess(p)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(p){return this._proxy.start(p)}shutdown(p,w){return this._proxy.shutdown(p,w)}input(p,w){return this._proxy.input(p,w)}processBinary(p,w){return this._proxy.processBinary(p,w)}resize(p,w,C){return this._proxy.resize(p,w,C)}acknowledgeDataEvent(p,w){return this._proxy.acknowledgeDataEvent(p,w)}getInitialCwd(p){return this._proxy.getInitialCwd(p)}getCwd(p){return this._proxy.getCwd(p)}getLatency(p){return this._proxy.getLatency(p)}orphanQuestionReply(p){return this._proxy.orphanQuestionReply(p)}getDefaultSystemShell(p){return this._proxy.getDefaultSystemShell(p)}getShellEnvironment(){return this._proxy.getShellEnvironment()}setTerminalLayoutInfo(p){return this._proxy.setTerminalLayoutInfo(p)}async getTerminalLayoutInfo(p){return await this._proxy.getTerminalLayoutInfo(p)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};b=he([Y(0,k.ILogService),Y(1,R.ITelemetryService)],b),e.PtyHostService=b}),define(Z[52],ee([0,1,41]),function(K,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(U,O,m,v){const R=(0,S.setProperty)(U,O,m,v)[0];return R&&(U=U.substring(0,R.offset)+R.content+U.substring(R.offset+R.length)),U}e.edit=k;function A(U,O,m){let v=m;for(;v>=0;){if(U.charAt(v)===O.charAt(O.length-1)&&O.length===1)return v+1;if(v--,O.length===2&&v>=0&&U.charAt(v)===O.charAt(0))return v+2}return 0}e.getLineStartOffset=A;function L(U,O,m){let v=m;for(;v>=0;)if(U.charAt(v)===O.charAt(O.length-1)&&O.length===1||(v++,O.length===2&&v>=0&&U.charAt(v)===O.charAt(1)))return v;return U.length-1}e.getLineEndOffset=L}),define(Z[177],ee([0,1,26,56]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(g,y,b,c,p){var w,C;const D=[],f=[],s=[];if(!y){const j=g.filter(({identifier:B})=>p.every(M=>M.toLowerCase()!==B.id.toLowerCase()));return{added:D,removed:f,updated:s,remote:j.length>0?j:null}}g=g.map(v),y=y.map(v),b=b?b.map(v):null;const r=new Map,t=j=>{j.uuid&&r.set(j.id.toLowerCase(),j.uuid)};g.forEach(({identifier:j})=>t(j)),y.forEach(({identifier:j})=>t(j)),b&&b.forEach(({identifier:j})=>t(j));const i=j=>{const B=j.identifier.uuid||r.get(j.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${j.identifier.id.toLowerCase()}`},n=(j,B)=>(j.set(i(B),B),j),o=g.reduce(n,new Map),a=y.reduce(n,new Map),l=y.reduce((j,B)=>{const M=i(B);B=(0,S.deepClone)(B);const $=o.get(M);return $&&($.installed&&(B.installed=!0),B.version||(B.version=$.version)),n(j,B)},new Map),u=b?b.reduce(n,new Map):null,d=c.reduce(n,new Map),E=p.reduce((j,B)=>{const M=r.get(B.toLowerCase());return j.add(M?`uuid:${M}`:`id:${B.toLowerCase()}`)},new Set),h=L(o,a,E);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const j=L(u,o,E),B=L(u,a,E),M=($,V)=>{const q=o.get($);if(q){const H=a.get($);return Object.assign(Object.assign({},V?H:q),{version:(H.version&&k.gt(H.version,q.version),q.version),state:U(q,H,u==null?void 0:u.get($))})}};for(const $ of B.removed.values()){const V=o.get($);V&&f.push(V.identifier)}for(const $ of B.added.values())if(j.added.has($)){if(h.updated.has($)){const V=M($,!0);V&&(s.push(R(V,$)),l.set($,V))}}else{const V=a.get($);V.installed&&D.push(R(V,$))}for(const $ of B.updated.values()){const V=M($,!0);V&&(s.push(R(V,$)),l.set($,V))}for(const $ of j.added.values())B.added.has($)||l.set($,o.get($));for(const $ of j.updated.values())if(!B.removed.has($)&&!B.updated.has($)){const V=M($,!1);V&&(((w=l.get($))===null||w===void 0?void 0:w.installed)&&(V.installed=!0),l.set($,V))}for(const $ of j.removed.values())!d.has($)&&!B.updated.has($)&&((C=u==null?void 0:u.get($))===null||C===void 0?void 0:C.installed)&&l.delete($)}const P=[],_=L(a,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((j,B)=>P.push(R(j,B))),{added:D,removed:f,updated:s,remote:P.length?P:null}}e.merge=A;function L(g,y,b,{checkInstalledProperty:c,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const w=g?[...g.keys()].filter(r=>!b.has(r)):[],C=[...y.keys()].filter(r=>!b.has(r)),D=C.filter(r=>w.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),f=w.filter(r=>C.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of w)if(!f.has(r)){const t=g.get(r),i=y.get(r);(!i||t.disabled!==i.disabled||!m(t.state,i.state)||p&&t.version!==i.version||c&&t.installed!==i.installed)&&s.add(r)}return{added:D,removed:f,updated:s}}function U(g,y,b){const c=g.state,p=y.state,w=b==null?void 0:b.state;if(!y.version||c&&k.gt(g.version,y.version))return c;if(p&&k.gt(y.version,g.version)||!c)return p;if(!p)return c;const C=(0,S.deepClone)(c),D=w?O(w,p):{added:Object.keys(p).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set},f=w?O(w,c):{added:Object.keys(c).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set};for(const s of[...D.added.values(),...D.updated.values()])C[s]=p[s];for(const s of D.removed.values())f.updated.has(s)||delete C[s];return C}function O(g,y){const b=Object.keys(g),c=Object.keys(y),p=c.filter(D=>b.indexOf(D)===-1).reduce((D,f)=>(D.add(f),D),new Set),w=b.filter(D=>c.indexOf(D)===-1).reduce((D,f)=>(D.add(f),D),new Set),C=new Set;for(const D of b)if(!w.has(D)){const f=g[D],s=y[D];(0,S.equals)(f,s)||C.add(D)}return{added:p,removed:w,updated:C}}function m(g={},y={}){const{added:b,removed:c,updated:p}=O(g,y);return b.size===0&&c.size===0&&p.size===0}function v(g){return Object.assign(Object.assign({},g),{disabled:!!g.disabled,installed:!!g.installed})}function R(g,y){const b={identifier:{id:g.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0}};return g.version&&(b.version=g.version),g.disabled&&(b.disabled=!0),g.installed&&(b.installed=!0),g.state&&(b.state=g.state),b}}),define(Z[81],ee([0,1,18,3,2,33,5,28,19]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let R=class Qe extends A.Disposable{constructor(y,b){super();this.storageService=y,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(c=>this.onDidChangeStorageValue(c)))}static toKey(y){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const b=v.exec(y);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const y=this.storageService.keys(0,1);for(const b of y){const c=Qe.fromKey(b);c&&this.extensionsWithKeysForSync.add(c.id.toLowerCase())}}onDidChangeStorageValue(y){if(y.scope===0){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Qe.fromKey(y.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(y,b){this.storageService.store(Qe.toKey(y),JSON.stringify(b),0,1)}getKeysForSync(y){var b;const c=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[y.id.toLowerCase()],p=this.storageService.get(Qe.toKey(y),0),w=p?JSON.parse(p):void 0;return w&&c?(0,S.distinct)([...w,...c]):w||c}};R=he([Y(0,m.IStorageService),Y(1,O.IProductService)],R),e.ExtensionsStorageSyncService=R}),define(Z[82],ee([0,1,18,25,5]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(O){this.configurationService=O}hasToNeverSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,m){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==O&&R!==`-${O}`),m&&v.push(O.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}updateSynchronizedExtensions(O,m){let v=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==O&&R!==`-${O}`),m&&v.push(`-${O.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,1)}getIgnoredExtensions(O){const m=O.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),v=this.getConfiguredIgnoredExtensions().map(y=>y.toLowerCase()),R=[],g=[];if(Array.isArray(v))for(const y of v)y.startsWith("-")?g.push(y.substring(1)):R.push(y);return(0,S.distinct)([...m,...R].filter(y=>g.indexOf(y)===-1))}getConfiguredIgnoredExtensions(){let O=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.configurationService.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};L=he([Y(0,k.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(Z[178],ee([0,1,26,32,18,139,52]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function O(s){return(0,k.parse)(s)||[]}e.parseKeybindings=O;async function m(s,r,t,i,n){const o=O(s),a=O(r),l=t?O(t):null,u=[...o,...a,...l||[]].map(q=>q.key),d=await n.resolveUserBindings(u);let E=R(o,a,l,d);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:r,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const h=y(o),P=y(a),_=l?y(l):null,j=c(h,P,d),B=_?c(_,h,d):{added:[...h.keys()].reduce((q,H)=>(q.add(H),q),new Set),removed:new Set,updated:new Set},M=_?c(_,P,d):{added:[...P.keys()].reduce((q,H)=>(q.add(H),q),new Set),removed:new Set,updated:new Set},$=v(j,B,M);let V=s;for(const q of $.removed.values())$.conflicts.has(q)||(V=D(V,q,i));for(const q of $.added.values())if(!$.conflicts.has(q)){const H=P.get(q);if(H.some(z=>z.command!==`-${q}`&&E.conflicts.has(d[z.key]))){$.conflicts.add(q);continue}V=C(V,H,i)}for(const q of $.updated.values())if(!$.conflicts.has(q)){const H=P.get(q);if(H.some(z=>z.command!==`-${q}`&&E.conflicts.has(d[z.key]))){$.conflicts.add(q);continue}V=f(V,q,H,i)}return{mergeContent:V,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=m;function v(s,r,t){const i=new Set,n=new Set,o=new Set,a=new Set;for(const l of r.removed.values())t.updated.has(l)&&a.add(l);for(const l of t.removed.values())a.has(l)||(r.updated.has(l)?a.add(l):n.add(l));for(const l of r.added.values())a.has(l)||t.added.has(l)&&s.updated.has(l)&&a.add(l);for(const l of t.added.values())a.has(l)||(r.added.has(l)?s.updated.has(l)&&a.add(l):i.add(l));for(const l of r.updated.values())a.has(l)||t.updated.has(l)&&s.updated.has(l)&&a.add(l);for(const l of t.updated.values())a.has(l)||(r.updated.has(l)?s.updated.has(l)&&a.add(l):o.add(l));return{added:i,removed:n,updated:o,conflicts:a}}function R(s,r,t,i){const n=new Set,o=g(s,i),a=g(r,i),l=t?g(t,i):null,u=b(o,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?b(l,o):{added:[...o.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const E=l?b(l,a):{added:[...a.keys()].reduce((B,M)=>(B.add(M),B),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:P,updated:_,conflicts:j}=v(u,d,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:P,updated:_,conflicts:j}}function g(s,r){const t=new Map;for(const i of s){const n=r[i.key];let o=t.get(n);o||(o=[],t.set(n,o)),o.push(i)}return t}function y(s){const r=new Map;for(const t of s){const i=t.command[0]==="-"?t.command.substring(1):t.command;let n=r.get(i);n||(n=[],r.set(i,n)),n.push(t)}return r}function b(s,r){const t=[...s.keys()],i=[...r.keys()],n=i.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),o=t.filter(l=>i.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),a=new Set;for(const l of t)if(!o.has(l)){const u=s.get(l).map(E=>Object.assign(Object.assign({},E),{key:l})),d=r.get(l).map(E=>Object.assign(Object.assign({},E),{key:l}));(0,A.equals)(u,d,(E,h)=>w(E,h))||a.add(l)}return{added:n,removed:o,updated:a}}function c(s,r,t){const i=[...s.keys()],n=[...r.keys()],o=n.filter(u=>i.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),a=i.filter(u=>n.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of i)if(!a.has(u)){const d=s.get(u).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]})),E=r.get(u).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]}));p(d,E)||l.add(u)}return{added:o,removed:a,updated:l}}function p(s,r){return!(!(0,A.equals)(s.filter(({command:t})=>t[0]!=="-"),r.filter(({command:t})=>t[0]!=="-"),(t,i)=>w(t,i))||!(0,A.equals)(s.filter(({command:t})=>t[0]==="-"),r.filter(({command:t})=>t[0]==="-"),(t,i)=>w(t,i)))}function w(s,r){if(s.command!==r.command||s.key!==r.key)return!1;const t=L.ContextKeyExpr.deserialize(s.when),i=L.ContextKeyExpr.deserialize(r.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!S.equals(s.args,r.args))}function C(s,r,t){for(const i of r)s=U.edit(s,[-1],i,t);return s}function D(s,r,t){const i=O(s);for(let n=i.length-1;n>=0;n--)(i[n].command===r||i[n].command===`-${r}`)&&(s=U.edit(s,[n],void 0,t));return s}function f(s,r,t,i){const n=O(s),o=n.findIndex(a=>a.command===r||a.command===`-${r}`);for(let a=n.length-1;a>=0;a--)(n[a].command===r||n[a].command===`-${r}`)&&(s=U.edit(s,[a],void 0,i));for(let a=t.length-1;a>=0;a--)s=U.edit(s,[o],t[a],i);return s}}),define(Z[179],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(L,U,O){const m={},v={},R=new Set;if(!U)return{local:{added:m,updated:v,removed:[...R.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const g=k(L,U);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{local:{added:m,updated:v,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=k(O,L),b=k(O,U),c={},p={},w=new Set,C=new Set;for(const D of y.removed.values())b.updated.has(D)?m[D]=U[D]:w.add(D);for(const D of b.removed.values())C.has(D)||(y.updated.has(D)?C.add(D):R.add(D));for(const D of y.updated.values())C.has(D)||(b.updated.has(D)?g.updated.has(D)&&C.add(D):p[D]=L[D]);for(const D of b.updated.values())C.has(D)||(y.updated.has(D)?g.updated.has(D)&&C.add(D):L[D]!==void 0&&(v[D]=U[D]));for(const D of y.added.values())C.has(D)||(b.added.has(D)?g.updated.has(D)&&C.add(D):c[D]=L[D]);for(const D of b.added.values())C.has(D)||(y.added.has(D)?g.updated.has(D)&&C.add(D):m[D]=U[D]);return{local:{added:m,removed:[...R.values()],updated:v},remote:{added:c,removed:[...w.values()],updated:p},conflicts:[...C.values()]}}e.merge=S;function k(L,U){const O=L?Object.keys(L):[],m=U?Object.keys(U):[],v=m.filter(y=>O.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),R=O.filter(y=>m.indexOf(y)===-1).reduce((y,b)=>(y.add(b),y),new Set),g=new Set;for(const y of O)if(!R.has(y)){const b=L[y],c=U[y];b!==c&&g.add(y)}return{added:v,removed:R,updated:g}}function A(L,U){const{added:O,removed:m,updated:v}=k(L,U);return O.size===0&&m.size===0&&v.size===0}e.areSame=A}),define(Z[20],ee([0,1,5,29,35,39,123,77,12,18,15]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function g(){const a=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(l=>!!a[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=g;function y(){const a=A.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(a).filter(E=>!!a[E].ignoreSync),u=Object.keys(a).filter(E=>a[E].scope===2||a[E].scope===6),d=g();return(0,v.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...u,...d])}e.getDefaultIgnoredSettings=y;function b(){const a="vscode://schemas/ignoredSettings",l=A.Registry.as(L.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=A.Registry.as(O.Extensions.JSONContribution),d=()=>{const E=g(),h=y().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(L.allSettings.properties).filter(B=>h.indexOf(B)===-1),_=h.filter(B=>E.indexOf(B)===-1),j={items:{type:"string",enum:[...P,..._.map(B=>`-${B}`)]}};u.registerSchema(a,j)};return l.onDidUpdateConfiguration(()=>d())}e.registerConfiguration=b;function c(a){return a&&(0,R.isObject)(a)&&(0,R.isString)(a.id)&&(0,R.isArray)(a.scopes)}e.isAuthenticationProvider=c;var p;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function w(a){const l={};return l[e.HEADER_EXECUTION_ID]=a,l}e.createSyncHeaders=w;var C;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.NoRef="NoRef",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class D extends Error{constructor(l,u,d,E){super(l);this.code=u,this.resource=d,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=D;class f extends D{constructor(l,u,d,E){super(l,d,void 0,E);this.url=u}}e.UserDataSyncStoreError=f;class s extends D{constructor(l,u){super(l,u)}}e.UserDataAutoSyncError=s,function(a){function l(u){if(u instanceof a)return u;const d=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(d&&d[1]){const E=d[2]==="unknown"?void 0:d[2],h=d[3]==="unknown"?void 0:d[3];return new a(u.message,d[1],E,h)}return new a(u.message,C.Unknown)}a.toUserDataSyncError=l}(D=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(a){return`sync.enable.${a}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(a,l){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,m.isEqualOrParent)(a,(0,m.joinPath)(l.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(Z[45],ee([0,1,2,10,23,4,20,9,12,6,3,22,32,119,25,15,21,18,44,19,30]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=r;function t(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}let i=class extends S.Disposable{constructor(u,d,E,h,P,_,j,B,M,$){super();this.resource=u,this.fileService=d,this.environmentService=E,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=j,this.telemetryService=B,this.logService=M,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new v.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new R.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,w.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(E.userDataSyncHome,1024)?m.extUri:m.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(E.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(u,E,this.extUri),this.currentMachineIdPromise=(0,D.getServiceMachineId)(E,d,h)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:E})=>E!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const d=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,d={}){await this._sync(u,!0,d)}async preview(u,d={}){return this._sync(u,!1,d)}async apply(u,d={}){try{this.syncHeaders=Object.assign({},d);const E=await this.doApply(u);return this.setStatus(E),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,d,E){try{if(this.syncHeaders=Object.assign({},E),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let h="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(u,P);return h=await this.performSync(_,P,d),h==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):h==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(h)}}finally{this.syncHeaders={}}}async replace(u){const d=await this.resolveContent(u);if(!d)return!1;const E=this.parseSyncData(d);if(!E)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const h=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,h),_=await this.generateSyncPreview({ref:P.ref,syncData:E},h,s.CancellationToken.None),j=[];for(const B of _){const M=await this.getAcceptResult(B,B.remoteResource,void 0,s.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,s.CancellationToken.None);j.push([B,Object.assign(Object.assign({},M),{remoteChange:$!==0?$:2})])}await this.applyResult(P,h,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(u,d){if(d){const E=u&&u.latest?u.latest[this.resource]:void 0;if(d.ref===E||E===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(u,d,E){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,u.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(u,d,E)}catch(h){if(h instanceof U.UserDataSyncError)switch(h.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,d,E);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(u,d,E)}throw h}}async doSync(u,d,E){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,v.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(u,d,E,P)));const h=await this.syncPreviewPromise;return this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":E?await this.doApply(!1):"syncing"}catch(h){throw this.syncPreviewPromise=null,h}}async merge(u){return await this.updateSyncResourcePreview(u,async d=>{const E=await this.getMergeResult(d,s.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString((E==null?void 0:E.content)||""));const h=E&&!E.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,s.CancellationToken.None):void 0;return d.acceptResult=h,d.mergeState=E.hasConflicts?"conflict":h?"accepted":"preview",d.localChange=h?h.localChange:E.localChange,d.remoteChange=h?h.remoteChange:E.remoteChange,d}),this.syncPreviewPromise}async accept(u,d){return await this.updateSyncResourcePreview(u,async E=>{const h=await this.getAcceptResult(E,u,d,s.CancellationToken.None);return E.acceptResult=h,E.mergeState="accepted",E.localChange=h.localChange,E.remoteChange=h.remoteChange,E}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async d=>{const E=await this.getMergeResult(d,s.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(E.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=E.localChange,d.remoteChange=E.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(u,d){if(!!this.syncPreviewPromise){let E=await this.syncPreviewPromise;const h=E.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:j})=>this.extUri.isEqual(P,u)||this.extUri.isEqual(_,u)||this.extUri.isEqual(j,u));h!==-1&&(this.syncPreviewPromise=(0,v.createCancelablePromise)(async P=>{const _=[...E.resourcePreviews];return _[h]=await d(_[h]),Object.assign(Object.assign({},E),{resourcePreviews:_})}),E=await this.syncPreviewPromise,this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(u){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(E=>[E,E.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const d=u.filter(({mergeState:E})=>E==="conflict");(0,C.equals)(this._conflicts,d,(E,h)=>this.extUri.isEqual(E.previewResource,h.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:E})=>({created:d,uri:this.toRemoteBackupResource(E)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:E})=>({created:d,uri:this.toLocalBackupResource(E)}))}toRemoteBackupResource(u){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return L.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const d=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(d))){const{content:E}=await this.getUserData(d);if(E){const h=this.parseSyncData(E);return h==null?void 0:h.machineId}}}async resolveContent(u){const d=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(d))){const{content:E}=await this.getUserData(d);return E}return this.extUri.isEqual(u,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(u){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const E of d.resourcePreviews){if(this.extUri.isEqual(E.acceptedResource,u))return E.acceptResult?E.acceptResult.content:null;if(this.extUri.isEqual(E.remoteResource,u))return E.remoteContent;if(this.extUri.isEqual(E.localResource,u))return E.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,d,E,h){var P;const _=await this.currentMachineIdPromise,j=!!((P=u.syncData)===null||P===void 0?void 0:P.machineId)&&u.syncData.machineId===_,B=d===null&&j&&!this.hasSyncResourceStateVersionChanged?u:d,M=await this.generateSyncPreview(u,B,h),$=[];for(const V of M){const q=V.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(V.localChange===0&&V.remoteChange===0)$.push(Object.assign(Object.assign({},V),{acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const H=E?await this.getMergeResult(V,h):void 0;if(h.isCancellationRequested)break;await this.fileService.writeFile(V.previewResource,A.VSBuffer.fromString((H==null?void 0:H.content)||""));const z=H&&!H.hasConflicts?await this.getAcceptResult(V,V.previewResource,void 0,h):void 0;$.push(Object.assign(Object.assign({},V),{acceptResult:z,mergeState:(H==null?void 0:H.hasConflicts)?"conflict":z?"accepted":"preview",localChange:z?z.localChange:H?H.localChange:V.localChange,remoteChange:z?z.remoteChange:H?H.remoteChange:V.remoteChange}))}}return{remoteUserData:u,lastSyncUserData:d,resourcePreviews:$,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(u.value.toString()),E=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&E&&d.version!==E,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;const h=d;if(h.content===null)return{ref:d.ref,syncData:null};const P=JSON.parse(h.content);if(r(P))return Object.assign(Object.assign({},d),{syncData:P,content:void 0})}catch(u){u instanceof k.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const E=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),h=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:E},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(h)))}async getRemoteUserData(u){const{ref:d,content:E}=await this.getUserData(u);let h=null;return E!==null&&(h=this.parseSyncData(E)),{ref:d,syncData:h}}parseSyncData(u){try{const d=JSON.parse(u);if(r(d))return d}catch(d){this.logService.error(d)}throw new U.UserDataSyncError((0,b.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(u){if((0,p.isString)(u)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:d}}else{const d=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(u,d){const E=await this.currentMachineIdPromise,h={version:this.version,machineId:E,content:u};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(h),d,this.syncHeaders),{ref:d,syncData:h}}async backupLocal(u){const d={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=he([Y(1,k.IFileService),Y(2,O.IEnvironmentService),Y(3,f.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,g.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,c.IConfigurationService)],i),e.AbstractSynchroniser=i;let n=class extends i{constructor(u,d,E,h,P,_,j,B,M,$,V){super(d,E,h,P,_,j,B,M,$,V);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,d,E){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(u),E?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(u),{overwrite:E})}catch(h){throw h instanceof k.FileOperationError&&h.fileOperationResult===1||h instanceof k.FileOperationError&&h.fileOperationResult===3?new U.UserDataSyncError(h.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):h}}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=he([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,f.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,g.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,c.IConfigurationService)],n),e.AbstractFileSynchroniser=n;let o=class extends n{constructor(u,d,E,h,P,_,j,B,M,$,V,q){super(u,d,E,h,P,_,j,B,M,$,q);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(u){const d=[];return(0,y.parse)(u,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=he([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,f.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,g.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,c.IConfigurationService)],o),e.AbstractJsonFileSynchroniser=o;let a=class{constructor(u,d,E,h){this.resource=u,this.environmentService=d,this.logService=E,this.fileService=h,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?m.extUri:m.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,d,m.extUri)}async initialize({ref:u,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const E=this.parseSyncData(d);if(!!E){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:u,syncData:E})}catch(P){this.logService.error(P)}}}parseSyncData(u){try{const d=JSON.parse(u);if(r(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,d={}){const E=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(E)))}};a=he([Y(1,O.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,k.IFileService)],a),e.AbstractInitializer=a}),define(Z[180],ee([0,1,20,3,9,29,33,10,25,177,45,22,4,46,41,21,19,82,11,81,6]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function r(a,l){const u=JSON.parse(a.content);if(a.version===1||a.version===2){const d=(await l.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of u)a.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),a.version===2&&d.every(h=>!(0,U.areSameExtensions)(h.identifier,E.identifier))&&(E.installed=!0)}return u}function t(a,l,u){const d=u.get((0,U.getExtensionId)(a,l),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function i(a,l,u,d){d.store((0,U.getExtensionId)(a,l),JSON.stringify(u),0,1)}e.storeExtensionStorageState=i;let n=class st extends R.AbstractSynchroniser{constructor(l,u,d,E,h,P,_,j,B,M,$,V,q,H){super("extensions",u,l,d,E,h,V,q,B,$);this.storageService=d,this.extensionManagementService=P,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=M,this.extensionsStorageSyncService=H,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,z=>!!z.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,z=>!z.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,u){const d=l.syncData?await r(l.syncData,this.extensionManagementService):null,E=(u==null?void 0:u.skippedExtensions)||[],h=(u==null?void 0:u.syncData)?await r(u.syncData,this.extensionManagementService):null,P=await this.extensionManagementService.getInstalled(),_=this.getLocalExtensions(P),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(P);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:B,removed:M,updated:$,remote:V}=(0,v.merge)(_,d,h,E,j),q={added:B,removed:M,updated:$,remote:V,content:this.getPreviewContent(_,B,$,M),localChange:B.length>0||M.length>0||$.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,u,d,E){const h=[...u,...d],P=new Set,_=j=>{P.add(j.id.toLowerCase()),j.uuid&&P.add(j.uuid)};h.forEach(({identifier:j})=>_(j)),E.forEach(_);for(const j of l)P.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&P.has(j.identifier.uuid)||h.push(j);return this.format(h)}async getMergeResult(l,u){return Object.assign(Object.assign({},l.previewResult),{hasConflicts:!1})}async getAcceptResult(l,u,d,E){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(l){const u=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),E=(0,v.merge)(l.localExtensions,null,null,l.skippedExtensions,d),{added:h,removed:P,updated:_,remote:j}=E;return{content:l.localContent,added:h,removed:P,updated:_,remote:j,localChange:h.length>0||P.length>0||_.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(l){const u=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),E=l.remoteContent?JSON.parse(l.remoteContent):null;if(E!==null){const h=(0,v.merge)(l.localExtensions,E,l.localExtensions,[],d),{added:P,removed:_,updated:j,remote:B}=h;return{content:l.remoteContent,added:P,removed:_,updated:j,remote:B,localChange:P.length>0||_.length>0||j.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:l.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(l,u,d,E){let{skippedExtensions:h,localExtensions:P}=d[0][0],{added:_,removed:j,updated:B,remote:M,localChange:$,remoteChange:V}=d[0][1];if($===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(P)),h=await this.updateLocalExtensions(_,j,B,h)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(M);l=await this.updateRemoteUserData(q,E?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(u==null?void 0:u.ref)!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:h}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:st.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,st.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),h=this.getLocalExtensions(d).filter(P=>!E.some(_=>(0,U.areSameExtensions)({id:_},P.identifier)));return this.format(h)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let u=await super.resolveContent(l);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(l)),u){const d=this.parseSyncData(u);if(d)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(l){l.sort((E,h)=>!E.identifier.uuid&&h.identifier.uuid?-1:E.identifier.uuid&&!h.identifier.uuid?1:(0,p.compare)(E.identifier.id,h.identifier.id));const u=JSON.stringify(l),d=(0,b.format)(u,void 0,{});return(0,c.applyEdits)(u,d)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(d=>d.installed||d.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,u,d,E){const h=[],P=[],_=await this.extensionManagementService.getInstalled();if(u.length){const B=_.filter(({identifier:M,isBuiltin:$})=>!$&&u.some(V=>(0,U.areSameExtensions)(M,V)));await s.Promises.settled(B.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),h.push(M.identifier)}))}(l.length||d.length)&&await s.Promises.settled([...l,...d].map(async B=>{const M=_.find(V=>(0,U.areSameExtensions)(V.identifier,B.identifier));if(M&&M.isBuiltin){B.state&&M.manifest.version===B.version&&this.updateExtensionState(B.state,M.manifest.publisher,M.manifest.name,M.manifest.version),B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id)),h.push(B.identifier);return}const $=await this.extensionGalleryService.getCompatibleExtension(B.identifier);if(B.state&&(M?M.manifest.version===B.version:!!$)){const V=M?M.manifest.publisher:$.publisher,q=M?M.manifest.name:$.name;this.updateExtensionState(B.state,V,q,M==null?void 0:M.manifest.version)}if($)try{B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id,$.version),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id,$.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id,$.version),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id,$.version)),M||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,B.identifier.id,$.version),await this.extensionManagementService.installFromGallery($,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,B.identifier.id,$.version),h.push($.identifier))}catch(V){P.push(B),this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else P.push(B)}));const j=[];for(const B of E)h.some(M=>(0,U.areSameExtensions)(M,B.identifier))||j.push(B);for(const B of P)j.some(M=>(0,U.areSameExtensions)(M.identifier,B.identifier))||j.push(B);return j}updateExtensionState(l,u,d,E){const h=t(u,d,this.storageService),P=E?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(u,d),version:E}):void 0;P?P.forEach(_=>{h[_]=l[_]}):Object.keys(l).forEach(_=>h[_]=l[_]),i(u,d,h,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const u=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:d,isBuiltin:E,manifest:h})=>{const P={identifier:d,version:h.version};u.some(_=>(0,U.areSameExtensions)(_,d))&&(P.disabled=!0),E||(P.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:h.version});if(_){const j=t(h.publisher,h.name,this.storageService);P.state=Object.keys(j).reduce((B,M)=>(_.includes(M)&&(B[M]=j[M]),B),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(_))}return P})}};n.EXTENSIONS_DATA_URI=y.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=he([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,w.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,L.IExtensionManagementService),Y(6,L.IGlobalExtensionEnablementService),Y(7,C.IIgnoredExtensionsManagementService),Y(8,S.IUserDataSyncLogService),Y(9,L.IExtensionGalleryService),Y(10,m.IConfigurationService),Y(11,S.IUserDataSyncResourceEnablementService),Y(12,g.ITelemetryService),Y(13,f.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let o=class extends R.AbstractInitializer{constructor(l,u,d,E,h){super("extensions",E,h,d);this.extensionManagementService=l,this.ignoredExtensionsManagementService=u}async parseExtensions(l){return l.syncData?await r(l.syncData,this.extensionManagementService):null}generatePreview(l,u){const d=[],E=[],h=[];for(const P of l)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(P.identifier.id)){const _=u.find(j=>(0,U.areSameExtensions)(j.identifier,P.identifier));_?(d.push(_),P.disabled&&h.push(P.identifier)):P.installed&&(E.push(P.identifier),P.disabled&&h.push(P.identifier))}return{installedExtensions:d,newExtensions:E,disabledExtensions:h,remoteExtensions:l}}};o=he([Y(0,L.IExtensionManagementService),Y(1,C.IIgnoredExtensionsManagementService),Y(2,O.IFileService),Y(3,A.IEnvironmentService),Y(4,S.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(Z[181],ee([0,1,26,20]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(O,m,v,R,g){if(!m)return{remote:Object.keys(O).length>0?O:null,local:{added:{},removed:[],updated:{}}};const y=L(O,m);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=v?L(v,m):{added:Object.keys(m).reduce((D,f)=>(D.add(f),D),new Set),removed:new Set,updated:new Set},c=v?L(v,O):{added:Object.keys(O).reduce((D,f)=>(D.add(f),D),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},w=S.deepClone(m),C=!v;for(const D of c.added.values())D!==k.SYNC_SERVICE_URL_TYPE&&C&&b.added.has(D)||(w[D]=O[D]);for(const D of c.updated.values())w[D]=O[D];for(const D of c.removed.values())R.unregistered.includes(D)||delete w[D];for(const D of b.added.values()){const f=m[D];if(R.machine.includes(D)){g.info(`GlobalState: Skipped adding ${D} in local storage because it is declared as machine scoped.`);continue}if(!(v&&c.added.has(D))){const s=O[D];s&&s.value===f.value||D===k.SYNC_SERVICE_URL_TYPE&&C&&c.added.has(D)||(s?p.updated[D]=f:p.added[D]=f)}}for(const D of b.updated.values()){const f=m[D];if(R.machine.includes(D)){g.info(`GlobalState: Skipped updating ${D} in local storage because it is declared as machine scoped.`);continue}if(!(c.updated.has(D)||c.removed.has(D))){const s=O[D];s&&s.value===f.value||(p.updated[D]=f)}}for(const D of b.removed.values()){if(R.machine.includes(D)){g.trace(`GlobalState: Skipped removing ${D} in local storage because it is declared as machine scoped.`);continue}c.updated.has(D)||c.removed.has(D)||p.removed.push(D)}return{local:p,remote:U(w,m)?null:w}}e.merge=A;function L(O,m){const v=Object.keys(O),R=Object.keys(m),g=R.filter(c=>v.indexOf(c)===-1).reduce((c,p)=>(c.add(p),c),new Set),y=v.filter(c=>R.indexOf(c)===-1).reduce((c,p)=>(c.add(p),c),new Set),b=new Set;for(const c of v)if(!y.has(c)){const p=O[c],w=m[c];S.equals(p,w)||b.add(c)}return{added:g,removed:y,updated:b}}function U(O,m){const{added:v,removed:R,updated:g}=L(O,m);return v.size===0&&R.size===0&&g.size===0}}),define(Z[182],ee([0,1,20,23,3,9,10,52,181,32,45,22,25,4,46,41,19,7,44,31,17]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(u){const d=u.storage?Object.keys(u.storage).sort():[],E={};d.forEach(_=>E[_]=u.storage[_]),u.storage=E;const h=JSON.stringify(u),P=(0,c.format)(h,void 0,{});return(0,p.applyEdits)(h,P)}const n=1;let o=class ot extends R.AbstractSynchroniser{constructor(d,E,h,P,_,j,B,M,$){super("globalState",d,_,$,E,h,j,B,P,M);this.storageService=$,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(d.onDidFilesChange,V=>V.contains(this.environmentService.argvResource)),A.Event.filter($.onDidChangeValue,V=>V.scope===0&&V.target!==void 0?V.target===0:$.keys(0,0).includes(V.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,E,h){const P=d.syncData?JSON.parse(d.syncData.content):null,_=E&&E.syncData?JSON.parse(E.syncData.content):null,j=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(_),{local:M,remote:$}=(0,m.merge)(j.storage,P?P.storage:null,_?_.storage:null,B,this.logService),V={content:null,local:M,remote:$,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:i(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:P?i(P):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(d,E){return Object.assign(Object.assign({},d.previewResult),{hasConflicts:!1})}async getAcceptResult(d,E,h,P){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(E,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const E=JSON.parse(d.remoteContent),{local:h,remote:P}=(0,m.merge)(d.localUserData.storage,E.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:h,remote:P,localChange:Object.keys(h.added).length>0||Object.keys(h.updated).length>0||h.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,E,h,P){let{localUserData:_}=h[0][0],{local:j,remote:B,localChange:M,remoteChange:$}=h[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const V=JSON.stringify({storage:B});d=await this.updateRemoteUserData(V,P?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(E==null?void 0:E.ref)!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const h=await this.getLocalGlobalState();return i(h)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let E=await super.resolveContent(d);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(d)),E){const h=this.parseSyncData(E);if(h)switch(this.extUri.basename(d)){case"globalState.json":return i(JSON.parse(h.content))}}return null}async hasLocalData(){var d;try{const{storage:E}=await this.getLocalGlobalState();if(Object.keys(E).length>1||((d=E[`${r}.locale`])===null||d===void 0?void 0:d.value)!=="en")return!0}catch(E){}return!1}async getLocalGlobalState(){const d={},E=await this.getLocalArgvContent(),h=(0,v.parse)(E);for(const P of t)h[P]!==void 0&&(d[`${r}${P}`]={version:1,value:h[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(d[P]={version:1,value:_})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:E,updated:h}){const P={},_={},j=(M,$)=>{for(const V of M){if(V.startsWith(r)){P[V.substring(r.length)]=$?$[V].value:void 0;continue}if($){const q=$[V];q.value!==String(this.storageService.get(V,0))&&(_[V]=q.value)}else this.storageService.get(V,0)!==void 0&&(_[V]=void 0)}};if(j(Object.keys(d),d),j(Object.keys(h),h),j(E),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(_))this.storageService.store(M,_[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(d){const E=await this.getLocalArgvContent();let h=E;for(const P of Object.keys(d))h=(0,O.edit)(h,[P],d[P],{});E!==h&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(h)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const E=this.storageService.keys(0,0),h=this.storageService.keys(0,1),P=[...E,...h],_=(d==null?void 0:d.storage)?Object.keys(d.storage).filter(j=>!j.startsWith(r)&&!P.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!C.isWeb){const j=[...S.ALL_SYNC_RESOURCES.map(B=>(0,S.getEnablementKey)(B)),S.SYNC_SERVICE_URL_TYPE];_.push(...j),h.push(...j)}return{user:E,machine:h,unregistered:_}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([Y(0,U.IFileService),Y(1,S.IUserDataSyncStoreService),Y(2,S.IUserDataSyncBackupStoreService),Y(3,S.IUserDataSyncLogService),Y(4,L.IEnvironmentService),Y(5,S.IUserDataSyncResourceEnablementService),Y(6,g.ITelemetryService),Y(7,y.IConfigurationService),Y(8,w.IStorageService)],o),e.GlobalStateSynchroniser=o;let a=class extends R.AbstractInitializer{constructor(d,E,h,P){super("globalState",h,P,E);this.storageService=d}async doInitialize(d){const E=d.syncData?JSON.parse(d.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const h={},P={};for(const _ of Object.keys(E.storage))_.startsWith(r)?h[_.substring(r.length)]=E.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=E.storage[_].value);if(Object.keys(h).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(h))_=(0,O.edit)(_,[j],h[j],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};a=he([Y(0,w.IStorageService),Y(1,U.IFileService),Y(2,L.IEnvironmentService),Y(3,S.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let l=class{constructor(d,E,h,P,_){this.userDataSyncStoreClient=d,this.storageService=E,this.environmentService=h,this.fileService=P,this.logService=_}getSyncStoreType(d){var E;const h=this.parseGlobalState(d);return(E=h==null?void 0:h.storage[S.SYNC_SERVICE_URL_TYPE])===null||E===void 0?void 0:E.value}async sync(d){const E=(0,S.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(d,E)}catch(h){if(h instanceof S.UserDataSyncError)switch(h.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,E)}throw h}}async doSync(d,E){const h=await this.userDataSyncStoreClient.read("globalState",null,E),P=this.parseGlobalState(h)||{storage:{}};P.storage[S.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const _=await(0,D.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),j={version:n,machineId:_,content:i(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),h.ref,E)}parseGlobalState({content:d}){if(!d)return null;const E=JSON.parse(d);if((0,R.isSyncData)(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};l=he([Y(1,w.IStorageService),Y(2,L.IEnvironmentService),Y(3,U.IFileService),Y(4,s.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[183],ee([0,1,10,20,178,32,120,9,25,7,15,18,45,22,19,23,3]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function C(s,r){const t=JSON.parse(s);if(!r)return(0,R.isUndefined)(t.all)?null:t.all;switch(v.OS){case 2:return(0,R.isUndefined)(t.mac)?null:t.mac;case 3:return(0,R.isUndefined)(t.linux)?null:t.linux;case 1:return(0,R.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=C;let D=class extends y.AbstractJsonFileSynchroniser{constructor(r,t,i,n,o,a,l,u,d,E){super(l.keybindingsResource,"keybindings",a,l,u,r,t,o,E,i,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(w.Event.filter(n.onDidChangeConfiguration,h=>h.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i){const n=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null,o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,a=await this.getLocalFileContent(),l=await this.getFormattingOptions();let u=null,d=!1,E=!1,h=!1;if(n){let _=a?a.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new k.UserDataSyncError((0,U.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==_||o!==n){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,A.merge)(_,n,o,l,this.userDataSyncUtilService);j.hasChanges&&(u=j.mergeContent,h=j.hasConflicts,d=h||j.mergeContent!==_,E=h||j.mergeContent!==n)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=a.value.toString(),E=!0);const P={content:u,localChange:d?a?2:1:0,remoteChange:E?2:0,hasConflicts:h};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:n,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,n){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,n){var o;const{fileContent:a}=i[0][0];let{content:l,localChange:u,remoteChange:d}=i[0][1];if(u===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new k.UserDataSyncError((0,U.localize)(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(l||"[]",a,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const E=this.toSyncContent(l||"[]",(o=r.syncData)===null||o===void 0?void 0:o.content);r=await this.updateRemoteUserData(E,n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(E){}(t==null?void 0:t.ref)!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,L.parse)(r.value.toString());if((0,g.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(r.syncData.content)}getKeybindingsContentFromSyncContent(r){try{return C(r,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,v.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let r=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return r!==void 0||(r=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,r!==void 0)?r:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};D=he([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,m.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,S.IFileService),Y(6,O.IEnvironmentService),Y(7,c.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],D),e.KeybindingsSynchroniser=D;let f=class extends y.AbstractInitializer{constructor(r,t,i){super("keybindings",t,i,r)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,p.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,L.parse)(r.value.toString());return!(0,g.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return C(r,!0)}catch(t){return this.logService.error(t),null}}};f=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(Z[184],ee([0,1,26,32,41,46,52,20,18]),function(K,e,S,k,A,L,U,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function v(l,u,d){let E=[];d?E=g(d):E=R(u);const h=[],P=[...(0,O.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const _ of E)_.startsWith("-")?P.push(_.substring(1)):h.push(_);return(0,m.distinct)([...l,...h].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=v;function R(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function g(l){const u=(0,k.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function y(l,u,d,E){if(d.length){const h=a(u),P=(0,k.parse)(u),_=(0,k.parse)(l),j=[];for(const B of d){const M=P[B],$=_[B];M===void 0?l=U.edit(l,[B],void 0,E):$!==void 0?l=U.edit(l,[B],M,E):j.push(r(B,h))}j.sort((B,M)=>B.startOffset-M.startOffset),j.forEach(B=>l=C(B.setting.key,u,l,E))}return l}e.updateIgnoredSettings=y;function b(l,u,d,E,h,P){const _=y(l,u,E,P),j=d!==_,B=d!==u;if(!j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(B&&!j)return{conflictsSettings:[],localContent:y(u,l,E,P),remoteContent:null,hasConflicts:!1};if(d===null&&p(l)){const ie=c(l,u,E)?null:y(u,l,E,P);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let M=l,$=u;const V=(0,k.parse)(l),q=(0,k.parse)(u),H=d?(0,k.parse)(d):null,z=E.reduce((ie,ce)=>(ie.add(ce),ie),new Set),I=w(V,q,z),T=w(H,V,z),F=w(H,q,z),N=new Map,x=new Set,G=ie=>{x.add(ie);const ce=h.filter(({key:ue})=>ue===ie)[0];ce?(M=U.edit(M,[ie],ce.value,P),$=U.edit($,[ie],ce.value,P)):N.set(ie,{key:ie,localValue:V[ie],remoteValue:q[ie]})};for(const ie of T.removed.values())F.updated.has(ie)?G(ie):$=U.edit($,[ie],void 0,P);for(const ie of F.removed.values())x.has(ie)||(T.updated.has(ie)?G(ie):M=U.edit(M,[ie],void 0,P));for(const ie of T.updated.values())x.has(ie)||(F.updated.has(ie)?I.updated.has(ie)&&G(ie):$=U.edit($,[ie],V[ie],P));for(const ie of F.updated.values())x.has(ie)||(T.updated.has(ie)?I.updated.has(ie)&&G(ie):M=U.edit(M,[ie],q[ie],P));for(const ie of T.added.values())x.has(ie)||(F.added.has(ie)?I.updated.has(ie)&&G(ie):$=C(ie,M,$,P));for(const ie of F.added.values())x.has(ie)||(T.added.has(ie)?I.updated.has(ie)&&G(ie):M=C(ie,$,M,P));const J=N.size>0||!c(M,$,E),Q=J||!c(M,l,[]),ne=J||!c($,u,[]);return{localContent:Q?M:null,remoteContent:ne?$:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=b;function c(l,u,d){if(l===u)return!0;const E=(0,k.parse)(l),h=(0,k.parse)(u),P=d.reduce((B,M)=>(B.add(M),B),new Set),_=a(l).filter(B=>!(B.setting&&P.has(B.setting.key))),j=a(u).filter(B=>!(B.setting&&P.has(B.setting.key)));if(_.length!==j.length)return!1;for(let B=0;B<_.length;B++){const M=_[B],$=j[B];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!S.equals(E[M.setting.key],h[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=c;function p(l){return l?a(l).length===0:!0}e.isEmpty=p;function w(l,u,d){const E=l?Object.keys(l).filter(B=>!d.has(B)):[],h=Object.keys(u).filter(B=>!d.has(B)),P=h.filter(B=>E.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),_=E.filter(B=>h.indexOf(B)===-1).reduce((B,M)=>(B.add(M),B),new Set),j=new Set;if(l){for(const B of E)if(!_.has(B)){const M=l[B],$=u[B];S.equals(M,$)||j.add(B)}}return{added:P,removed:_,updated:j}}function C(l,u,d,E){const h=(0,k.parse)(u),P=a(u),_=a(d),j=D(l,P,_);return f(d,l,h[l],j,_,E)}e.addSetting=C;function D(l,u,d){const E=u.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===l}),h=u[E-1];if(h){if(h.setting){const _=r(h.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!0}}else{const _=t(E,u);if(_){const j=r(_.setting.key,d);if(j){const B=i(d.indexOf(j),d),M=n(u,_,u[E]);if(B){const $=n(d,j,B),V=o(M,$);return V?{index:d.indexOf(V),insertAfter:!0}:{index:d.indexOf(B),insertAfter:!1}}else{const $=n(d,j,d[d.length-1]),V=o(M,$);return V?{index:d.indexOf(V),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const P=u[E+1];if(P)if(P.setting){const _=r(P.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!1}}else{const _=i(E,u);if(_){const j=r(_.setting.key,d);if(j){const B=t(d.indexOf(j),d),M=n(u,u[E],_);if(B){const $=n(d,B,j),V=o(M.reverse(),$.reverse());return V?{index:d.indexOf(V),insertAfter:!1}:{index:d.indexOf(B),insertAfter:!0}}else{const $=n(d,d[0],j),V=o(M.reverse(),$.reverse());return V?{index:d.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function f(l,u,d,E,h,P){let _;return E.index===-1?_=(0,A.setProperty)(l,[u],d,P):_=s(l,u,d,E,h,P).map(j=>(0,A.withFormatting)(l,j,P)[0]),(0,A.applyEdits)(l,_)}function s(l,u,d,E,h,P){var _;const j=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,B=(0,L.getEOL)(P,l),M=h[E.index];if(E.insertAfter){const $=[];if(M.setting)$.push({offset:M.endOffset,length:0,content:","+j});else{const V=i(E.index,h),q=t(E.index,h),H=(_=q==null?void 0:q.setting)===null||_===void 0?void 0:_.commaOffset;q&&H===void 0&&$.push({offset:q.endOffset,length:0,content:","});const z=H!==void 0&&H>M.endOffset;$.push({offset:z?H+1:M.endOffset,length:0,content:V?B+j+",":B+j})}return $}else{if(M.setting)return[{offset:M.startOffset,length:0,content:j+","}];const $=(h[E.index-1]&&!h[E.index-1].setting?B:"")+j+(i(E.index,h)?",":"")+B;return[{offset:M.startOffset,length:0,content:$}]}}function r(l,u){return u.filter(d=>{var E;return((E=d.setting)===null||E===void 0?void 0:E.key)===l})[0]}function t(l,u){for(let d=l-1;d>=0;d--)if(u[d].setting)return u[d]}function i(l,u){for(let d=l+1;d<u.length;d++)if(u[d].setting)return u[d]}function n(l,u,d){const E=l.indexOf(u),h=l.indexOf(d);return l.filter((P,_)=>E<_&&_<h)}function o(l,u){if(l.length&&u.length){let d=0;for(;d<u.length&&d<l.length;d++)if(l[d].value!==u[d].value)return u[d-1];return u[d-1]}}function a(l){const u=[];let d=-1,E,h;const P={onObjectBegin:_=>{d++},onObjectProperty:(_,j,B)=>{d===0&&(E=j,h=_)},onObjectEnd:(_,j)=>{d--,d===0&&u.push({startOffset:E,endOffset:_+j,value:l.substring(E,_+j),setting:{key:h,commaOffset:void 0}})},onArrayBegin:(_,j)=>{d++},onArrayEnd:(_,j)=>{d--,d===0&&u.push({startOffset:E,endOffset:_+j,value:l.substring(E,_+j),setting:{key:h,commaOffset:void 0}})},onLiteralValue:(_,j,B)=>{d===0&&u.push({startOffset:E,endOffset:j+B,value:l.substring(E,j+B),setting:{key:h,commaOffset:void 0}})},onSeparator:(_,j,B)=>{if(d===0&&_===","){let M=u.length-1;for(;M>=0&&!u[M].setting;M--);const $=u[M];$&&u.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:j}})}},onComment:(_,j)=>{d===0&&u.push({startOffset:_,endOffset:_+j,value:l.substring(_,_+j)})}};return(0,k.visit)(l,P),u}}),define(Z[185],ee([0,1,10,20,23,121,3,9,25,184,52,45,22,29,19,41]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function w(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function C(r){const t=JSON.parse(r);return w(t)?t:{settings:r}}e.parseSettingsSyncContent=C;let D=class extends g.AbstractJsonFileSynchroniser{constructor(t,i,n,o,a,l,u,d,E,h,P){super(i.settingsResource,"settings",t,i,n,o,a,E,h,l,u,d);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,n){const o=await this.getLocalFileContent(),a=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),u=i?this.getSettingsSyncContent(i):null,d=await this.getIgnoredSettings();let E=null,h=!1,P=!1,_=!1;if(l){let B=o?o.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,v.merge)(B,l.settings,u?u.settings:null,d,[],a);E=M.localContent||M.remoteContent,h=M.localContent!==null,P=M.remoteContent!==null,_=M.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),E=o.value.toString(),P=!0);const j={content:E,localChange:h?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,v.updateIgnoredSettings)(t.previewResult.content,"{}",o,n):null})}async getAcceptResult(t,i,n,o){const a=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,v.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,v.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,v.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,n,o){const{fileContent:a}=n[0][0];let{content:l,localChange:u,remoteChange:d}=n[0][1];if(u===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(l,a,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const E=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(l);l=(0,v.updateIgnoredSettings)(l,h?h.settings:"{}",P,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),n=(0,R.edit)(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,v.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const n=this.parseSyncData(i);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();i=(0,v.updateIgnoredSettings)(i,"{}",o,n)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return C(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError((0,L.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!s(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(i.content);if(!n||!n.settings)return;let o=n.settings;const a=await this.getFormattingOptions();for(const l in i)if(["version","content","machineId"].indexOf(l)===-1&&i[l]!==void 0){const u=(0,p.setProperty)(o,[l],i[l],a);u.length&&(o=(0,p.applyEdits)(o,u))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(o))}catch(t){}}};D=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,c.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,m.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,y.ITelemetryService),Y(10,b.IExtensionManagementService)],D),e.SettingsSynchroniser=D;let f=class extends g.AbstractInitializer{constructor(t,i,n){super("settings",i,n,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return C(t)}catch(i){this.logService.error(i)}return null}};f=he([Y(0,S.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function s(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&r.machineId!==void 0&&typeof r.machineId=="string")}}),define(Z[186],ee([0,1,20,9,10,25,45,22,23,179,19,26,3]),function(K,e,S,k,A,L,U,O,m,v,R,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends U.AbstractSynchroniser{constructor(w,C,D,f,s,r,t,i,n){super("snippets",C,w,D,f,s,i,n,r,t);this.version=1,this.snippetsFolder=w.snippetsHome,this._register(this.fileService.watch(w.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(y.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(w,C,D){const f=await this.getSnippetsFileContents(),s=this.toSnippetsContents(f),r=w.syncData?this.parseSnippets(w.syncData):null,t=C&&C.syncData?this.parseSnippets(C.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(s,r,t);return this.getResourcePreviews(i,f,r||{})}async getMergeResult(w,C){return w.previewResult}async getAcceptResult(w,C,D,f){if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:w.fileContent?w.fileContent.value.toString():null,localChange:0,remoteChange:w.fileContent?w.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:w.remoteContent,localChange:w.remoteContent!==null?w.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder))return D===void 0?{content:w.previewResult.content,localChange:w.previewResult.localChange,remoteChange:w.previewResult.remoteChange}:{content:D,localChange:D===null?w.fileContent!==null?3:0:2,remoteChange:D===null?w.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${C.toString()}`)}async applyResult(w,C,D,f){const s=D.map(([r,t])=>Object.assign(Object.assign({},r),{acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,f)),s.some(({remoteChange:r})=>r!==0)&&(w=await this.updateRemoteSnippets(s,w,f)),(C==null?void 0:C.ref)!==w.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(w),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch(t){}}getResourcePreviews(w,C,D){const f=new Map;for(const s of Object.keys(w.local.added)){const r={content:w.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};f.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(w.local.updated)){const r={content:w.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of w.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(w.remote.added)){const r={content:w.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(w.remote.updated)){const r={content:w.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s],localContent:C[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of w.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of w.conflicts){const r={content:C[s]?C[s].value.toString():null,hasConflicts:!0,localChange:C[s]?2:1,remoteChange:D[s]?2:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s]||null,localContent:C[s]?C[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(C))if(!f.has(s)){const r={content:C[s]?C[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:C[s]||null,localContent:C[s]?C[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:w}){let C=await super.resolveContent(w);if(C){const D=this.parseSyncData(C);if(D){const f=this.parseSnippets(D),s=[];for(const r of Object.keys(f)){const t=this.extUri.joinPath(w,r),i=this.extUri.joinPath(this.snippetsFolder,r),n=await this.fileService.exists(i);s.push({resource:t,comparableResource:n?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(w){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(w);let C=await super.resolveContent(w);if(C)return C;if(C=await super.resolveContent(this.extUri.dirname(w)),C){const D=this.parseSyncData(C);if(D)return this.parseSnippets(D)[this.extUri.basename(w)]||null}return null}async hasLocalData(){try{const w=await this.getSnippetsFileContents();if(Object.keys(w).length)return!0}catch(w){}return!1}async updateLocalBackup(w){const C={};for(const D of w)D.fileContent&&(C[this.extUri.basename(D.localResource)]=D.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(C)))}async updateLocalSnippets(w,C){for(const{fileContent:D,acceptResult:f,localResource:s,remoteResource:r,localChange:t}of w)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),n=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,m.VSBuffer.fromString(f.content),{overwrite:C}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,m.VSBuffer.fromString(f.content),C?void 0:D),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(w,C,D){const f=C.syncData?this.parseSnippets(C.syncData):{},s=(0,g.deepClone)(f);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:n}of w)if(n!==0){const o=t?this.extUri.basename(t):this.extUri.basename(i);n===3?delete s[o]:s[o]=r.content}return(0,v.areSame)(f,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),C=await this.updateRemoteUserData(JSON.stringify(s),D?null:C.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),C}parseSnippets(w){return JSON.parse(w.content)}toSnippetsContents(w){const C={};for(const D of Object.keys(w))C[D]=w[D].value.toString();return C}async getSnippetsFileContents(){const w={};let C;try{C=await this.fileService.resolve(this.snippetsFolder)}catch(D){if(D instanceof A.FileOperationError&&D.fileOperationResult===1)return w;throw D}for(const D of C.children||[]){const f=D.resource,s=this.extUri.extname(f);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);w[r]=t}}return w}};b=he([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,L.IConfigurationService),Y(7,S.IUserDataSyncResourceEnablementService),Y(8,O.ITelemetryService)],b),e.SnippetsSynchroniser=b;let c=class extends U.AbstractInitializer{constructor(w,C,D){super("snippets",C,D,w)}async doInitialize(w){const C=w.syncData?JSON.parse(w.syncData.content):null;if(!C){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(C)){const s=C[f];if(s){const r=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(r,m.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(w)}async isEmpty(){var w;try{return!((w=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||w===void 0?void 0:w.length)}catch(C){return C.fileOperationResult===1}}};c=he([Y(0,A.IFileService),Y(1,k.IEnvironmentService),Y(2,S.IUserDataSyncLogService)],c),e.SnippetsInitializer=c}),define(Z[59],ee([0,1,5,3,2,20]),function(K,e,S,k,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let U=class extends A.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};U=he([Y(0,L.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[187],ee([0,1,2,20,12,25,10,9,54,23,6]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends S.Disposable{constructor(b,c,p,w){super();this.environmentService=b,this.fileService=c,this.configurationService=p,this.logService=w,k.ALL_SYNC_RESOURCES.forEach(C=>this.cleanUpBackup(C))}async getAllRefs(b){const c=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),p=await this.fileService.resolve(c);return p.children?p.children.filter(C=>C.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(C.name)).sort().reverse().map(C=>({ref:C.name,created:this.getCreationTime(C)})):[]}async resolveContent(b,c){if(!c){const p=await this.getAllRefs(b);p.length&&(c=p[p.length-1].ref)}if(c){const p=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,c);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(b,c){const p=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),w=(0,A.joinPath)(p,`${(0,m.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(w,v.VSBuffer.fromString(c))}catch(C){this.logService.error(C)}try{this.cleanUpBackup(b)}catch(C){}}async cleanUpBackup(b){const c=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(c))return}catch(w){return}const p=await this.fileService.resolve(c);if(p.children){const w=p.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),C=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let D=w.filter(s=>Date.now()-this.getCreationTime(s)>C);const f=w.length-D.length;f<10&&(D=D.slice(10-f)),await R.Promises.settled(D.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};g=he([Y(0,O.IEnvironmentService),Y(1,U.IFileService),Y(2,L.IConfigurationService),Y(3,k.IUserDataSyncLogService)],g),e.UserDataSyncBackupStoreService=g}),define(Z[188],ee([0,1,4,2]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(y){this.service=y}listen(y,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(y,b,c){switch(b){case"triggerSync":return this.service.triggerSync(c[0],c[1],c[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(c[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class L{constructor(y){this.service=y}listen(y,b){throw new Error(`Event not found: ${b}`)}call(y,b,c){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(c[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(c[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class U{constructor(y){this.channel=y}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.channel.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.channel.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=U;class O{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(y,b,c){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(c[0],c[1]);case"setEnablement":return this.service.setEnablement(c[0],c[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=O;class m{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(y,b,c){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(c)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class v{constructor(y){this.service=y}listen(y,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(y,b,c){switch(b){case"switch":return this.service.switch(c[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class R extends k.Disposable{constructor(y){super();this.channel=y,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.channel.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(y)}revive(y){return{url:S.URI.revive(y.url),type:y.type,defaultUrl:S.URI.revive(y.defaultUrl),insidersUrl:S.URI.revive(y.insidersUrl),stableUrl:S.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(Z[189],ee([0,1,17,9]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends S.AbstractLogger{constructor(U,O){super();this.logger=this._register(U.createLogger(O.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...O){this.logger.trace(U,...O)}debug(U,...O){this.logger.debug(U,...O)}info(U,...O){this.logger.info(U,...O)}warn(U,...O){this.logger.warn(U,...O)}error(U,...O){this.logger.error(U,...O)}critical(U,...O){this.logger.critical(U,...O)}flush(){this.logger.flush()}};A=he([Y(0,S.ILoggerService),Y(1,k.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,5,2,44,9,10,19,20,124,28,7,21,3]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const c="sync.currentMachineName";let p=class He extends k.Disposable{constructor(C,D,f,s,r,t){super();this.storageService=f,this.userDataSyncStoreService=s,this.logService=r,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(C,D,f)}async getMachines(C){const D=await this.currentMachineIdPromise;return(await this.readMachinesData(C)).machines.map(s=>Object.assign(Object.assign({},s),{isCurrent:s.id===D}))}async addCurrentMachine(C){const D=await this.currentMachineIdPromise,f=await this.readMachinesData(C);f.machines.some(({id:s})=>s===D)||(f.machines.push({id:D,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(C){const D=await this.currentMachineIdPromise,f=await this.readMachinesData(C),s=f.machines.filter(({id:r})=>r!==D);s.length!==f.machines.length&&(f.machines=s,await this.writeMachinesData(f))}async renameMachine(C,D,f){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(f),t=r.machines.find(({id:i})=>i===C);t&&(t.name=D,await this.writeMachinesData(r),r.machines.some(({id:i})=>i===s)&&this.storageService.store(c,D,0,1))}async setEnablement(C,D){const f=await this.readMachinesData(),s=f.machines.find(({id:r})=>r===C);s&&(s.disabled=D?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(C){const D=this.storageService.get(c,0);if(D)return D;const f=`${this.productService.nameLong} (${(0,g.PlatformToString)(g.isWeb?0:g.platform)})`,s=new RegExp(`${(0,y.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let r=0;for(const t of C){const i=s.exec(t.name),n=i?parseInt(i[1]):0;r=n>r?n:r}return`${f} #${r+1}`}async readMachinesData(C){this.userData=await this.readUserData(C);const D=this.parse(this.userData);if(D.version!==He.VERSION)throw new Error((0,v.localize)(0,null,this.productService.nameLong));return D}async writeMachinesData(C){var D;const f=JSON.stringify(C),s=await this.userDataSyncStoreService.write(He.RESOURCE,f,((D=this.userData)===null||D===void 0?void 0:D.ref)||null);this.userData={ref:s,content:f},this._onDidChange.fire()}async readUserData(C){if(this.userData){const D=C&&C.latest?C.latest[He.RESOURCE]:void 0;if(this.userData.ref===D)return this.userData;if(D===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(He.RESOURCE,this.userData)}parse(C){if(C.content!==null)try{return JSON.parse(C.content)}catch(D){this.logService.error(D)}return{version:He.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=he([Y(0,L.IEnvironmentService),Y(1,U.IFileService),Y(2,O.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncLogService),Y(5,R.IProductService)],p),e.UserDataSyncMachinesService=p}),define(Z[83],ee([0,1,6,3,2,20,59,22,11,19,9,60,122,54,4,12,7,28]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const D="sync.enable",f="sync.disableMachineEventually",s="sync.sessionId",r="sync.storeUrl",t="sync.productQuality";let i=class extends A.Disposable{constructor(l,u,d){super();this.storageService=l,this.environmentService=u,this.userDataSyncStoreManagementService=d,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(D,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(D,l,0,1)}onDidStorageChange(l){if(l.scope===0&&D===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Y(0,v.IStorageService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let n=class extends A.Disposable{constructor(l,u,d,E,h,P,_,j,B,M,$){var V;super();this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=d,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=h,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=j,this.userDataSyncMachinesService=B,this.storageService=M,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=$,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(V=u.userDataSyncStore)===null||V===void 0?void 0:V.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(u.onDidChangeUserDataSyncStore(()=>{var q,H;(0,p.isEqual)(this.syncUrl,(q=u.userDataSyncStore)===null||q===void 0?void 0:q.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=u.userDataSyncStore)===null||H===void 0?void 0:H.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(d.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(h.onDidChangeLocal,(q,H)=>q?[...q,H]:[H],1e3)(q=>this.triggerSync(q,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,q])=>q)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(r,0);return l?c.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(r,l.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:u}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(d=>this.onDidFinishSync(d))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(u&&this.logService.info(u),this.autoSync.clear()):u&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(u))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,b.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,u,d){try{this.userDataSyncAccountService.account&&!d&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(u)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(D,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const u=L.UserDataSyncError.toUserDataSyncError(l);u instanceof L.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:u.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),u.code===L.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):u.code===L.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):u.code===L.UserDataSyncErrorCode.LocalTooManyRequests||u.code===L.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):u.code===L.UserDataSyncErrorCode.UpgradeRequired||u.code===L.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):u.code===L.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with newer version than of client. Requires client upgrade.`)):u.code===L.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with older version than of client. Requires server reset.`)):u.code===L.UserDataSyncErrorCode.ServiceChanged||u.code===L.UserDataSyncErrorCode.DefaultServiceChanged?w.isWeb&&u.code===L.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(u),this.successiveFailures++),this._onError.fire(u)}async disableMachineEventually(){this.storageService.store(f,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,0,!1)}stopDisableMachineEventually(){this.storageService.remove(f,0)}async triggerSync(l,u,d){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(u&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",d)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=he([Y(0,C.IProductService),Y(1,L.IUserDataSyncStoreManagementService),Y(2,L.IUserDataSyncStoreService),Y(3,L.IUserDataSyncResourceEnablementService),Y(4,L.IUserDataSyncService),Y(5,L.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,O.ITelemetryService),Y(8,g.IUserDataSyncMachinesService),Y(9,v.IStorageService),Y(10,L.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class o extends A.Disposable{constructor(l,u,d,E,h,P,_,j){super();this.lastSyncUrl=l,this.interval=u,this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=E,this.userDataSyncService=h,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=j,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(l,u){const d=(0,S.createCancelablePromise)(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,m.isPromiseCanceledError)(h))return}return this.doSync(l,u,E)});return this.syncPromise=d,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,p.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),u=this.userDataSyncStoreManagementService.userDataSyncStore;return!!u&&!!l&&(!(0,p.isEqual)(u.defaultUrl,l.defaultUrl)||!(0,p.isEqual)(u.insidersUrl,l.insidersUrl)||!(0,p.isEqual)(u.stableUrl,l.stableUrl))}async doSync(l,u,d){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(u),d.isCancellationRequested)return;let h=this.syncTask.manifest;if(h===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(0,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(1,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(2,null),L.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(s,0);if(P&&h&&P!==h.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new L.UserDataAutoSyncError((0,y.localize)(3,null),L.UserDataSyncErrorCode.DefaultServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(4,null),L.UserDataSyncErrorCode.ServiceChanged):new L.UserDataAutoSyncError((0,y.localize)(5,null),L.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(h||void 0);if(d.isCancellationRequested)return;const j=_.find(B=>B.isCurrent);if(j==null?void 0:j.disabled)throw new L.UserDataAutoSyncError((0,y.localize)(6,null),L.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),h===null&&(h=await this.userDataSyncStoreService.manifest()),h&&h.session!==P&&this.storageService.store(s,h.session,0,1),d.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(h||void 0)}catch(h){this.logService.error(h),E=h}this._onDidFinishSync.fire(E)}register(l){return super._register(l)}}o.INTERVAL_SYNCING="Interval"}),define(Z[190],ee([0,1,20,2,3,19,22,7]),function(K,e,S,k,A,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends k.Disposable{constructor(R,g){super();this.storageService=R,this.telemetryService=g,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(R.onDidChangeValue(y=>this.onDidStorageChange(y)))}isResourceEnabled(R){return this.storageService.getBoolean((0,S.getEnablementKey)(R),0,!0)}setResourceEnablement(R,g){if(this.isResourceEnabled(R)!==g){const y=(0,S.getEnablementKey)(R);this.telemetryService.publicLog2(y,{enabled:g}),this.storeResourceEnablement(y,g)}}getResourceSyncStateVersion(R){}storeResourceEnablement(R,g){this.storageService.store(R,g,0,O.isWeb?0:1)}onDidStorageChange(R){if(R.scope===0){const g=S.ALL_SYNC_RESOURCES.filter(y=>(0,S.getEnablementKey)(y)===R.key)[0];if(g){this._onDidChangeResourceEnablement.fire([g,this.isResourceEnabled(g)]);return}}}};m=he([Y(0,L.IStorageService),Y(1,U.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(Z[191],ee([0,1,20,2,5,3,180,183,182,43,22,18,19,185,12,186,31,6,11]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let s=class extends k.Disposable{constructor(n,o,a,l,u,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=o,this.instantiationService=a,this.logService=l,this.telemetryService=u,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(O.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(p.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(m.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(E=>L.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(E=>L.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(E=>L.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n){await this.checkEnablement();const o=(0,w.generateUuid)();let a;try{const E=(0,S.createSyncHeaders)(o);n&&(E["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(E)}catch(E){const h=S.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(h,o),h}let l=!1;const u=this;let d;return{manifest:a,run(){if(l)throw new Error("Can run a task only once");return d=(0,C.createCancelablePromise)(E=>u.sync(a,o,E)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,w.generateUuid)(),o=(0,S.createSyncHeaders)(n);let a;try{a=await this.userDataSyncStoreService.manifest(o)}catch(l){const u=S.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(u,n),u}return new r(n,a,o,this.synchronisers,this.logService)}async sync(n,o,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!a.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,S.createSyncHeaders)(o);for(const d of this.synchronisers){if(a.isCancellationRequested)return;try{await d.sync(n,u)}catch(E){if(E instanceof S.UserDataSyncError)switch(E.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(E.message,E.code,d.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const h=S.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(h,o),this.logService.error(E),this.logService.error(`${d.resource}: ${(0,v.toErrorMessage)(E)}`),this._syncErrors.push([d.resource,h])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(u){const d=S.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,o),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(o){this.logService.error(o)}}async replace(n){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(n))return}async accept(n,o,a,l){await this.checkEnablement();const u=this.getSynchroniser(n);await u.accept(o,a),l&&await u.apply(!1,(0,S.createSyncHeaders)((0,w.generateUuid)()))}async resolveContent(n){for(const o of this.synchronisers){const a=await o.resolveContent(n);if(a)return a}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,o){return this.getSynchroniser(n).getAssociatedResources(o)}getMachineId(n,o){return this.getSynchroniser(n).getMachineId(o)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of n)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(o){this.logService.error(`${n.resource}: ${(0,v.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const o=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,g.equals)(this._conflicts,n,([o,a],[l,u])=>o===o&&(0,g.equals)(a,u,(d,E)=>(0,c.isEqual)(d.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,o){this.telemetryService.publicLog2("sync/error",{code:n.code,url:n instanceof S.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(o=>o.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=he([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,S.IUserDataSyncLogService),Y(4,R.ITelemetryService),Y(5,y.IStorageService)],s),e.UserDataSyncService=s;class r extends k.Disposable{constructor(n,o,a,l,u){super();this.id=n,this.manifest=o,this.syncHeaders=a,this.synchronisers=l,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,C.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,o){try{return await this.performAction(n,a=>a.accept(n,o))}catch(a){throw this.logService.error(a),a}}async merge(n){try{return n?await this.performAction(n,o=>o.merge(n)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(n){try{return await this.performAction(n,o=>o.discard(n))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,o]of this.previews)for(const a of o.resourcePreviews)a.mergeState==="conflict"&&n.push(a.previewResource);for(const o of n)await this.discard(o);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===o);for(const d of a.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const u=await l.apply(!1,this.syncHeaders);u&&n.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(l=>l.resource===n);for(const l of o.resourcePreviews)await a.accept(l.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(l=>l.resource===n);for(const l of o.resourcePreviews)await a.accept(l.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(o){(0,D.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(n,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:B,previewResource:M,remoteResource:$})=>(0,c.isEqual)(n,B)||(0,c.isEqual)(n,M)||(0,c.isEqual)(n,$)));if(a===-1)return this.previews;const[l,u]=this.previews[a],d=u.resourcePreviews.find(({localResource:j,remoteResource:B,previewResource:M})=>(0,c.isEqual)(j,n)||(0,c.isEqual)(B,n)||(0,c.isEqual)(M,n));if(!d)return this.previews;let E=this.synchronizingResources.find(j=>j[0]===l);E||(E=[l,[]],this.synchronizingResources.push(E)),E[1].some(j=>(0,c.isEqual)(j,d.localResource))||(E[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const h=this.synchronisers.find(j=>j.resource===this.previews[a][0]),P=await o(h);P?this.previews.splice(a,1,this.toSyncResourcePreview(h.resource,P)):this.previews.splice(a,1);const _=this.synchronizingResources.findIndex(j=>j[0]===l);return this.synchronizingResources[_][1].splice(E[1].findIndex(j=>(0,c.isEqual)(j,d.localResource)),1),E[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===o);let u=a;for(const d of a.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(u=await l.merge(d.previewResource));u&&n.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const o=[];for(const a of this.synchronisers){if(n.isCancellationRequested)return[];const l=await a.preview(this.manifest,this.syncHeaders);l&&o.push(this.toSyncResourcePreview(a.resource,l))}return o}toSyncResourcePreview(n,o){return[n,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[192],ee([0,1,3,20,4,2,15]),function(K,e,S,k,A,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class O{constructor(g,y){this.service=g,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(g,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(g,y,b){try{return await this._call(g,y,b)}catch(c){throw this.logService.error(c),c}}async _call(g,y,b){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],A.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const c=y.substring("manualSync/".length),p=b[0],w=this.getManualSyncTask(p);switch(b=b.slice(1),c){case"preview":return w.preview();case"accept":return w.accept(A.URI.revive(b[0]),b[1]);case"merge":return w.merge(A.URI.revive(b[0]));case"discard":return w.discard(A.URI.revive(b[0]));case"discardConflicts":return w.discardConflicts();case"apply":return w.apply();case"pull":return w.pull();case"push":return w.push();case"stop":return w.stop();case"_getStatus":return w.status;case"dispose":return this.disposeManualSyncTask(w)}}throw new Error("Invalid call")}getManualSyncTask(g){const y=this.manualSyncTasks.get(this.createKey(g));if(!y)throw new Error(`Manual sync taks not found: ${g}`);return y.manualSyncTask}async createManualSyncTask(){const g=new L.DisposableStore,y=g.add(await this.service.createManualSyncTask());return g.add(y.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:b}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:g}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(g){var y;g.dispose();const b=this.createKey(g.id);(y=this.manualSyncTasks.get(b))===null||y===void 0||y.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(g){return`manualSyncTask-${g}`}}e.UserDataSyncChannel=O;class m extends L.Disposable{constructor(g){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,b,c){return g.call(y,b,c).then(null,p=>{throw k.UserDataSyncError.toUserDataSyncError(p)})},listen(y,b){return g.listen(y,b)}},this.channel.call("_getInitialData").then(([y,b,c])=>{this.updateStatus(y),this.updateConflicts(b),c&&this.updateLastSyncTime(c),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([b,c])=>[b,k.UserDataSyncError.toUserDataSyncError(c)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:g,manifest:y,status:b}=await this.channel.call("createManualSyncTask"),c=this,p=new v(g,y,b,{async call(w,C,D){return c.channel.call(`manualSync/${w}`,[g,...(0,U.isArray)(C)?C:[C]],D)},listen(w,C){return S.Event.map(S.Event.filter(c.channel.listen(`manualSync/${w}`,C),D=>!p.isDiposed()&&D.manualSyncTaskId===g),D=>D.data)}});return p}replace(g){return this.channel.call("replace",[g])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(g,y,b,c){return this.channel.call("accept",[g,y,b,c])}resolveContent(g){return this.channel.call("resolveContent",[g])}async getLocalSyncResourceHandles(g){return(await this.channel.call("getLocalSyncResourceHandles",[g])).map(({created:b,uri:c})=>({created:b,uri:A.URI.revive(c)}))}async getRemoteSyncResourceHandles(g){return(await this.channel.call("getRemoteSyncResourceHandles",[g])).map(({created:b,uri:c})=>({created:b,uri:A.URI.revive(c)}))}async getAssociatedResources(g,y){return(await this.channel.call("getAssociatedResources",[g,y])).map(({resource:c,comparableResource:p})=>({resource:A.URI.revive(c),comparableResource:A.URI.revive(p)}))}async getMachineId(g,y){return this.channel.call("getMachineId",[g,y])}async updateStatus(g){this._status=g,this._onDidChangeStatus.fire(g)}async updateConflicts(g){this._conflicts=g.map(([y,b])=>[y,b.map(c=>Object.assign(Object.assign({},c),{localResource:A.URI.revive(c.localResource),remoteResource:A.URI.revive(c.remoteResource),previewResource:A.URI.revive(c.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(g){this._lastSyncTime!==g&&(this._lastSyncTime=g,this._onDidChangeLastSyncTime.fire(g))}}e.UserDataSyncChannelClient=m;class v extends L.Disposable{constructor(g,y,b,c){super();this.id=g,this.manifest=y,this._disposed=!1,this._status=b;const p=this;this.channel={async call(w,C,D){try{const f=await c.call(w,C,D);return p.isDiposed()||(p._status=await c.call("_getStatus")),f}catch(f){throw k.UserDataSyncError.toUserDataSyncError(f)}},listen(w,C){return c.listen(w,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const g=await this.channel.call("preview");return this.deserializePreviews(g)}async accept(g,y){const b=await this.channel.call("accept",[g,y]);return this.deserializePreviews(b)}async merge(g){const y=await this.channel.call("merge",[g]);return this.deserializePreviews(y)}async discard(g){const y=await this.channel.call("discard",[g]);return this.deserializePreviews(y)}async discardConflicts(){const g=await this.channel.call("discardConflicts");return this.deserializePreviews(g)}async apply(){const g=await this.channel.call("apply");return this.deserializePreviews(g)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(g){return g.map(([y,b])=>[y,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(c=>Object.assign(Object.assign({},c),{localResource:A.URI.revive(c.localResource),remoteResource:A.URI.revive(c.remoteResource),previewResource:A.URI.revive(c.previewResource),acceptedResource:A.URI.revive(c.acceptedResource)}))}])}}}),define(Z[193],ee([0,1,2,20,40,12,30,25,28,44,9,10,19,31,7,3,6,15,4,11]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",r="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let a=class extends S.Disposable{constructor(P,_,j){super();this.productService=P,this.configurationService=_,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new p.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(p.Event.filter(j.onDidChangeValue,B=>{var M;return B.key===k.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((M=this.userDataSyncStore)===null||M===void 0?void 0:M.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,P,0,c.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=c.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const j=Object.assign(Object.assign({},P||{}),_||{});if(j&&(0,C.isString)(j.url)&&(0,C.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(B=>(0,C.isArray)(j.authenticationProviders[B].scopes))){const B=j,M=!!B.canSwitch&&!(_==null?void 0:_.url),$=B.url===B.insidersUrl?"insiders":"stable",V=(M?this.userDataSyncStoreType:void 0)||$,q=(_==null?void 0:_.url)||(V==="insiders"?B.insidersUrl:V==="stable"?B.stableUrl:B.url);return{url:D.URI.parse(q),type:V,defaultType:$,defaultUrl:D.URI.parse(B.url),stableUrl:D.URI.parse(B.stableUrl),insidersUrl:D.URI.parse(B.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(B.authenticationProviders).reduce((H,z)=>(H.push({id:z,scopes:B.authenticationProviders[z].scopes}),H),[])}}}};a=he([Y(0,m.IProductService),Y(1,O.IConfigurationService),Y(2,y.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let l=class extends a{constructor(P,_,j){super(P,_,j);const B=this.storageService.get(s,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const M=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(s,JSON.stringify(M),0,1):this.storageService.remove(s,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=he([Y(0,m.IProductService),Y(1,O.IConfigurationService),Y(2,y.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let u=class extends S.Disposable{constructor(P,_,j,B,M,$,V){super();this.requestService=j,this.logService=B,this.storageService=V,this._onTokenFailed=this._register(new p.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new p.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new p.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,v.getServiceMachineId)(M,$,V).then(q=>{const H={"X-Client-Name":`${_.applicationName}${c.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":q};return _.commit&&(H["X-Client-Commit"]=_.commit),H}),this.session=new E(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,L.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(r,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,w.createCancelablePromise)(j=>(0,w.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),j).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,j=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P),j={},B=await this.request(_.toString(),{type:"GET",headers:j},[],U.CancellationToken.None);return(await(0,A.asJson)(B)||[]).map(({url:$,created:V})=>({ref:(0,L.relativePath)(_,_.with({path:$})),created:V*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),B={};B["Cache-Control"]="no-cache";const M=await this.request(j,{type:"GET",headers:B},[],U.CancellationToken.None);return await(0,A.asText)(M)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),j={};await this.request(_,{type:"DELETE",headers:j},[],U.CancellationToken.None)}async read(P,_,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();j=Object.assign({},j),j["Cache-Control"]="no-cache",_&&(j["If-None-Match"]=_.ref);const M=await this.request(B,{type:"GET",headers:j},[304],U.CancellationToken.None);if(M.res.statusCode===304)return _;const $=M.res.headers.etag;if(!$)throw new k.UserDataSyncStoreError("Server did not return the ref",B,k.UserDataSyncErrorCode.NoRef,M.res.headers[k.HEADER_OPERATION_ID]);const V=await(0,A.asText)(M);return{ref:$,content:V}}async write(P,_,j,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",j&&(B["If-Match"]=j);const $=await this.request(M,{type:"POST",data:_,headers:B},[],U.CancellationToken.None),V=$.res.headers.etag;if(!V)throw new k.UserDataSyncStoreError("Server did not return the ref",M,k.UserDataSyncErrorCode.NoRef,$.res.headers[k.HEADER_OPERATION_ID]);return V}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,L.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const j=await this.request(_,{type:"GET",headers:P},[],U.CancellationToken.None),B=await(0,A.asJson)(j),M=this.storageService.get(t,0);return M&&B&&M!==B.session&&this.clearSession(),B===null&&M&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,L.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(P,_,j,B){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",P,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),M),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let $;try{$=await this.session.request(P,_,B)}catch(z){if(!(z instanceof k.UserDataSyncStoreError)){const I=(0,f.isPromiseCanceledError)(z)?k.UserDataSyncErrorCode.RequestCanceled:(0,f.getErrorMessage)(z).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;z=new k.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,I,void 0)}throw this.logService.info("Request failed",P),z}const V=$.res.headers[k.HEADER_OPERATION_ID],q={url:P,status:$.res.statusCode,"execution-id":_.headers[k.HEADER_EXECUTION_ID],"operation-id":V},H=(0,A.isSuccess)($)||$.res.statusCode&&j.indexOf($.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,k.UserDataSyncErrorCode.Unauthorized,V);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.Conflict,V);if($.res.statusCode===410)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,k.UserDataSyncErrorCode.Gone,V);if($.res.statusCode===412)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.PreconditionFailed,V);if($.res.statusCode===413)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,k.UserDataSyncErrorCode.TooLarge,V);if($.res.statusCode===426)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,k.UserDataSyncErrorCode.UpgradeRequired,V);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V)):new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequests,V)}if(!H)throw new k.UserDataSyncStoreError("Server returned "+$.res.statusCode,P,k.UserDataSyncErrorCode.Unknown,V);return $}addSessionHeaders(P){let _=this.storageService.get(i,0);_===void 0&&(_=(0,b.generateUuid)(),this.storageService.store(i,_,0,1)),P["X-Machine-Session-Id"]=_;const j=this.storageService.get(t,0);j!==void 0&&(P["X-User-Session-Id"]=j)}};u=he([Y(1,m.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,g.IFileService),Y(6,y.IStorageService)],u),e.UserDataSyncStoreClient=u;let d=class extends u{constructor(P,_,j,B,M,$,V){var q;super((q=P.userDataSyncStore)===null||q===void 0?void 0:q.url,_,j,B,M,$,V);this._register(P.onDidChangeUserDataSyncStore(()=>{var H;return this.updateUserDataSyncStoreUrl((H=P.userDataSyncStore)===null||H===void 0?void 0:H.url)}))}};d=he([Y(0,k.IUserDataSyncStoreManagementService),Y(1,m.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,g.IFileService),Y(6,y.IStorageService)],d),e.UserDataSyncStoreService=d;class E{constructor(P,_,j,B){this.limit=P,this.interval=_,this.requestService=j,this.logService=B,this.requests=[],this.startTime=void 0}request(P,_,j){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=E}),define(Z[194],ee([0,1,20,3,57,83,59,22,19,60,28]),function(K,e,S,k,A,L,U,O,m,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let g=class extends L.UserDataAutoSyncService{constructor(b,c,p,w,C,D,f,s,r,t,i,n){super(b,c,p,w,C,f,s,r,t,i,n);this._register(k.Event.debounce(k.Event.any(k.Event.map(D.onDidFocusWindow,()=>"windowFocus"),k.Event.map(D.onDidOpenWindow,()=>"windowOpen")),(o,a)=>o?[...o,a]:[a],1e3)(o=>this.triggerSync(o,!0,!1)))}};g=he([Y(0,R.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncResourceEnablementService),Y(4,S.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,S.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,O.ITelemetryService),Y(9,v.IUserDataSyncMachinesService),Y(10,m.IStorageService),Y(11,S.IUserDataAutoSyncEnablementService)],g),e.UserDataAutoSyncService=g}),define(Z[195],ee([0,1,3,2,6]),function(K,e,S,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:O,onDidFocusWindow:m,getActiveWindowId:v}){super();this.disposables=this._register(new k.DisposableStore),S.Event.latch(S.Event.any(O,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(O){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=O}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[61],ee([0,1,105,8,27,6,24,201,202,15]),function(K,e,S,k,A,L,U,O,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=R;function g(r){const t=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function y(r){if(r instanceof R)return r;let t;return/end of central directory record signature not found/.test(r.message)&&(t="CorruptZip"),new R(t,r)}function b(r,t,i,n,o,a){const l=k.dirname(t),u=k.join(n,l);if(!u.startsWith(n))return Promise.reject(new Error(S.localize(0,null,t)));const d=k.join(n,t);let E;return a.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(A.promises.mkdir(u,{recursive:!0})).then(()=>new Promise((h,P)=>{if(!a.isCancellationRequested)try{E=(0,A.createWriteStream)(d,{mode:i}),E.once("close",()=>h()),E.once("error",P),r.once("error",P),r.pipe(E)}catch(_){P(_)}}))}function c(r,t,i,n){let o=(0,L.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{o.cancel(),r.close()}),new Promise((l,u)=>{const d=new L.Sequencer,E=h=>{h.isCancellationRequested||(a++,r.readEntry())};r.once("error",u),r.once("close",()=>o.then(()=>{n.isCancellationRequested||r.entryCount===a?l():u(new R("Incomplete",new Error(S.localize(1,null,a,r.entryCount))))},u)),r.readEntry(),r.on("entry",h=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(h.fileName)){E(n);return}const P=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(P)){const B=k.join(t,P);o=(0,L.createCancelablePromise)(M=>A.promises.mkdir(B,{recursive:!0}).then(()=>E(M)).then(void 0,u));return}const _=w(r,h),j=g(h);o=(0,L.createCancelablePromise)(B=>d.queue(()=>_.then(M=>b(M,P,j,t,i,B).then(()=>E(B)))).then(null,u))}})})}function p(r,t=!1){return new Promise((i,n)=>{(0,O.open)(r,t?{lazyEntries:!0}:void 0,(o,a)=>{o?n(y(o)):i((0,v.assertIsDefined)(a))})})}function w(r,t){return new Promise((i,n)=>{r.openReadStream(t,(o,a)=>{o?n(y(o)):i((0,v.assertIsDefined)(a))})})}function C(r,t){return new Promise((i,n)=>{const o=new m.ZipFile;t.forEach(l=>{l.contents?o.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&o.addFile(l.localPath,l.path)}),o.end();const a=(0,A.createWriteStream)(r);o.outputStream.pipe(a),o.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(r))})}e.zip=C;function D(r,t,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=p(r,!0);return i.overwrite&&(a=a.then(l=>(0,U.rimraf)(t).then(()=>l))),a.then(l=>c(l,t,{sourcePathRegex:o},n))}e.extract=D;function f(r,t){return p(r).then(i=>new Promise((n,o)=>{i.on("entry",a=>{a.fileName===t&&w(i,a).then(l=>n(l),l=>o(l))}),i.once("close",()=>o(new Error(S.localize(2,null,t))))}))}function s(r,t){return f(r,t).then(i=>new Promise((n,o)=>{const a=[];i.once("error",o),i.on("data",l=>a.push(l)),i.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=s}),define(Z[196],ee([0,1,61,110]),function(K,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(L){return(0,S.buffer)(L,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(O){throw new Error((0,k.localize)(0,null))}})}e.getManifest=A}),define(Z[197],ee([0,1,27,56,2,24,8,17,29,33,6,4,9,130,111,28,61,7,18,16,10,12,31,11]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const n="scanningSystem",o="scanningUser",a="extracting",l="deleting",u="renaming";let d=class extends A.Disposable{constructor(h,P,_,j,B){super();this.beforeRemovingExtension=h,this.fileService=P,this.logService=_,this.environmentService=j,this.productService=B,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(h){const P=[];(h===null||h===0)&&P.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(_).message,n)))),(h===null||h===1)&&P.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(_).message,o))));try{const _=await Promise.all(P);return(0,D.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(h){this.logService.trace("Started scanning user extensions");let[P,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(j=>!P[new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),h&&(_=(0,v.groupByExtension)(_,B=>B.identifier).map(B=>B.sort((M,$)=>k.rcompare(M.manifest.version,$.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(h,P,_){const j=h.key(),B=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),M=U.join(this.extensionsPath,j);try{await L.rimraf(M)}catch(V){try{await L.rimraf(M)}catch(q){}throw new m.ExtensionManagementError((0,c.localize)(0,null,M,h.id),l)}await this.extractAtLocation(h,P,B,_);let $=await this.scanExtension(g.URI.file(B),1);if(!$)throw new Error((0,c.localize)(1,null,B));await this.storeMetadata($,{installedTimestamp:Date.now()});try{await this.rename(h,B,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(V){try{await L.rimraf(B)}catch(q){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",h.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(V)}. Deleted from extracted location`,B),V}try{$=await this.scanExtension(g.URI.file(M),1)}catch(V){}if($)return $;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(h,P){return this.setMetadata(h,P),await this.storeMetadata(h,Object.assign(Object.assign({},P),{installedTimestamp:h.installedTimestamp})),h}async storeMetadata(h,P){P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0,P.installedTimestamp=P.installedTimestamp||void 0;const _=U.join(h.location.fsPath,"package.json"),j=await S.promises.readFile(_,"utf8"),{manifest:B}=await this.parseManifest(j);return B.__metadata=P,await L.writeFile(_,JSON.stringify(B,null,"	")),h}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...h){const P=h.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{P.forEach(j=>_[j.key()]=!0)})}async setInstalled(h){await this.withUninstalledExtensions(j=>delete j[h.key()]);const _=(await this.scanExtensions(1)).find(j=>new v.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(h))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(h){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await S.promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let _={};if(P)try{_=JSON.parse(P)}catch(j){}return h&&(h(_),Object.keys(_).length?await L.writeFile(this.uninstalledPath,JSON.stringify(_)):await L.rimraf(this.uninstalledPath)),_})}async removeExtension(h,P){this.logService.trace(`Deleting ${P} extension from disk`,h.identifier.id,h.location.fsPath),await L.rimraf(h.location.fsPath),this.logService.info("Deleted from disk",h.identifier.id,h.location.fsPath)}async removeUninstalledExtension(h){await this.removeExtension(h,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new v.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()])}async extractAtLocation(h,P,_,j){this.logService.trace(`Started extracting the extension from ${P} to ${_}`);try{await L.rimraf(_)}catch(B){throw new m.ExtensionManagementError(this.joinErrors(B).message,l)}try{await(0,w.extract)(P,_,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${_}:`,h.id)}catch(B){try{await L.rimraf(_)}catch(M){}throw new m.ExtensionManagementError(B.message,B instanceof w.ExtractError&&B.type?B.type:a)}}async rename(h,P,_,j){try{await S.promises.rename(P,_)}catch(B){if(C.isWindows&&B&&B.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${P} to ${_} with 'EPERM' error. Trying again...`,h.id),this.rename(h,P,_,j);throw new m.ExtensionManagementError(B.message||(0,c.localize)(3,null,P,_),B.code||u)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const h=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return h;const P=this.scanDevSystemExtensions(),[_,j]=await Promise.all([h,P]);return[..._,...j]}async scanExtensionsInDir(h,P){const _=new R.Limiter(10),j=await this.fileService.resolve(g.URI.file(h));return j.children?(await Promise.all(j.children.filter(M=>M.isDirectory).map(M=>_.queue(async()=>P===1&&(0,r.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,P))))).filter(M=>M&&M.identifier):[]}async scanExtension(h,P){var _,j;try{const B=await this.fileService.resolve(h);if(B.children){const{manifest:M,metadata:$}=await this.readManifest(h.fsPath),V=(_=B.children.find(({name:I})=>/^readme(\.txt|\.md|)$/i.test(I)))===null||_===void 0?void 0:_.resource,q=(j=B.children.find(({name:I})=>/^changelog(\.txt|\.md|)$/i.test(I)))===null||j===void 0?void 0:j.resource,H={id:(0,v.getGalleryExtensionId)(M.publisher,M.name)},z={type:P,identifier:H,manifest:M,location:h,readmeUrl:V,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return $&&(this.setMetadata(z,$),z.installedTimestamp=$.installedTimestamp),z}}catch(B){P!==0&&this.logService.trace(B)}return null}async scanDefaultSystemExtensions(){const h=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",h.length),h}async scanDevSystemExtensions(){const h=this.getDevSystemExtensionsList();if(h.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(_=>h.some(j=>(0,v.areSameExtensions)(_.identifier,{id:j})))}else return[]}setMetadata(h,P){h.publisherDisplayName=P.publisherDisplayName||null,h.publisherId=P.publisherId||null,h.identifier.uuid=P.id,h.isMachineScoped=!!P.isMachineScoped,h.isBuiltin=h.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const h=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),_=new Set;for(const M of P)h[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||_.add(M.identifier.id.toLowerCase());const j=(0,v.groupByExtension)(P,M=>M.identifier);await R.Promises.settled(j.map(async M=>{const $=M.sort((V,q)=>k.rcompare(V.manifest.version,q.manifest.version))[0];_.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension($)}));const B=P.filter(M=>h[new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await R.Promises.settled(B.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const h=await this.scanAllUserExtensions(),P=[],_=(0,v.groupByExtension)(h,j=>j.identifier);P.push(...(0,D.flatten)(_.map(j=>j.sort((B,M)=>k.rcompare(B.manifest.version,M.manifest.version)).slice(1)))),await R.Promises.settled(P.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(h=>h.name)}joinErrors(h){const P=Array.isArray(h)?h:[h];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((_,j)=>new Error(`${_.message}${_.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(f.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(h){const P=[S.promises.readFile(U.join(h,"package.json"),"utf8").then(M=>this.parseManifest(M)),S.promises.readFile(U.join(h,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:_,metadata:j},B]=await Promise.all(P);return{manifest:(0,b.localizeManifest)(_,B),metadata:j}}parseManifest(h){return new Promise((P,_)=>{try{const j=JSON.parse(h),B=j.__metadata||null;P({manifest:j,metadata:B})}catch(j){_(new Error((0,c.localize)(4,null)))}})}};d=he([Y(1,s.IFileService),Y(2,O.ILogService),Y(3,y.INativeEnvironmentService),Y(4,p.IProductService)],d),e.ExtensionsScanner=d}),define(Z[198],ee([0,1,27,109,8,24,2,18,61,29,33,9,6,3,56,4,51,7,17,143,43,22,68,12,31,70,5,16,30,196,151,197,152,153,10]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s,r,t,i,n,o,a,l,u,d,E,h,P,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const B="unsetUninstalled",M="downloading",$="validating",V="local",q="unknown";let H=class extends U.Disposable{constructor(I,T,F,N,x,G,J){super();this.environmentService=I,this.galleryService=T,this.logService=F,this.downloadService=N,this.telemetryService=x,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(G.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(h.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new f.ExtensionsManifestCache(I,this)),this.extensionsDownloader=this._register(G.createInstance(E.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,J,I,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ce})=>{ie.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(I){this.logService.trace("ExtensionManagementService#zip",I.identifier.id);const T=await this.collectFiles(I),F=await(0,m.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,T);return p.URI.file(F)}async unzip(I){return this.logService.trace("ExtensionManagementService#unzip",I.toString()),(await this.install(I)).identifier}async getManifest(I){const T=await this.downloadVsix(I),F=A.resolve(T.fsPath);return(0,d.getManifest)(F)}async collectFiles(I){const T=async N=>{let x=await L.readdir(N);x=x.map(Q=>A.join(N,Q));const G=await Promise.all(x.map(Q=>S.promises.stat(Q)));let J=Promise.resolve([]);return G.forEach((Q,ne)=>{const ie=x[ne];Q.isFile()&&(J=J.then(ce=>[...ce,ie])),Q.isDirectory()&&(J=J.then(ce=>T(ie).then(ue=>[...ce,...ue])))}),J};return(await T(I.location.fsPath)).map(N=>({path:`extension/${A.relative(I.location.fsPath,N)}`,localPath:N}))}async install(I,T={}){return this.logService.trace("ExtensionManagementService#install",I.toString()),(0,y.createCancelablePromise)(async F=>{const N=await this.downloadVsix(I),x=A.resolve(N.fsPath),G=await(0,d.getManifest)(x),J={id:(0,R.getGalleryExtensionId)(G.publisher,G.name)};let Q=1;if(G.engines&&G.engines.vscode&&!(0,t.isEngineValid)(G.engines.vscode,w.default.version))throw new Error(k.localize(0,null,J.id,w.default.version));const ne=new R.ExtensionIdentifierWithVersion(J,G.version),ce=(await this.getInstalled(1)).find(ge=>(0,R.areSameExtensions)(J,ge.identifier));if(ce)if(T.isMachineScoped=T.isMachineScoped||ce.isMachineScoped,T.isBuiltin=T.isBuiltin||ce.isBuiltin,Q=2,ne.equals(new R.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(k.localize(1,null,G.displayName||G.name))}else c.gt(ce.manifest.version,G.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ne);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(Ee){throw new Error(k.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",J.id),this._onInstallExtension.fire({identifier:J,zipPath:x});let ue;try{ue=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(G.publisher,G.name))}catch(ge){}try{const ge=await this.installFromZipPath(ne,x,Object.assign(Object.assign({},ue||{}),T),T,Q,F);return this.logService.info("Successfully installed the extension:",J.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",J.id,ge.message),ge}})}async downloadVsix(I){if(I.scheme===l.Schemas.file)return I;if(!this.downloadService)throw new Error("Download service is not available");const T=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(I,T),T}async installFromZipPath(I,T,F,N,x,G){try{const J=await this.installExtension({zipPath:T,identifierWithVersion:I,metadata:F},G);try{await this.installDependenciesAndPackExtensions(J,void 0,N)}catch(Q){(0,O.isNonEmptyArray)(J.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",J.identifier.id,Q.message),(0,O.isNonEmptyArray)(J.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",J.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:I,zipPath:T,local:J,operation:x}),J}catch(J){throw this._onDidInstallExtension.fire({identifier:I,zipPath:T,operation:x,error:J}),J}}async canInstall(I){return!0}async installFromGallery(I,T={}){if(!this.galleryService.isEnabled())throw new Error(k.localize(3,null));try{I=await this.checkAndGetCompatibleVersion(I)}catch(x){const G=x&&x.code?x.code:q;throw this.logService.error("Failed to install extension:",I.identifier.id,x?x.message:G),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(I),void 0,x),x instanceof Error&&(x.name=G),x}const F=new R.ExtensionIdentifierWithVersion(I.identifier,I.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,y.createCancelablePromise)(x=>this.doInstallFromGallery(I,T,x)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(I,T,F){const N=new Date().getTime();let x=1;this.logService.info("Installing extension:",I.identifier.id),this._onInstallExtension.fire({identifier:I.identifier,gallery:I});try{const J=(await this.getInstalled(1)).find(ie=>(0,R.areSameExtensions)(ie.identifier,I.identifier));J&&(x=2);const Q=await this.downloadInstallableExtension(I,x);Q.metadata.isMachineScoped=T.isMachineScoped||(J==null?void 0:J.isMachineScoped),Q.metadata.isBuiltin=T.isBuiltin||(J==null?void 0:J.isBuiltin);const ne=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(p.URI.file(Q.zipPath))}catch(ie){}if(!T.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,J,T)}catch(ie){try{await this.uninstall(ne)}catch(ce){}throw ie}return J&&c.neq(J.manifest.version,I.version)&&await this.extensionsScanner.setUninstalled(J),this.logService.info("Extensions installed successfully:",I.identifier.id),this._onDidInstallExtension.fire({identifier:I.identifier,gallery:I,local:ne,operation:x}),this.reportTelemetry(this.getTelemetryEvent(x),(0,R.getGalleryExtensionTelemetryData)(I),new Date().getTime()-N,void 0),ne}catch(G){const J=G&&G.code?G.code:q;throw this.logService.error("Failed to install extension:",I.identifier.id,G?G.message:J),this._onDidInstallExtension.fire({identifier:I.identifier,gallery:I,operation:x,error:J}),this.reportTelemetry(this.getTelemetryEvent(x),(0,R.getGalleryExtensionTelemetryData)(I),new Date().getTime()-N,G),G instanceof Error&&(G.name=J),G}}async checkAndGetCompatibleVersion(I){if(await this.isMalicious(I))throw new v.ExtensionManagementError(k.localize(4,null),v.INSTALL_ERROR_MALICIOUS);const T=await this.galleryService.getCompatibleExtension(I);if(!T)throw new v.ExtensionManagementError(k.localize(5,null,I.identifier.id,w.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return T}async reinstallFromGallery(I){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",I.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(6,null));const T=await this.findGalleryExtension(I);if(!T)throw new Error(k.localize(7,null));await this.extensionsScanner.setUninstalled(I);try{await this.extensionsScanner.removeUninstalledExtension(I)}catch(F){throw new Error(k.localize(8,null,(0,s.toErrorMessage)(F)))}await this.installFromGallery(T)}getTelemetryEvent(I){return I===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(I){const T=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(T).has(I.identifier.id)}async downloadInstallableExtension(I,T){const F={id:I.identifier.uuid,publisherId:I.publisherId,publisherDisplayName:I.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",I.identifier.id),N=(await this.extensionsDownloader.downloadExtension(I,T)).fsPath,this.logService.info("Downloaded extension:",I.identifier.id,N)}catch(x){throw new v.ExtensionManagementError(this.joinErrors(x).message,M)}try{const x=await(0,d.getManifest)(N);return{zipPath:N,identifierWithVersion:new R.ExtensionIdentifierWithVersion(I.identifier,x.version),metadata:F}}catch(x){throw new v.ExtensionManagementError(this.joinErrors(x).message,$)}}async installExtension(I,T){try{const F=await this.unsetUninstalledAndGetLocal(I.identifierWithVersion);if(F)return I.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,I.metadata):F}catch(F){throw C.isMacintosh?new v.ExtensionManagementError(k.localize(9,null),B):new v.ExtensionManagementError(k.localize(10,null),B)}return this.extractAndInstall(I,T)}async unsetUninstalledAndGetLocal(I){if(!await this.isUninstalled(I))return null;this.logService.trace("Removing the extension from uninstalled list:",I.id);const F=await this.extensionsScanner.setInstalled(I);return this.logService.info("Removed the extension from uninstalled list:",I.id),F}async extractAndInstall({zipPath:I,identifierWithVersion:T,metadata:F},N){let x=await this.extensionsScanner.extractUserExtension(T,I,N);return this.logService.info("Installation completed.",T.id),F&&(x=await this.extensionsScanner.saveMetadataForLocalExtension(x,F)),x}async installDependenciesAndPackExtensions(I,T,F){if(!!this.galleryService.isEnabled()){const N=I.manifest.extensionDependencies||[];if(I.manifest.extensionPack)for(const x of I.manifest.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(G=>(0,R.areSameExtensions)({id:G},{id:x}))||N.every(G=>!(0,R.areSameExtensions)({id:G},{id:x}))&&N.push(x);if(N.length){const x=await this.getInstalled(),G=N.filter(J=>x.every(({identifier:Q})=>!(0,R.areSameExtensions)(Q,{id:J})));if(G.length){const Q=(await this.galleryService.query({names:G,pageSize:N.length},u.CancellationToken.None)).firstPage;try{await y.Promises.settled(Q.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(Q)}catch(ie){}throw ne}}}}}async rollback(I){const F=(await this.getInstalled(1)).filter(N=>I.some(x=>new R.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new R.ExtensionIdentifierWithVersion(x.identifier,x.version))));await y.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(I,T={}){this.logService.trace("ExtensionManagementService#uninstall",I.identifier.id);const F=await this.getInstalled(1),N=F.find(x=>(0,R.areSameExtensions)(x.identifier,I.identifier));if(!N)throw new Error(k.localize(11,null,I.manifest.displayName||I.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,T)}catch(x){throw this.joinErrors(x)}}async updateMetadata(I,T){return this.logService.trace("ExtensionManagementService#updateMetadata",I.identifier.id),I=await this.extensionsScanner.saveMetadataForLocalExtension(I,Object.assign(Object.assign({},I.manifest.__metadata||{}),T)),this.manifestCache.invalidate(),I}async updateExtensionScope(I,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",I.identifier.id),I=await this.extensionsScanner.saveMetadataForLocalExtension(I,Object.assign(Object.assign({},I.manifest.__metadata||{}),{isMachineScoped:T})),this.manifestCache.invalidate(),I}async getGalleryMetadata(I){const T=await this.findGalleryExtensionByName(I);return T?{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId}:void 0}async findGalleryExtension(I){if(I.identifier.uuid){const T=await this.findGalleryExtensionById(I.identifier.uuid);return T||this.findGalleryExtensionByName(I.identifier.id)}return this.findGalleryExtensionByName(I.identifier.id)}async findGalleryExtensionById(I){return(await this.galleryService.query({ids:[I],pageSize:1},u.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(I){return(await this.galleryService.query({names:[I],pageSize:1},u.CancellationToken.None)).firstPage[0]}joinErrors(I){const T=Array.isArray(I)?I:[I];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(I,T,F){try{await this.preUninstallExtension(I);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(I,T);await this.uninstallExtensions(I,N,T,F)}catch(N){throw await this.postUninstallExtension(I,new v.ExtensionManagementError(N instanceof Error?N.message:N,V)),N}await this.postUninstallExtension(I)}async uninstallExtensions(I,T,F,N){const x=[I,...T];if(!N.donotCheckDependents)for(const G of x)this.checkForDependents(G,x,F,I);await y.Promises.settled([this.uninstallExtension(I),...T.map(G=>this.doUninstall(G))])}checkForDependents(I,T,F,N){const x=this.getDependents(I,F);if(x.length){const G=x.filter(J=>T.indexOf(J)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(I,G,N))}}getDependentsErrorMessage(I,T,F){return F===I?T.length===1?k.localize(12,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?k.localize(13,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):k.localize(14,null,F.manifest.displayName||F.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):T.length===1?k.localize(15,null,F.manifest.displayName||F.manifest.name,I.manifest.displayName||I.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?k.localize(16,null,F.manifest.displayName||F.manifest.name,I.manifest.displayName||I.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):k.localize(17,null,F.manifest.displayName||F.manifest.name,I.manifest.displayName||I.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name)}getAllPackExtensionsToUninstall(I,T,F=[]){if(F.indexOf(I)!==-1)return[];F.push(I);const N=I.manifest.extensionPack?I.manifest.extensionPack:[];if(N.length){const x=T.filter(J=>!J.isBuiltin&&N.some(Q=>(0,R.areSameExtensions)({id:Q},J.identifier))),G=[];for(const J of x)G.push(...this.getAllPackExtensionsToUninstall(J,T,F));return[...x,...G]}return[]}getDependents(I,T){return T.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,R.areSameExtensions)({id:N},I.identifier)))}async doUninstall(I){try{await this.preUninstallExtension(I),await this.uninstallExtension(I)}catch(T){throw await this.postUninstallExtension(I,new v.ExtensionManagementError(T instanceof Error?T.message:T,V)),T}await this.postUninstallExtension(I)}async preUninstallExtension(I){if(!await L.exists(I.location.fsPath))throw new Error(k.localize(18,null));this.logService.info("Uninstalling extension:",I.identifier.id),this._onUninstallExtension.fire(I.identifier)}async uninstallExtension(I){let T=this.uninstallingExtensions.get(I.identifier.id);return T||(T=(0,y.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,R.areSameExtensions)(N.identifier,I.identifier)))}),this.uninstallingExtensions.set(I.identifier.id,T),T.finally(()=>this.uninstallingExtensions.delete(I.identifier.id))),T}async postUninstallExtension(I,T){if(T)this.logService.error("Failed to uninstall extension:",I.identifier.id,T.message);else if(this.logService.info("Successfully uninstalled extension:",I.identifier.id),I.identifier.uuid)try{await this.galleryService.reportStatistic(I.manifest.publisher,I.manifest.name,I.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(I),void 0,T);const F=T?T instanceof v.ExtensionManagementError?T.code:q:void 0;this._onDidUninstallExtension.fire({identifier:I.identifier,error:F})}getInstalled(I=null){return this.extensionsScanner.scanExtensions(I)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(I){return(await this.filterUninstalled(I)).length===1}async filterUninstalled(...I){const T=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of I)F[N.key()]&&T.push(N.key());return T}getExtensionsReport(){const I=new Date().getTime();return(!this.reportedExtensions||I-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=I),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const I=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${I.length} reported extensions from service`),I}catch(I){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(I,T,F,N){const x=N?N instanceof v.ExtensionManagementError?N.code:q:void 0;this.telemetryService.publicLogError(I,Object.assign(Object.assign({},T),{success:!N,duration:F,errorcode:x}))}};H=he([Y(0,g.INativeEnvironmentService),Y(1,v.IExtensionGalleryService),Y(2,D.ILogService),Y(3,(0,a.optional)(o.IDownloadService)),Y(4,r.ITelemetryService),Y(5,a.IInstantiationService),Y(6,j.IFileService)],H),e.ExtensionManagementService=H}),define(Z[203],ee([0,1,27,38,204,99,51,98,34,74,50,147,9,127,129,29,198,170,25,161,40,162,22,58,168,78,79,173,17,75,154,55,2,163,70,159,158,141,140,149,148,169,69,155,10,157,16,28,20,191,193,188,57,189,194,167,19,165,190,59,187,171,60,71,131,195,172,83,82,81,5,150,142,11,43,80,176,175,192,138,144,174,4,12]),function(K,e,S,k,A,L,U,O,m,v,R,g,y,b,c,p,w,C,D,f,s,r,t,i,n,o,a,l,u,d,E,h,P,_,j,B,M,$,V,q,H,z,I,T,F,N,x,G,J,Q,ne,ie,ce,ue,ge,Ee,Ie,Oe,Ae,Ue,ke,Ne,De,Te,Ge,Ke,$e,ze,X,re,se,me,W,te,oe,ae,le,fe,ve,Se,we,be,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends P.Disposable{constructor(de){super();this.configuration=de,this.server=this._register(new O.Server),(0,A.gracefulify)(S),this.registerListeners()}registerListeners(){const de=()=>this.dispose();process.once("exit",de),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",de)}async open(){const de=await this.initServices();(0,J.registerConfiguration)(),de.invokeFunction(Le=>{const _e=Le.get(u.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(_e)}),this._register((0,P.combinedDisposable)(de.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),de.createInstance(M.LanguagePackCachedDataCleaner),de.createInstance($.StorageDataCleaner,this.configuration.backupWorkspacesPath),de.createInstance(V.LogsDataCleaner),de.createInstance(me.LocalizationsUpdater),de.createInstance(W.DeprecatedExtensionsCleaner)))}async initServices(){const de=new v.ServiceCollection,Le=Object.assign({_serviceBrand:void 0},U.default);de.set(G.IProductService,Le);const _e=new m.StaticRouter(qe=>qe==="main"),Fe=new H.MessagePortMainProcessService(this.server,_e);de.set(q.IMainProcessService,Fe);const Me=new b.NativeEnvironmentService(this.configuration.args,Le);de.set(y.INativeEnvironmentService,Me);const Ze=new d.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),Ye=new d.LoggerChannelClient(this.configuration.logLevel,Ze.onDidChangeLogLevel,Fe.getChannel("logger"));de.set(u.ILoggerService,Ye);const tt=this._register(new u.MultiplexLogService([this._register(new u.ConsoleLogger(this.configuration.logLevel)),this._register(Ye.createLogger((0,ye.joinPath)(Pe.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new d.FollowerLogService(Ze,tt));de.set(u.ILogService,Be);const We=this._register(new T.FileService(Be));de.set(F.IFileService,We);const it=this._register(new N.DiskFileSystemProvider(Be));We.registerProvider(x.Schemas.file,it);const Ve=this._register(new f.ConfigurationService(Me.settingsResource,We));de.set(D.IConfigurationService,Ve),await Ve.initialize();const Je=new Ee.NativeStorageService(void 0,Fe,Me);de.set(Ie.IStorageService,Je),await Je.initialize(),this._register((0,P.toDisposable)(()=>Je.flush())),de.set(s.IRequestService,new R.SyncDescriptor(r.RequestService)),de.set(Se.IChecksumService,new R.SyncDescriptor(we.ChecksumService));const et=m.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});de.set(ce.INativeHostService,et),de.set(j.IDownloadService,new R.SyncDescriptor(_.DownloadService));const nt=this._register(new Ke.ActiveWindowManager(et)),ut=new m.StaticRouter(qe=>nt.getActiveClientId().then(rt=>qe===rt));de.set(Te.IExtensionRecommendationNotificationService,new Ge.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let Xe,xe;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Le.enableTelemetry){xe=new $e.TelemetryLogAppender(Ye,Me);const{appRoot:qe,extensionsPath:rt,isBuilt:dt,installSourcePath:ft}=Me;if(Le.aiConfig&&Le.aiConfig.asimovKey&&dt){const at=new l.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>at.flush())),xe=(0,i.combinedAppender)(at,xe)}Xe=new a.TelemetryService({appender:xe,commonProperties:(0,n.resolveCommonProperties)(We,(0,k.release)(),(0,k.hostname)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,ft),sendErrorTelemetry:!0,piiPaths:[qe,rt]},Ve)}else Xe=i.NullTelemetryService,xe=i.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(xe)),de.set(t.ITelemetryService,Xe);const ht=new be.CustomEndpointTelemetryService(Ve,Xe);return de.set(t.ICustomEndpointTelemetryService,ht),de.set(p.IExtensionManagementService,new R.SyncDescriptor(w.ExtensionManagementService)),de.set(p.IExtensionGalleryService,new R.SyncDescriptor(C.ExtensionGalleryService)),de.set(p.IExtensionTipsService,new R.SyncDescriptor(Ne.ExtensionTipsService)),de.set(h.ILocalizationsService,new R.SyncDescriptor(E.LocalizationsService)),de.set(I.IDiagnosticsService,new R.SyncDescriptor(z.DiagnosticsService)),de.set(Ue.IUserDataSyncAccountService,new R.SyncDescriptor(Ue.UserDataSyncAccountService)),de.set(J.IUserDataSyncLogService,new R.SyncDescriptor(ue.UserDataSyncLogService)),de.set(J.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",qe=>qe.ctx!=="main"))),de.set(p.IGlobalExtensionEnablementService,new R.SyncDescriptor(Oe.GlobalExtensionEnablementService)),de.set(X.IIgnoredExtensionsManagementService,new R.SyncDescriptor(X.IgnoredExtensionsManagementService)),de.set(re.IExtensionsStorageSyncService,new R.SyncDescriptor(re.ExtensionsStorageSyncService)),de.set(J.IUserDataSyncStoreManagementService,new R.SyncDescriptor(ne.UserDataSyncStoreManagementService)),de.set(J.IUserDataSyncStoreService,new R.SyncDescriptor(ne.UserDataSyncStoreService)),de.set(De.IUserDataSyncMachinesService,new R.SyncDescriptor(De.UserDataSyncMachinesService)),de.set(J.IUserDataSyncBackupStoreService,new R.SyncDescriptor(ke.UserDataSyncBackupStoreService)),de.set(J.IUserDataAutoSyncEnablementService,new R.SyncDescriptor(ze.UserDataAutoSyncEnablementService)),de.set(J.IUserDataSyncResourceEnablementService,new R.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),de.set(J.IUserDataSyncService,new R.SyncDescriptor(Q.UserDataSyncService)),de.set(fe.ILocalPtyService,this._register(new le.PtyHostService(Be,Xe))),new g.InstantiationService(de)}initChannels(de){const Le=new c.ExtensionManagementChannel(de.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const _e=m.ProxyChannel.fromService(de.get(h.ILocalizationsService));this.server.registerChannel("localizations",_e);const Fe=m.ProxyChannel.fromService(de.get(I.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new c.ExtensionTipsChannel(de.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const Ze=m.ProxyChannel.fromService(de.get(Se.IChecksumService));this.server.registerChannel("checksum",Ze);const Ye=new ie.UserDataSyncMachinesServiceChannel(de.get(De.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ye);const tt=m.ProxyChannel.fromService(de.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",tt);const Be=new ie.UserDataSyncAccountServiceChannel(de.get(Ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const We=new ie.UserDataSyncStoreManagementServiceChannel(de.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const it=new ve.UserDataSyncChannel(de.get(J.IUserDataSyncService),de.get(u.ILogService));this.server.registerChannel("userDataSync",it);const Ve=this._register(de.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Je=new ie.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",Je);const et=de.get(fe.ILocalPtyService),nt=m.ProxyChannel.fromService(et);this.server.registerChannel(ae.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(de){window.addEventListener("unhandledrejection",Le=>{(0,te.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,te.setUnexpectedErrorHandler)(Le=>{const _e=(0,oe.toErrorMessage)(Le,!0);!_e||de.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function Ce(Re){const de=new pe(Re);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await de.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/19cda32aafccb88db45622e7ae9be90cb71c9744/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
